/*******************************************************************************
* FILE NAME: ibhandle.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in ibhandle.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C"
{
  #include <iwindefs.h>
  #include <malloc.h>
}

#include <ibhandle.hpp>
#include <istring.hpp>
#include <istream.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IBHANDLE_CPP_
  #include <ipagetun.h>
#endif

IString IHandle :: asString ( ) const
{
  return IString( (unsigned long)this->handle );
}

IString IHandle :: asDebugInfo ( ) const
{
  IString result( "IHandle(" );
  result += this->Inherited::asDebugInfo();
  result += ",handle=";
  result += this->asString();
  result += ")";
  return result;
}

ostream &operator << ( ostream &aStream, const IHandle &aHandle )
{
  return aStream << aHandle.asString();
}

