/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/
#include <iexctxt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)
#include <string.h>
#pragma SOMAsDefault (pop)

static const char
  *defaultMsgFile = "cppwoc3u.msg";

ICollectionExceptionText::ICollectionExceptionText (unsigned long resid)
{
  const char *pMsgFileName;
  pMsgFileName = defaultMsgFile;

  ivMsgTxt = new IMessageText (resid, pMsgFileName);

  if (ivMsgTxt != 0)
  {
    switch (resid)
    {
      case IC_CHILD_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("child already exists");
        break;
      case IC_COLLECTION_IS_EMPTY:
        ivMsgTxt->setDefaultText ("collection is empty");
        break;
      case IC_CURSOR_NOT_CONTAINED:
        ivMsgTxt->setDefaultText ("cursor not contained in collection");
        break;
      case  IC_CURSOR_NOT_FOR_GIVEN:
        ivMsgTxt->setDefaultText ("cursor not for given collection");
        break;
      case  IC_CURSOR_NOT_FOR_THIS:
        ivMsgTxt->setDefaultText ("cursor not for this collection");
        break;
      case  IC_IDENTICAL_COLLECTION:
        ivMsgTxt->setDefaultText ("identical collection");
        break;
      case IC_INVALID_CURSOR:
        ivMsgTxt->setDefaultText ("invalid cursor");
        break;
      case IC_INVALID_POSITION:
        ivMsgTxt->setDefaultText ("invalid position");
        break;
      case IC_INVALID_REPLACEMENT:
        ivMsgTxt->setDefaultText ("invalid replacement");
        break;
      case IC_KEY_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("key already exists");
        break;
      case IC_KEY_NOT_CONTAINED:
        ivMsgTxt->setDefaultText ("key not contained");
        break;
      case IC_NOT_BOUNDED:
        ivMsgTxt->setDefaultText ("collection is unbounded");
        break;
      case IC_ROOT_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("root already exists");
        break;
      case IC_CYCLIC_CHILD_ATTACHMENT:
        ivMsgTxt->setDefaultText ("cyclic child attachment");
        break;
      case IC_OUT_OF_COLLECTION_MEMORY:
        ivMsgTxt->setDefaultText ("out of collection memory");
        break;
      default:
        ivMsgTxt->setDefaultText ("unknown exception text");
    }
  }
}

#pragma pack ()
#pragma info (restore)
