/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIAMAP_H
#define _IIAMAP_H

#include <iiacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

class IAMapImpl : public IACollectionImpl {
public:

          ~IAMapImpl
                            ();

  virtual
  void     Antivalence      (IAMapImpl const&);

  virtual
  void     AddAntivalence   (IAMapImpl const&,
                             IAMapImpl const&); 

  virtual
  void     AddDifference    (IAMapImpl const&,
                             IAMapImpl const&); 

  virtual
  void     AddIntersection  (IAMapImpl const&,
                             IAMapImpl const&);

  virtual
  void     AddUnion         (IAMapImpl const&,
                             IAMapImpl const&);

  virtual
  void     Difference       (IAMapImpl const&);

  virtual
  void     Intersection     (IAMapImpl const&);

  virtual
  void     Union            (IAMapImpl const&);

  virtual
  IBoolean operator==       (IAMapImpl const&) const = 0;

  IBoolean operator!=       (IAMapImpl const&) const;

protected:

           IAMapImpl
                            (Ops&);

  IBoolean LocateNext       (void const*, ICursorImpl&) const;

  IBoolean LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  IBoolean SetToNextWithDifferentKey
                            (ICursorImpl&) const;

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IAMapImpl const&),\
           AddAntivalence   (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddDifference    (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddIntersection  (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddUnion         (IAMapImpl const&,\
                             IAMapImpl const&),\
           Difference       (IAMapImpl const&),\
           Intersection     (IAMapImpl const&),\
           Union            (IAMapImpl const&),\
           operator==       (IAMapImpl const&) const,\
           operator!=       (IAMapImpl const&) const,\
           IAMapImpl\
                            (Ops&)\
                        )
#endif

};

#pragma SOMAsDefault (pop)

#pragma info (restore)
#pragma pack ()

#endif
