/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <iiexc.h>

// --------------------------
// IAKeyBagAsHshTableNodeImpl
// --------------------------

// public members

inline
IAKeyBagAsHshTableNodeImpl::
IAKeyBagAsHshTableNodeImpl ()
: ivNext (0)
{
}

// -------------------------
// IKeyBagAsHshTableNodeImpl
// -------------------------

// public members

template <class Element>
inline
IKeyBagAsHshTableNodeImpl <Element>::
IKeyBagAsHshTableNodeImpl (Element const& element)
: IAKeyBagAsHshTableNodeImpl (), ivElement (element)
{
}

template <class Element>
inline
IKeyBagAsHshTableNodeImpl <Element>::
~IKeyBagAsHshTableNodeImpl ()
{
}

// ---------------------------
// IKeyBagAsHshTableCursorImpl
// ---------------------------

// public members

inline void
IKeyBagAsHshTableCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline IBoolean
IKeyBagAsHshTableCursorImpl::
IsInBetween () const
{ return false;
}

inline IBoolean
IKeyBagAsHshTableCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline void
IKeyBagAsHshTableCursorImpl::
operator= (IKeyBagAsHshTableCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode   = cursor.ivNode;
  ivBucket = cursor.ivBucket;
}

inline IBoolean
IKeyBagAsHshTableCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode   == ((Self const&)cursor).ivNode &&
          ivBucket == ((Self const&)cursor).ivBucket);
}



// ---------------------
// IKeyBagAsHshTableImpl
// ---------------------

// public members

#if defined (__LIB_BUILD__)

#if ! defined (__2nd_LEVEL__)
#define inline
#endif

inline char const*
IKeyBagAsHshTableImpl::
ClassName () const
{ return cvClassName;
}

inline IBoolean
IKeyBagAsHshTableImpl::
ContainsElementWithKey (void const* key) const
{ return Self::LocateElementWithKey (key, CursorOf (*this));
}

inline void*
IKeyBagAsHshTableImpl::
ElementAt (ICursorImpl const& cursor) const
{ IASSERT (NodeOf (cursor) != 0);
  return ElementOf (NodeOf (cursor));
}

inline IBoolean
IKeyBagAsHshTableImpl::
IsBounded () const
{ return false;
}

inline IBoolean
IKeyBagAsHshTableImpl::
IsConsistent () const
{ return true;
}

inline IBoolean
IKeyBagAsHshTableImpl::
IsEmpty () const
{ return (ivNumberOfElements == 0);
}

inline IBoolean
IKeyBagAsHshTableImpl::
IsFull () const
{ return false;
}

inline void*
IKeyBagAsHshTableImpl::
Key (void const* element) const
{ return OpsOf (*this).Key (element);
}

inline INumber
IKeyBagAsHshTableImpl::
NumberOfElements () const
{ return ivNumberOfElements;
}

inline void
IKeyBagAsHshTableImpl::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ IASSERT (NodeOf (cursor) != 0);
  Assign (Self::ElementAt (cursor), element);
}

#if ! defined (__2nd_LEVEL__)
#undef inline
#endif

// protected members

inline void
IKeyBagAsHshTableImpl::
Assign (void* element1, void const* element2) const
{ OpsOf (*this).Assign (element1, element2);
}

inline void*
IKeyBagAsHshTableImpl::
CreateNode (void const* element) const
{ return OpsOf (*this).CreateNode (element);
}

inline void*
IKeyBagAsHshTableImpl::
CreateNodes (INumber n) const
{ return OpsOf (*this).CreateNodes (n);
}

inline void
IKeyBagAsHshTableImpl::
DeleteNode (void* node) const
{ OpsOf (*this).DeleteNode (node);
}

inline void
IKeyBagAsHshTableImpl::
DeleteNodes (void* nodes) const
{ OpsOf (*this).DeleteNodes (nodes);
}

inline IBoolean
IKeyBagAsHshTableImpl::
EqualKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return OpsOf (*this).EqualKeys (arg1, arg2, argType);
}

inline unsigned long
IKeyBagAsHshTableImpl::
HashKey (void const* arg, unsigned long h, IArgType argType) const
{ return OpsOf (*this).HashKey (arg, h, argType);
}

inline void*
IKeyBagAsHshTableImpl::
StreamIn (TStream& fromWhere) const
{ return OpsOf (*this).StreamIn (fromWhere);
}

inline void
IKeyBagAsHshTableImpl::
StreamOut (void const* element, TStream& fromWhere) const
{ OpsOf (*this).StreamOut (element, fromWhere);
}

// private members

inline INumber&
IKeyBagAsHshTableImpl::
BucketOf (ICursorImpl const& cursor)
{ return ((Cursor&)cursor).ivBucket;
}

inline void*
IKeyBagAsHshTableImpl::
ElementOf (Node const* node) const
{ typedef IKeyBagAsHshTableNodeImpl <long> TypedNode;
  return (OpsOf (*this).ivContainsDTSObjects ?
    (void*) ((TypedNode const*)node)->ivElement :
    (void*)&((TypedNode const*)node)->ivElement);
}

inline IBoolean
IKeyBagAsHshTableImpl::
IsInBetween (ICursorImpl const& cursor)
{
  return false;
}

inline IKeyBagAsHshTableImpl::Node*&
IKeyBagAsHshTableImpl::
NodeOf (ICursorImpl const& cursor)
{ return ((Cursor&)cursor).ivNode;
}

inline INumber&
IKeyBagAsHshTableImpl::
NextBucketOf (ICursorImpl const& cursor)
{
  return ((Cursor&)cursor).ivBucket; // just a dummy
}

inline IKeyBagAsHshTableImpl::Node*&
IKeyBagAsHshTableImpl::
NextNodeOf (ICursorImpl const& cursor)
{
  return ((Cursor&)cursor).ivNode; // just a dummy
}

inline IKeyBagAsHshTableImpl::Ops&
IKeyBagAsHshTableImpl::
OpsOf (IKeyBagAsHshTableImpl const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

#endif

// ---------------------
// IAKeyBagAsHshTableOps
// ---------------------

// public members

inline
IAKeyBagAsHshTableOps::
~IAKeyBagAsHshTableOps ()
{
}

// protected members

inline
IAKeyBagAsHshTableOps::
IAKeyBagAsHshTableOps (IBoolean containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}
