/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

// ---------------------------
// IKeySortedBagOnSequenceImpl
// ---------------------------

// public members

#if defined (__LIB_BUILD__)

#if ! defined (__2nd_LEVEL__)
#define inline
#endif

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return (CompareKeys
    (Self::ElementAt (cursor), element, kElementElement) == 0);
}

template <class Base>
inline char const*
IKeySortedBagOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return LocateKey (key, CursorOf (*this));
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Key (void const* element) const
{ return OpsOf (*this).Key (element);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
inline IPosition
IKeySortedBagOnSequenceImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAllElementsWithKey (void const* key)
{ ivKey = key;
  return RemoveAll (Predicate::IsEqual, this);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
inline IBoolean
IKeySortedBagOnSequenceImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

template <class Base>
inline TStream&
IKeySortedBagOnSequenceImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= OpsOf (*this) <<= fromWhere);
}

template <class Base>
inline TStream&
IKeySortedBagOnSequenceImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= OpsOf (*this) >>= toWhere);
}

#if ! defined (__2nd_LEVEL__)
#undef inline
#endif

#endif

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
operator= (IKeySortedBagOnSequenceImpl <Base> const& collection)
{ BaseOf (*this).Base::operator= (BaseOf (collection));
}

#if defined (__LIB_BUILD__)
// protected members

template <class Base>
inline long
IKeySortedBagOnSequenceImpl <Base>::
CompareKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return OpsOf (*this).CompareKeys (arg1, arg2, argType);
}

// private members

template <class Base>
inline Base&
IKeySortedBagOnSequenceImpl <Base>::
BaseOf (IKeySortedBagOnSequenceImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline IKeySortedBagOnSequenceImpl <Base>::Ops&
IKeySortedBagOnSequenceImpl <Base>::
OpsOf (IKeySortedBagOnSequenceImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}
#endif

// ---------------------------
// IAKeySortedBagOnSequenceOps
// ---------------------------

// public members

template <class Base>
inline
IAKeySortedBagOnSequenceOps <Base>::
~IAKeySortedBagOnSequenceOps ()
{
}
