/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// ----------------------------
// ISortedSetOnKeySortedSetImpl
// ----------------------------

// public members

template <class Base>
ISortedSetOnKeySortedSetImpl <Base>::
ISortedSetOnKeySortedSetImpl (Ops& ops, INumber)
: IASortedSetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedSetOnKeySortedSetImpl <Base>::
ISortedSetOnKeySortedSetImpl
  (Ops& ops, ISortedSetOnKeySortedSetImpl <Base> const&)
: IASortedSetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedSetOnKeySortedSetImpl <Base>::
~ISortedSetOnKeySortedSetImpl ()
{
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& ss = (Self const&)collection;
    BaseOf (*this).Base::AddAllFrom (BaseOf (ss));
  }
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISortedSetOnKeySortedSetImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISortedSetOnKeySortedSetImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISortedSetOnKeySortedSetImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
Contains (void const* element) const
{ return BaseOf (*this).ContainsElementWithKey (element);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& ss = (Self const&)collection;
    return BaseOf (*this).Base::ContainsAllKeysFrom (BaseOf (ss));
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
ISortedSetOnKeySortedSetImpl <Base>::Cursor*
ISortedSetOnKeySortedSetImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
ISortedSetOnKeySortedSetImpl <Base>::MngCursor*
ISortedSetOnKeySortedSetImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISortedSetOnKeySortedSetImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
ISortedSetOnKeySortedSetImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
void*
ISortedSetOnKeySortedSetImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
void*
ISortedSetOnKeySortedSetImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (element, cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).
    Base::LocateNextElementWithKey (element, cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISortedSetOnKeySortedSetImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
IPosition
ISortedSetOnKeySortedSetImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
Remove (void const* element)
{ return BaseOf (*this).Base::RemoveElementWithKey (element);
}

template <class Base>
INumber
ISortedSetOnKeySortedSetImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISortedSetOnKeySortedSetImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
void
ISortedSetOnKeySortedSetImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

template <class Base>
IBoolean
ISortedSetOnKeySortedSetImpl <Base>::
operator== (IASortedSetImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          Self::ContainsAllFrom (collection));
}

template <class Base>
TStream&
ISortedSetOnKeySortedSetImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= fromWhere);
}

template <class Base>
TStream&
ISortedSetOnKeySortedSetImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= toWhere);
}

#pragma info (restore)
#pragma pack ()
