/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <iivcllct.h>
#include <inotifev.hpp>

#include <ibcllct.h> // bad, bad !!

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

INotificationId const IVCollectionImpl::addId =
     "IVCollectionImpl::addId";

INotificationId const IVCollectionImpl::modifyId =
     "IVCollectionImpl::modifyId";

INotificationId const IVCollectionImpl::removeId =
     "IVCollectionImpl::removeId";

INotificationId const IVCollectionImpl::replaceId =
     "IVCollectionImpl::replaceId";

INotificationId const IVCollectionImpl::addedId =
      IVCollectionImpl::addId;

INotificationId const IVCollectionImpl::modifiedId =
      IVCollectionImpl::modifyId;

INotificationId const IVCollectionImpl::removedId =
      IVCollectionImpl::removeId;

INotificationId const IVCollectionImpl::replacedId =
     "IVCollectionImpl::replaceId";


// ----------------
// IVCollectionImpl
// ----------------

// public members

IVCollectionImpl::
IVCollectionImpl ()
{
}

// protected members

IVCollectionImpl::
~IVCollectionImpl ()
{
}

void
IVCollectionImpl::
NotifyOfAddAt (ICursorImpl const& cursor)
{
  //-----------------------------------------------------
  // DEFECT 9119 :
  // Use local cursor, as default cursor is often passed,
  // and is also used for comparison in cursor methods.
  // IF DEFAULT CURSOR WAS USED, !!MUST!! CLONE IT,
  //  OR COULD BE USING A BAD CURSOR POSITION FOR NOTIFY.
  //-----------------------------------------------------
  ICursorImpl* pLocalCursor = cursor.Clone();
  
  ICursor c ((ICursorImpl*)pLocalCursor);
  IVCollectionEventData <void> d (c);
  INotificationEvent event (addId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!
  
  delete pLocalCursor;
  //-----------------------------------------------------
}

void
IVCollectionImpl::
NotifyOfModification ()
{ INotificationEvent event (modifyId, *this);
  notifyObservers (event);
}

void
IVCollectionImpl ::
NotifyOfRemoveAt (ICursorImpl const& cursor)
{ ICursor c ((ICursorImpl*)&cursor);
  IVCollectionEventData <void> d (c);
  INotificationEvent event (removeId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!
}

void
IVCollectionImpl ::
NotifyOfReplaceAt (ICursorImpl const& cursor, void const* element)
{ ICursor c ((ICursorImpl*)&cursor);
  IVCollectionEventData <void> d (c, element);
  INotificationEvent event (replaceId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!
}

#pragma info (restore)
#pragma pack ()

