#ifdef __MVS__
                   ??=ifdef __COMPILER_VER__
                     ??=pragma filetag("IBM-1047")
                   ??=endif
                   #pragma nomargins nosequence
                   #pragma checkout(suspend)
#endif

#ifndef _IMSGTEXT_
#define _IMSGTEXT_
/*******************************************************************************
* FILE NAME: imsgtext.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMsgtext                                                                 *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#ifdef __IBMCPP__
#pragma info (none)
#pragma pack (4)
#endif


#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma map ( operator&(const char*,const IString&)        , "@@CLBA10")
#pragma map ( operator^(const char*,const IString&)        , "@@CLBA11")
#pragma map ( operator|(const char*,const IString&)        , "@@CLBA12")
#pragma map ( operator+(const char*,const IString&)        , "@@CLBA13")

#pragma map ( operator<<(const IString&,unsigned long)     , "@@CLBA20")

#pragma map ( operator<<(ostream&,const IBase&)            , "@@CLBA30")
#pragma map ( operator<<(ostream&,const IDate&)            , "@@CLBA31")
#pragma map ( operator<<(ostream&,const ITime&)            , "@@CLBA32")
#pragma map ( operator<<(ostream&,const IVBase&)           , "@@CLBA33")
#pragma map ( operator<<(ostream&,const IString&)          , "@@CLBA34")

#pragma map ( operator>>(const IString&,char)              , "@@CLBA40")
#pragma map ( operator>>(const IString&,int)               , "@@CLBA41")
#pragma map ( operator>>(const IString&,const char*)       , "@@CLBA42")

#pragma map ( operator>>(const IString&,IStringParser::Command) , "@@CLBA50")
#pragma map ( operator>>(const IString&,const IStringParser::SkipWords&)  \
      , "@@CLBA51")

#pragma map ( operator>>(const IString&,const IStringTest&) , "@@CLBA60")
#pragma map ( operator>>(const IString&,IString&)           , "@@CLBA61")
#pragma map ( operator>>(const IString&,const IString&)     , "@@CLBA62")
#pragma map ( operator>>(const IString&,unsigned long)      , "@@CLBA63")
#pragma map ( operator>>(istream&,IString&)                 , "@@CLBA64")
#pragma map ( IExcept__assertParameter   , "@@CLBA70")
#pragma map ( IExcept__assertState       , "@@CLBA71")
#pragma map ( IExcept__throwError        , "@@CLBA72")
#pragma map ( IExcept__throwLibraryError , "@@CLBA73")
#endif
#endif


class IMessageText {
public:
/*----------------------------- Constructors ---------------------------------*/
  IMessageText  ( unsigned long messageId,
                  const char*   messageFileName,
                  const char*   textInsert1 = 0,
                  const char*   textInsert2 = 0,
                  const char*   textInsert3 = 0,
                  const char*   textInsert4 = 0,
                  const char*   textInsert5 = 0,
                  const char*   textInsert6 = 0,
                  const char*   textInsert7 = 0,
                  const char*   textInsert8 = 0,
                  const char*   textInsert9 = 0 );

  IMessageText ( const IMessageText& text );

  ~IMessageText ( );

/*-------------------------------- Accessors ---------------------------------*/
  operator const char*  () const;

const char*
  text ( ) const;

IMessageText
 &setDefaultText ( const char*         text ),
 &operator=      ( const IMessageText& text );

private:
/*--------------------------------- Private ----------------------------------*/

char
 *pClText;
int
  bClSuccess;

#if defined (_AIX)  || defined (__MVS__)
  char*
    replaceVars (const char* varText,
                 char* insertTable[],
                 unsigned long tableEntries);
#endif


#ifdef __MVS__
int
  readMessageFromFile  (char*          messageText,
                        const char*    messageFileName,
                        unsigned long  messageId);
#endif


#if defined (__SOM_ENABLED__ ) && defined (__RRBC_LIB__)

#pragma SOMClassVersion  (*, 3, 0)

#ifdef __OS2__
#pragma SOMReleaseOrder( \
/*   1 */       IMessageText(unsigned long,const char*,const char*, \
                             const char*,const char*,const char*,   \
                             const char*,const char*,const char*,   \
                             const char*,const char*),\
/*   2 */       operator const char*() const,\
/*   3 */       text() const,\
/*   4 */       setDefaultText(const char*),\
/*   5 */       operator=(const IMessageText&))
#endif

#ifdef _AIX
#pragma SOMReleaseOrder( \
/*   1 */       IMessageText(unsigned long,const char*,const char*, \
                             const char*,const char*,const char*,   \
                             const char*,const char*,const char*,   \
                             const char*,const char*),\
/*   2 */       operator const char*() const,\
/*   3 */       text() const,\
/*   4 */       setDefaultText(const char*),\
/*   5 */       operator=(const IMessageText&), \
/*   6 */       replaceVars(const char*,char**,unsigned long))
#endif

#ifdef __MVS__
#pragma SOMReleaseOrder( \
/*   1 */       IMessageText(unsigned long,const char*,const char*, \
                             const char*,const char*,const char*,   \
                             const char*,const char*,const char*,   \
                             const char*,const char*),\
/*   2 */       operator const char*() const,\
/*   3 */       text() const,\
/*   4 */       setDefaultText(const char*),\
/*   5 */       operator=(const IMessageText&), \
/*   6 */       replaceVars(const char*,char**,unsigned long),\
/*   7 */       readMessageFromFile(char*,const char*,unsigned long))
#endif


#endif    // SOM_ENABLED & RRBC_LIB

}; // IMessageText


#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#ifdef __IBMCPP__
#pragma info (restore)
#pragma pack ()
#endif

#endif // _IMSGTEXT_

#ifdef __MVS__
                   #pragma checkout(resume)
#endif

