#ifdef __MVS__
                   ??=ifdef __COMPILER_VER__
                     ??=pragma filetag("IBM-1047")
                   ??=endif
                   #pragma nomargins nosequence
                   #pragma checkout(suspend)
#endif


#ifndef _ISTPARSE_
#define _ISTPARSE_
/*******************************************************************************
* FILE NAME: istparse.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IStringParser                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>


#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

class IString;
class IStringTest;
class IStringParserData;

class IStringParser : public IBase {
typedef IBase
  Inherited;
public:

/*------------------------- Constructors -------------------------------------*/
 ~IStringParser ( );

/*------------------------- Commands -----------------------------------------*/
enum Command {
  reset,
  skipWord
};

class SkipWords : public IBase {
public:
  SkipWords     ( unsigned long numberOfWords = 1 );
unsigned long
  numberOfWords ( ) const;
private:
unsigned long
  fNumSkip;

#if defined (__SOM_ENABLED__ ) && defined (__RRBC_LIB__)

#pragma SOMClassVersion  (*, 3, 0)

#pragma SOMReleaseOrder( \
/*   1 */       SkipWords(unsigned long),\
/*   2 */       numberOfWords() const)
/*   3 */  /*   numWords() const - obsolete function removed */

#endif    // SOM_ENABLED & RRBC_LIB

};

IStringParser
 &operator >>   ( Command          command ),
 &operator >>   ( const SkipWords& skipObject );

/*------------------------- Initialize ---------------------------------------*/
friend IStringParser
  operator >>   ( const IString& text,
                        IString& token );

friend IStringParser
  operator >>   ( const IString& text,
                  const IString& pattern );
friend IStringParser
  operator >>   ( const IString& text,
                  const char*    pattern );

friend IStringParser
  operator >>   ( const IString& text,
                  char           pattern );

friend IStringParser
  operator >>   ( const IString& text,
                  unsigned long  position );
friend IStringParser
  operator >>   ( const IString& text,
                  int            position );

friend IStringParser
  operator <<   ( const IString& text,
                  unsigned long  position );

friend IStringParser
  operator >>   ( const IString&     text,
                  const IStringTest& test );

friend IStringParser
  operator >>   ( const IString&         text,
                  IStringParser::Command command );

friend IStringParser
  operator >>   ( const IString&                  text,
                  const IStringParser::SkipWords& skipObject );

/*------------------------- Tokenizing ---------------------------------------*/
IStringParser
 &operator >>   ( IString& token );

/*------------------------- Pattern Matching ---------------------------------*/
IStringParser
 &operator >>   ( const IString&     pattern ),
 &operator >>   ( const char*        pattern ),
 &operator >>   ( char               pattern ),
 &operator >>   ( const IStringTest& test );

/*----------------------- Relative Column Positioning ------------------------*/
IStringParser
 &operator >>   ( int           delta ),
 &operator >>   ( unsigned long delta );

/*----------------------- Absolute Column Positioning ------------------------*/
IStringParser
 &operator <<   ( unsigned long position );


protected:
/*------------------------- Protected Constructors ---------------------------*/
  IStringParser ( const IString&       text );
  IStringParser ( const IStringParser& parser );


/*------------------------- Private ------------------------------------------*/
private:
IStringParserData
 *fData;


#if defined (__SOM_ENABLED__ ) && defined (__RRBC_LIB__)

#pragma SOMClassVersion  (*, 3, 0)

#pragma SOMReleaseOrder( \
/*   1 */       operator>>(Command),\
/*   2 */       operator>>(const SkipWords&),\
/*   3 */       operator>>(IString&),\
/*   4 */       operator>>(const IString&),\
/*   5 */       operator>>(const char*),\
/*   6 */       operator>>(char),\
/*   7 */       operator>>(const IStringTest&),\
/*   8 */       operator>>(int),\
/*   9 */       operator>>(unsigned long),\
/*  10 */       operator<<(unsigned long),\
/*  11 */       IStringParser(const IString&))


#endif    // SOM_ENABLED & RRBC_LIB


}; // class IStringParser


#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#endif // _ISTPARSE_

#ifdef __MVS__
                   #pragma checkout(resume)
#endif

