/* NOSHIP */
#ifndef _ITYPTABM_
#define _ITYPTABM_
/*******************************************************************************
* FILE NAME: ityptabm.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     ITypeTableMap                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
* ADDITONAL COPYRIGHTS:                                                        *
*  Copyright (C) 1996, Taligent, Inc. All rights reserved.                     *
*  Copyright (C) 1996, Lotus Development Corporation. All Rights Reserved.     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>

#pragma pack(4)


class ITypeTableMap {
public:
                    ITypeTableMap(const IString& key, void* data);   // 7810
                    ITypeTableMap(const ITypeTableMap& copy);        // 7810
                    ~ITypeTableMap();                                // 7810
    IBoolean        operator==(const ITypeTableMap& k) const
                    { return  (fKey == k.fKey) && (fData == k.fData); }
    const IString&  GetKey() const { return fKey; }
    void*           GetData() const { return fData; }

private:
    IString         fKey;
    void*           fData;
};

ITypeTableMap::ITypeTableMap(const IString& key, void* data)    // 7810
                    : fKey(key), fData(data)
{
}

ITypeTableMap::ITypeTableMap(const ITypeTableMap& copy)         // 7810
                    : fKey(copy.fKey), fData(copy.fData)
{
   // note: added explicit copy constructor, but didn't 
   //       over-ride the default shallow-copy behavior...
}

ITypeTableMap::~ITypeTableMap()                                 // 7810
{
}

inline IString const& key(ITypeTableMap const& a) { return  a.GetKey(); }

inline unsigned long hash(IString const& key, unsigned long range)
{
    return  hash((const char*) key, range);
}

#pragma pack()

#endif // _ITYPTABM_
