/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswBase
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *
 *    CAswBase class declaration.  CAswBase supports:
 *       *  Setup and Shutdown methods (for production builds)
 *       *  Reference Holder auxiliary functions.
 *       *  Access to classes CAswDebugBase and CAswCtlBase via inheritance.
 *
 *****************************************************************************/

#ifndef ASBASE_H
#define ASBASE_H
#include <aspack.h>
class ASWPUBCLASS CAswBase : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswBase( PASWCONTROL pControl, BOOL fAddToList = TRUE );
   virtual ASWPUBMETHOD ~CAswBase(void);
   CAswResult ASWPUBMETHOD Setup(void);
   virtual CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE);
   virtual CAswResult ASWPUBMETHOD GetRefHolder( PPASWREFHOLDER ppRefHolder );
   virtual ASWREFIID ASWPUBMETHOD GetPreferredIID( void ) const;
   virtual CAswResult ASWPUBMETHOD Bind( PASWREFHOLDER prhHolderToQuery,
                            BOOL bQueryNeeded = TRUE );
   virtual CAswResult ASWPUBMETHOD Bind( PASWBASE pBaseToQuery,
                            BOOL bQueryNeeded = TRUE );
   virtual void ASWPUBMETHOD Unbind( void );
   virtual CAswResult ASWPUBMETHOD BindGivenInterface( LPUNKNOWN pInterface );
   virtual CAswResult ASWPUBMETHOD BindReturnedInterface( LPUNKNOWN pInterface);
   virtual CAswResult ASWPUBMETHOD BindWithQuery( LPUNKNOWN pInterface );
   virtual BOOL ASWPUBMETHOD IsShutdownOK(void);
   virtual void ASWPUBMETHOD ShutdownStateChange(BOOL fShutdownOK);
   virtual PASWSHUTDOWN ASWPUBMETHOD GetShutdownObject(void);
   virtual PASWBASE ASWPUBMETHOD GetParentObject(void);
   inline void DoShutdownProcessing( BOOL bInProgress )
   {
      PASWSHUTDOWN ps = GetShutdownObject();
      if ( ps )
         ps->SetInProgress( bInProgress );
   }
#ifdef ASWOCX
   CAswResult ASWPUBMETHOD GetIIDbyFlags( LPIID riid, int flags );
   CAswResult ASWPUBMETHOD AddConnection( PASWCONNMGR pConnection );
   CAswResult ASWPUBMETHOD RemoveConnection( PASWCONNMGR pConnection );
   CAswResult ASWPUBMETHOD ReleaseAllConnections( void );
   CAswResult ASWPUBMETHOD OnPropertyChanged( DISPID dispid );
   CAswResult ASWPUBMETHOD OnRequestEdit( DISPID dispid );
   CAswResult ASWPUBMETHOD InvokeAmbientProperty( DISPID dispidMember,
      REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS __RPC_FAR *pdispparams,
      VARIANT __RPC_FAR *pvarResult, EXCEPINFO __RPC_FAR *pexcepinfo,
      UINT __RPC_FAR *puArgErr);
   LPCONNECTIONPOINTCONTAINER GetConnectionPointContainer(void);
#endif 
private:
#ifdef ASWOCX
   PASWREFHOLDER ASWPUBMETHOD GetConnectionPointContainerRH( void );
#endif 
   CAswBase( const CAswBase & SourceObject );
   void operator= ( const CAswBase & SourceObject );
};
#include <aspop.h>
#endif 
