/* NOSHIP */
/*****************************************************************************
 *
 * ascont.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswContainer
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#ifndef ASWAN_ASCONT_H
#define ASWAN_ASCONT_H
#include <aspack.h>
typedef enum tagASWLINKSTRINGID
{
   ASWLINKSTRINGID_CANTUPDATELINK = 0
}
   ASWLINKSTRINGID;
class ASWPUBCLASS CAswContainer : public CAswBase
{
public:
   ASWPUBMETHOD CAswContainer( PASWCONTROL pAswControl,
                               LPUNKNOWN   lpUnknownOuter = NULL );
   ASWPUBMETHOD ~CAswContainer();
   CAswResult ASWPUBMETHOD Setup( PASWCONTAINERUNDO   pAswContainerUndo = NULL,
                                  BOOL                fContainerSupportsInplace = TRUE,
                                  PASWOBJECTINSTANCE  pObjectInstance = NULL,
                                  PASWUILINKCONTAINER pLinkContainer = NULL );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   CAswResult ASWPUBMETHOD CloseAllObjects( DWORD dwSaveOption );
   CAswResult ASWPUBMETHOD IsAnyObjectDirty( void );
   CAswResult ASWPUBMETHOD UpdateObjects( void );
   CAswResult ASWPUBMETHOD AreObjectsUpToDate( void );
   void ASWPUBMETHOD NotifyObjectsOfRename( LPMONIKER pmk );
   void ASWPUBMETHOD NotifyObjectsOfDocRename( LPASWCOLESTR pszDocumentName );
   void ASWPUBMETHOD SetInplaceSupported(BOOL fContainerSupportsInplace);
   BOOL ASWPUBMETHOD GetInplaceSupported(void);
   LPASWCOLESTR ASWPUBMETHOD GetDocumentName(void);
   void ASWPUBMETHOD SetDocumentName(LPASWCOLESTR pszDocumentName);
   CAswResult ASWPUBMETHOD SetFileName(LPASWCOLESTR pszFileName);
   LPASWCOLESTR ASWPUBMETHOD GetFileName(void);
   CAswResult ASWPUBMETHOD GetRelativeMoniker(DWORD             dwAssign,
                                              LPMONIKER ASWPTR* ppmk);
   CAswResult ASWPUBMETHOD GetFullMoniker(DWORD              dwAssign,
                                          LPMONIKER ASWPTR*  ppmk);
   CAswResult ASWPUBMETHOD SetMoniker(DWORD dwWhichMoniker, LPMONIKER pmk);
   CAswResult ASWPUBMETHOD UpdateAllLinks( void );
   CAswResult ASWPUBMETHOD UpdateAutomaticLinks( HWND   hWndParent,
                                                 LPASWCOLESTR lpszDialogTitle );
   CAswResult ASWPUBMETHOD BindAllLinksIfSrcRunning(void);
   virtual BOOL ASWPUBMETHOD ContinueBindingLinks(void);
   inline void AddObject( PASWCONTAINEDOBJECT pCO )
   {
      m_lhListOfContainedObjects.Insert( pCO );
      m_pNextBindToProcess = NULL;
   }
   inline void RemoveObject( PASWCONTAINEDOBJECT pCO )
   {
      m_lhListOfContainedObjects.Remove( pCO );
      m_pNextBindToProcess = NULL;
   }
   inline PASWCONTAINEDOBJECT GetFirstObject( void )
   {
      return ( m_lhListOfContainedObjects.GetFirst() );
   }
   inline PASWCONTAINEDOBJECT GetNextObject( void )
   {
      return ( m_lhListOfContainedObjects.GetNext() );
   }
   inline PASWUILINKCONTAINER GetUILinkContainer ( void )
   {
      return ( m_pUILinkContainer );
   }
   virtual void ASWPUBMETHOD LinkGetStringInfo( ASWLINKSTRINGID id,
                                                PASWSTRINGINFO  pStringInfo );
   virtual CAswResult ASWPUBMETHOD DoEditLinksDlg( HWND hWndParent );
   virtual CAswResult ASWPUBMETHOD DoManageLinksDlg (
                                    HWND           hWndOwner,  
                                    BOOL           fConfirmBreakLink = FALSE,   
                                    BOOL           fShowHelp = TRUE,
                                    BOOL           fDisableUpdateNow = FALSE,   
                                    BOOL           fDisableOpenSource = FALSE,  
                                    BOOL           fDisableChangeSource = FALSE,
                                    BOOL           fDisableCancelLink = FALSE,  
                                    LPASWCOLESTR   lpszCaption = NULL,
                                    LPFNOLEUIHOOK  lpfnHook = NULL,
                                    LPARAM         lCustData = 0L,
                                    HINSTANCE      hInstance = NULL,
                                    LPASWCOLESTR   lpszTemplate = NULL,
                                    HRSRC          hResource = NULL);
   inline void AddCOMSiteToList( PASWCOMSITE pCOMSite )
   {
      m_lhListOfCOMSites.Insert(pCOMSite);
   };
   inline void RemoveCOMSiteFromList( PASWCOMSITE pCOMSite )
   {
      m_lhListOfCOMSites.Remove(pCOMSite);
   };
   inline PASWCOMSITE GetFirstCOMSite( void )
   {
      return ( m_lhListOfCOMSites.GetFirst() );
   }
   inline PASWCOMSITE GetNextCOMSite( void )
   {
      return ( m_lhListOfCOMSites.GetNext() );
   }
   inline void SetNextContainer(PASWCONTAINER pAswContainer)
   {
      m_pAswContainerNext = pAswContainer;
   }
   inline PASWCONTAINER GetNextContainer(void)
   {
      return m_pAswContainerNext;
   }
   inline PASWOBJECTINSTANCE GetServerObjectInstance( void )
   {
      return m_pObjectInstance;
   }
   PASWCONTAINEDOBJECT GetContainedObject(LPASWCOLESTR pszItem);
   inline BOOL IsUndoSupported( void )
   {
      return (NULL != m_pAswContainerUndo) ? TRUE : FALSE;
   }
public:
   CAswListEl                    m_leContainerListElement;
private:
private:
   CAswRefHolder                 m_rhContainerMoniker;
   PASWOBJECTINSTANCE            m_pObjectInstance;
   PASWCONTAINERUNDO             m_pAswContainerUndo;
   PASWCONTAINER                 m_pAswContainerNext;
   PASWCONTAINEDOBJECT           m_pNextBindToProcess;
   CAswCOMSiteListHead           m_lhListOfCOMSites;
   CAswContainedObjectListHead   m_lhListOfContainedObjects;
   CAswOLEString                 m_ostrDocName;
   CAswOLEString                 m_ostrFileName;
   BOOL                          m_fContSupportsInplace;
   BOOL                          m_fContSetup;
   CAswUILinkContainer           m_auilcLinks;
   PASWUILINKCONTAINER           m_pUILinkContainer;
};
MAKELISTHEADCLASS(CAswContainer);
#include <aspop.h>
#endif      
