/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswSpaceBase
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    This class is a base class that is used to handle both frame window space
 *    and document window space for an InPlace container.  An InPlace container
 *    must implement a class that derives from CAswSpaceBase for frame window
 *    space support and another instance for document window space.  If a
 *    container only wishes to negotiate frame space it only needs to implement
 *    one instance for the frame window.  The same is true if only document
 *    window space negotiation is required. 
 *
 *****************************************************************************/

#ifndef ASCSPBS_H
#define ASCSPBS_H
#include <aspack.h>
class ASWPUBCLASS CAswSpaceBase : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswSpaceBase( PASWCONTROL pAswControl );
   ASWPUBMETHOD ~CAswSpaceBase( void ); 
   CAswResult ASWPUBMETHOD Setup( void ); 
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   CAswResult ASWPUBMETHOD ChangedNegotiatedSpace( LPCRECT prcNewBorder = NULL ); 
   virtual CAswResult ASWPUBMETHOD GetBorder(LPRECT prcBorder); 
   virtual CAswResult ASWPUBMETHOD RequestBorderSpace( LPCBORDERWIDTHS lpBorderwidths); 
   virtual CAswResult ASWPUBMETHOD SetBorderSpace( LPCBORDERWIDTHS lpBorderwidths ); 
   inline void SetWindowBase( PASWWINDOWBASE pAswWindowBase )
   {
      m_pAswWindowBase = pAswWindowBase;
   }
   inline PASWWINDOWBASE GetWindowBase( void ) const
   {
      return m_pAswWindowBase;
   }
private:
	PASWWINDOWBASE m_pAswWindowBase;
};
#include <aspop.h>
#endif   
