/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswDataSite 
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    A container may choose to get an embedded object's data, to manipulate
 *    and render as necssary.  One example may be data from a spreadsheet
 *    object which the container renders in a chart. 
 *
 *    The CAswDataSite class is used to host data sites for containers.   
 *
 *****************************************************************************/

#ifndef ASDATA_H
#define ASDATA_H
#include <aspack.h>
class ASWPUBCLASS CAswDataSite : public CAswBase
{
public:
   ASWPUBMETHOD CAswDataSite(PASWCONTROL pAswControl);
   ASWPUBMETHOD ~CAswDataSite(void);
   CAswResult ASWPUBMETHOD Setup(PASWCONTAINEDOBJECT  pContainedObject,
                                 LPFORMATETC          pFormatEtc);
   virtual CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE); 
   CAswResult ASWPUBMETHOD SetAdvise(DWORD advf = ADVF_NODATA);
   CAswResult ASWPUBMETHOD RemoveAdvise(void);
   virtual void OnDataChange(PASWSTGMEDUNION pAswStgMed) PURE; 
   virtual void ASWPUBMETHOD OnAdviseClose(  );
   CAswResult ASWPUBMETHOD QueryGetData(LPFORMATETC pFormatEtc = NULL);
   CAswResult ASWPUBMETHOD GetData(PASWSTGMEDUNION pAswStgMed);
   void ASWPUBMETHOD DoneUsingData(void);
   CAswResult ASWPUBMETHOD TakeDataOwnership(PASWSTGMEDUNION pAswStgMed,
                                             PASWSTORAGE     pAswStorage = NULL,
                                             PASWSTREAM      pAswStream = NULL);
   CAswResult ASWPUBMETHOD Prime(PCASWREFHOLDER prhDataObject);
   inline CAswResult Prime(PASWDROPTARGET pDropTarget)
   {
      return Prime(pDropTarget->GetDataObjectRH());
   }
   inline CAswResult Prime(PASWPASTETARGET pPasteTarget)
   {
      return Prime(pPasteTarget->GetDataObjectRH());
   }
   CAswResult ASWPUBMETHOD SetData(  );
   virtual void ASWPUBMETHOD SurfaceToTop(void);
   void OnDataChange(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium);
   CAswListEl     m_leDataSiteListElement; 
private:
   inline BOOL IsAdvise(void)
   {
      return (0 != m_dwConnection);
   }
   PASWDATAMANAGER      m_pAswDataManager;
   FORMATETC            m_fmtetc;
   DWORD                m_dwConnection;
   ASWSTGMEDUNION       m_aswStgMed;
   CAswStorage          m_aswStorage;
   CAswStream           m_aswStream;
};
MAKELISTHEADCLASS(CAswDataSite);
#include <aspop.h>
#endif
