/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: asdebmac.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Purpose:       Debug facility macro declarations.  Declares macros
 *                for 3 build types: debug, assert, and production (no
 *                debug or assert macros).  For the production build,
 *                dummy macros are declared.
 *
 *                Contents of this file were taken from asdebug.h, which
 *                got too big and complicated from conditional directives.
 *                For earlier history on this file, refer to the history
 *                of asdebug.h.
 *
 *****************************************************************************/

#ifndef ASDEBMAC_H
#define ASDEBMAC_H
#include <aspack.h>
#ifdef ASWANASSERT
#define ASszAC "Assertion failure in %s(%d): (%s) is FALSE."
#define ASszAWSC "Assertion failure in %s(%d): (%s) is FALSE.\n%s"
#define ASszRPOKC "Assertion failure in %s(%d): can't read from pointer @ 0x%08lx, length %lu)."
#define ASszWPOKC "Assertion failure in %s(%d): can't write to pointer @ 0x%08lx length %lu."
#define ASszASWERRORFXCtl "error at %Fs(%d): %Fs; "
#define ASszASWERRORFCtl "error at %Fs(%d): %Fs"
#define ASszASWERRORFRCtl "error at %Fs(%d): %Fs - %d; "
#define ASszCallRetStrCtl "%s returns %s"
#define ASszCallingCtl "calling %s"
#define ASszCalling2Ctl "calling %s: "
#define ASszReturnsCtl "%s returns"
#define ASszReturns2Ctl "%s returns "
#define ASszShowRectCtl "%s: left=%d right=%d top=%d bottom=%d"
#define ASszShowPRectCtl "%s(@0x%08lx): left=%d right=%d top=%d bottom=%d"
#define ASszFrameInfoCtl "FrameInfo: fMDIApp=%s, hwndFrame=0x%x, haccel=0x%x, cAccelEntries=%d"
#define ASszShowOLEStringCtl "OLESTRING-- name=%s: value=%s"
#define ASszBadPointer "<Bad pointer>"
#define ASszNULLString "< NULL >"
#define ASszXReturnsCtl "Exit: returns %s"
#define ASszXString "Exit: "
#define ASszXShort "Exit"
#define ASszPanicC "fEmergency=%s"
#define ASszCTORXC "Exit.  size=%ld bytes"
#define ASszEntry "Entry: "
#define ASszEntryShort "Entry"
#define ASszSBAllocFailed "NULL != m_lpszAlloc"
#define ASszSBLostIMalloc "m_lpMalloc && m_iAllocSize <= 0 - Lost IMalloc !"
#define ASszBadBack "Signatures do not match in back"
#define ASszBadFront "Signatures do not match in front"
#define ASszBadPSig "Pointer bad looking for signature"
#define ASszTooBig "String to big to add Signatures"
#ifdef ANSIUNIPROF
#define ASszANSIUNIPROFCtl "**ANSIUNIAPI  function= (0x%08lx) %s --- FILE= %s;  LINE = %i\n"
#endif
typedef void (ASWPTR * LPFN_AswanSimpleAssert) ( LPCSTR, LPCSTR, int );
extern void ASWPUBFUNC AswanSimpleAssert( LPCSTR lpszMessage, LPCSTR lpszFile, int iLine );
extern LPFN_AswanSimpleAssert ASWPUBFUNC SetAswanSimpleAssert( LPFN_AswanSimpleAssert lpfn );
typedef void (ASWPTR * LPFN_AswanGlobalAssert) ( LPCSTR );
extern LPFN_AswanGlobalAssert ASWPUBFUNC SetAswanGlobalAssert( LPFN_AswanGlobalAssert lpfn );
#define ASW_DO_SIMPLE_ASSERT(string) AswanSimpleAssert(string,__FILE__,__LINE__);
#define ASWSIMPLEASSERT(exp,string) if(FALSE==(exp)) ASW_DO_SIMPLE_ASSERT(string)
extern void ASWPUBFUNC AswanGlobalAssert( LPCSTR lpszMessage );
#if defined(_WIN32)
#define ASWHANDLE(h) ((unsigned long)(h))
#else
#define ASWHANDLE(h) ((unsigned short)(h))
#endif
#define ASWSTR __AswDBStringConst
#define ASWGLOBALASSERT(x) if(FALSE==(x)){ASWCODESEGSTRING(E,#x);\
REFASWEXTRNCODESEGSTRING(szAC,ASszAC);\
CAswANSIString s(::lstrlen(E)+::lstrlen(szAC)+::lstrlen(__FILE__)+11);\
LPSTR p=s.GetANSIPtr();::wsprintf(p,szAC,(LPSTR)__FILE__,__LINE__,(LPSTR)E);\
AswanGlobalAssert((LPCSTR)p);}
#define ASWGLOBALASSERTF( exp, FORMAT_STR, PRINTF_SPEC )\
if(FALSE==(exp))\
{\
char szOut[MAXMSGBOXTEXTLEN];\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szFormat,FORMAT_STR);\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szExp,#exp);\
::wsprintf(szOut,szFormat,(PRINTF_SPEC));\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
CAswANSIString s(::lstrlen(szAWSC)+::lstrlen(__FILE__)+::lstrlen(szExp)+::lstrlen(szOut)+11);\
LPSTR lpsz=s.GetANSIPtr();\
::wsprintf(lpsz,szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,(LPSTR)szOut);\
AswanGlobalAssert((LPCSTR)lpsz);\
}
#define ASWGLOBALASSERTMSG( exp, MESSAGE_STR )\
if(FALSE==(exp))\
{\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szMsg,MESSAGE_STR);\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szExp,#exp);\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
CAswANSIString s(::lstrlen(szAWSC)+::lstrlen(__FILE__)+::lstrlen(szExp)+::lstrlen(szMsg)+11);\
LPSTR lpsz=s.GetANSIPtr();\
::wsprintf(lpsz,szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,(LPSTR)szMsg);\
AswanGlobalAssert((LPCSTR)lpsz);\
}
#define ASWGLOBALASSERTSTRING(exp, lpszStr )\
if(FALSE==(exp))\
{\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szExp,#exp);\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAC);\
CAswANSIString s(::lstrlen(szAWSC)+::lstrlen(__FILE__)+::lstrlen(szExp)+::lstrlen(lpszStr)+11);\
LPSTR lpsz=s.GetANSIPtr();\
::wsprintf(lpsz,szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,lpszStr);\
AswanGlobalAssert((LPCSTR)lpsz);\
}
#define ASWASSERTRESSTRING(exp, STRING_ID )\
if(FALSE==(exp))\
{\
char szMsg[MAXMSGBOXTEXTLEN];\
GetControl()->LoadResourceString(STRING_ID,szMsg,sizeof(szMsg));\
ASWNAMEDCODESEGSTRING("ASWANGASRT_TEXT",szExp,#exp);\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
CAswANSIString s(::lstrlen(szAWSC)+::lstrlen(__FILE__)+::lstrlen(szExp)+::lstrlen(szMsg)+11);\
LPSTR lpsz=s.GetANSIPtr();\
::wsprintf(lpsz,szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,(LPSTR)szMsg);\
AswanGlobalAssert((LPCSTR)lpsz);\
}
#define ASSERT_RPTROKLEN(p,n) if(FALSE==ISRPTROKLEN((p),(n))){\
REFASWEXTRNCODESEGSTRING(szRPOKC,ASszRPOKC);\
CAswANSIString s(::lstrlen(szRPOKC)+::lstrlen(__FILE__)+31);\
LPSTR l=s.GetANSIPtr();::wsprintf(l,szRPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n));\
AswanGlobalAssert((LPCSTR)l);}
#define ASSERT_WPTROKLEN(p,n) if(FALSE==ISWPTROKLEN((p),(n))){\
REFASWEXTRNCODESEGSTRING(szWPOKC,ASszWPOKC);\
CAswANSIString s(::lstrlen(szWPOKC)+::lstrlen(__FILE__)+31);\
LPSTR l=s.GetANSIPtr();::wsprintf(l,szWPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n));\
AswanGlobalAssert((LPCSTR)l);}
#ifdef ASWANDEBUG       
#ifdef ANSIUNIPROF
#define ANSIUNIAPI(STR)\
{\
char b[200];\
LPCSTR lpsz;\
if(ISRPTROK(STR)) lpsz=STR; else lpsz="<bad string>";\
REFASWEXTRNCODESEGSTRING(szANSIUNIPROFCtl,ASszANSIUNIPROFCtl);\
::wsprintf(b,szANSIUNIPROFCtl,STR,lpsz,__FILE__,__LINE__);\
::OutputDebugString(b);\
}
#else
#define ANSIUNIAPI(STR)
#endif
#define ASWASSERT( exp )\
if(FALSE==(exp))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szAAE,#exp);\
REFASWEXTRNCODESEGSTRING(szAC,ASszAC);\
ASWPRINTFNAFS((szAC,(LPSTR)__FILE__,__LINE__,(LPSTR)szAAE));\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERTF( exp, FORMAT_STR, PRINTF_SPEC )\
if(FALSE==(exp))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
ASWIDENTIFYMSG();\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szAAE,#exp);\
REFASWEXTRNCODESEGSTRING(szAC,ASszAC);\
ASWPRINTFXXNAFS((szAC,(LPSTR)__FILE__,__LINE__,(LPSTR)szAAE));\
ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
ASWENDMESSAGE();\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERTANSISTR( exp, pA )\
if(FALSE==(exp))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
ASWIDENTIFYMSG();\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szAAE,#exp);\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
ASWPRINTFXXNAFS((szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szAAE,(LPSTR)pA->GetANSIPtr()));\
ASWENDMESSAGE();\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERT_RPTROKLEN(p,n)\
if(FALSE==ISRPTROKLEN(p,n))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
REFASWEXTRNCODESEGSTRING(szRPOKC,ASszRPOKC);\
ASWPRINTFNAFS((szRPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n)));\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERT_WPTROKLEN(p,n)\
if(FALSE==ISWPTROKLEN(p,n))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
REFASWEXTRNCODESEGSTRING(szWPOKC,ASszWPOKC);\
ASWPRINTFNAFS((szWPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n)));\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERT_HUGERPTROKLEN(p,n)\
if(FALSE==ISHUGERPTROKLEN(p,n))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
REFASWEXTRNCODESEGSTRING(szRPOKC,ASszRPOKC);\
ASWPRINTFNAFS((szRPOKC,(LPSTR)__FILE__,__LINE__,(const void _huge *)(p),(DWORD)(n)));\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#define ASWASSERT_HUGEWPTROKLEN(p,n)\
if(FALSE==ISHUGEWPTROKLEN(p,n))\
{\
ASWSETCHANNELS((CH_ASSERTIONS));\
REFASWEXTRNCODESEGSTRING(szWPOKC,ASszWPOKC);\
ASWPRINTFNAFS((szWPOKC,(LPSTR)__FILE__,__LINE__,(void _huge *)(p),(DWORD)(n)));\
ASWCLEARCHANNELS((CH_ASSERTIONS));\
}
#else    
class CAswPrintf : public CAswMemoryBase
{
private:
   enum { INTERNALBUFFERSIZE = 512 };
public:
   inline CAswPrintf( void )
   {
      m_str[ 0 ] = '\0';
   }
   void __cdecl Printf( LPCSTR fmt, ... );
   inline LPCSTR GetPtr( void ) const
   {
      return ( &m_str[0] );
   }
private:
   char m_str[ INTERNALBUFFERSIZE ];
};
#define ASWASSERT( exp )\
if(FALSE==(exp))\
{\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szExp,#exp);\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
REFASWEXTRNCODESEGSTRING(szAC,ASszAC);\
pCtl->Printf(szAC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp);\
}\
}
#define ASWASSERTF( exp, FORMAT_STR, PRINTF_SPEC )\
if(FALSE==(exp))\
{\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szExp,#exp);\
{\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",ASWSTR,FORMAT_STR);\
CAswPrintf p;\
p.Printf PRINTF_SPEC;\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
pCtl->Printf(szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,p.GetPtr());\
}\
}\
}
#define ASWASSERTANSISTR( exp, pA )\
if(FALSE==(exp))\
{\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
ASWNAMEDCODESEGSTRING("ASWANASRT_TEXT",szExp,#exp);\
{\
REFASWEXTRNCODESEGSTRING(szAWSC,ASszAWSC);\
pCtl->Printf(szAWSC,(LPSTR)__FILE__,__LINE__,(LPSTR)szExp,(LPSTR)pA->GetANSIPtr());\
}\
}\
}
#define ASWASSERT_RPTROKLEN(p,n)\
if(FALSE==ISRPTROKLEN((p),(n)))\
{\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
REFASWEXTRNCODESEGSTRING(szRPOKC,ASszRPOKC);\
pCtl->Printf(szRPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n));\
}\
}
#define ASWASSERT_WPTROKLEN(p,n)\
if(FALSE==ISWPTROKLEN((p),(n)))\
{\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
REFASWEXTRNCODESEGSTRING(szWPOKC,ASszWPOKC);\
pCtl->Printf(szWPOKC,(LPSTR)__FILE__,__LINE__,(LPVOID)(p),(DWORD)(n));\
}\
}
#define ASWASSERT_HUGERPTROKLEN(p,n)\
if(FALSE==ISHUGERPTROKLEN((p),(n)))\
{\
PASWCONTROL pCtl=GetControl();\
if(pCtl)\
{\
REFASWEXTRNCODESEGSTRING(szRPOKC,ASszRPOKC);\
pCtl->Printf(szRPOKC,(LPSTR)__FILE__,__LINE__,(const void _huge *)(p),(DWORD)(n));\
}\
}
#define ASWASSERT_HUGEWPTROKLEN(p,n)\
if(FALSE==ISHUGEWPTROKLEN((p),(n)))\
{\
PASWCONTROL pCtl = GetControl();\
if(pCtl)\
{\
REFASWEXTRNCODESEGSTRING(szWPOKC,ASszWPOKC);\
pCtl->Printf(szWPOKC,(LPSTR)__FILE__,__LINE__,(void _huge *)(p),(DWORD)(n));\
}\
}
#define ANSIUNIAPI(STR)
#endif   
#define ASWASSERT_RPTROKLEN_NULLOK( p, n ) if(p)ASWASSERT_RPTROKLEN(p,n)
#define ASWASSERT_WPTROKLEN_NULLOK( p, n ) if(p)ASWASSERT_WPTROKLEN(p,n)
#else    
#define ASWSTR
#define ASW_DO_SIMPLE_ASSERT(string)
#define ASWSIMPLEASSERT(exp,string)
#define ASWGLOBALASSERT( exp )
#define ASWGLOBALASSERTF( exp, FORMAT_STR, PRINTF_SPEC )
#define ASWGLOBALASSERTMSG( exp, MESSAGE_STR )
#define ASWGLOBALASSERTSTRING(exp, lpszString )
#define ASWASSERTRESSTRING(exp, STRING_ID )
#define ASSERT_RPTROKLEN(p,n)
#define ASSERT_WPTROKLEN(p,n)
#define ANSIUNIAPI(STR)
#define ASWASSERT(x)
#define ASWASSERTF( exp, FORMAT_STR, PRINTF_SPEC )
#define ASWASSERTANSISTR( exp, pAnsiStr )
#define ASWASSERT_WPTROKLEN(p,n)
#define ASWASSERT_RPTROKLEN(p,n)
#define ASWASSERT_RPTROKLEN_NULLOK( p, n )
#define ASWASSERT_WPTROKLEN_NULLOK( p, n )
#define ASWASSERT_HUGEWPTROKLEN(p,n)
#define ASWASSERT_HUGERPTROKLEN(p,n)
#endif
#define ASWASSERT_RPTROK( p ) ASWASSERT_RPTROKLEN(p,1)
#define ASWASSERT_WPTROK( p ) ASWASSERT_WPTROKLEN(p,1)
#define ASWASSERT_RPTROKSIZE( p ) ASWASSERT_RPTROKLEN(p,sizeof(*p))
#define ASWASSERT_WPTROKSIZE( p ) ASWASSERT_WPTROKLEN(p,sizeof(*p))
#define ASWASSERT_RPTROK_NULLOK( p ) ASWASSERT_RPTROKLEN_NULLOK(p,1)
#define ASWASSERT_WPTROK_NULLOK( p ) ASWASSERT_WPTROKLEN_NULLOK(p,1)
#define ASWASSERT_RPTROKSIZE_NULLOK( p ) ASWASSERT_RPTROKLEN_NULLOK(p,sizeof(*p))
#define ASWASSERT_WPTROKSIZE_NULLOK( p ) ASWASSERT_WPTROKLEN_NULLOK(p,sizeof(*p))
#define ASSERT_RPTROK(p) ASSERT_RPTROKLEN(p,1);
#define ASSERT_WPTROK(p) ASSERT_WPTROKLEN(p,1);
#define ASSERT_RPTROKSIZE(p) ASSERT_RPTROKLEN(p,sizeof(*p))
#define ASSERT_WPTROKSIZE(p) ASSERT_WPTROKLEN(p,sizeof(*p))
#define ASSERT_RPTROKLEN_NULLOK( p, n ) if(p)ASSERT_RPTROKLEN(p,n)
#define ASSERT_WPTROKLEN_NULLOK( p, n ) if(p)ASSERT_WPTROKLEN(p,n)
#define ASSERT_RPTROK_NULLOK(p) ASSERT_RPTROKLEN_NULLOK(p,1);
#define ASSERT_WPTROK_NULLOK(p) ASSERT_WPTROKLEN_NULLOK(p,1);
#define ASSERT_RPTROKSIZE_NULLOK(p) ASSERT_RPTROKLEN_NULLOK(p,sizeof(*p))
#define ASSERT_WPTROKSIZE_NULLOK(p) ASSERT_WPTROKLEN_NULLOK(p,sizeof(*p))
#define ASWGLOBALASSERT_RPTROKLEN(p,l) ASSERT_RPTROKLEN(p,l)
#define ASWGLOBALASSERT_WPTROKLEN(p,l) ASSERT_WPTROKLEN(p,l)
#define ASWGLOBALASSERT_RPTROK(p) ASWGLOBALASSERT_RPTROKLEN(p,1)
#define ASWGLOBALASSERT_WPTROK(p) ASWGLOBALASSERT_WPTROKLEN(p,1)
#define ASWGLOBALASSERT_RPTROKSIZE(p) ASWGLOBALASSERT_RPTROKLEN(p,sizeof(*p))
#define ASWGLOBALASSERT_WPTROKSIZE(p) ASWGLOBALASSERT_WPTROKLEN(p,sizeof(*p))
#define ASWGLOBALASSERT_RPTROKLEN_NULLOK(p,l) ASSERT_RPTROKLEN_NULLOK(p,l)
#define ASWGLOBALASSERT_WPTROKLEN_NULLOK(p,l) ASSERT_WPTROKLEN_NULLOK(p,l)
#define ASWGLOBALASSERT_RPTROK_NULLOK(p) ASWGLOBALASSERT_RPTROKLEN_NULLOK(p,1)
#define ASWGLOBALASSERT_WPTROK_NULLOK(p) ASWGLOBALASSERT_WPTROKLEN_NULLOK(p,1)
#define ASWGLOBALASSERT_RPTROKSIZE_NULLOK(p) ASWGLOBALASSERT_RPTROKLEN_NULLOK(p,sizeof(*p))
#define ASWGLOBALASSERT_WPTROKSIZE_NULLOK(p) ASWGLOBALASSERT_WPTROKLEN_NULLOK(p,sizeof(*p))
#define ASWDOSHUTDOWNENTRY() DoShutdownProcessing(TRUE);
#define ASWDOSHUTDOWNEXIT(ar) DoShutdownProcessing(FALSE);return(ar);
#ifdef ASWANDEBUG
#define ASWENDMESSAGE()\
if(__pC)\
{\
__pC->EndMessage();\
__pC->SetMessageChannelMap( NULL);\
}
#define ASWINDENT(INOUT)\
if(__pC)\
{\
__pC->Indent(INOUT);\
}
#define ASWIDENTIFYMSG()\
if(__pC)\
{\
__pC->SetMessageChannelMap( &__MessageChannelMap);\
__pC->Identify(GetAswanClassName(),GetInstanceID(),__szMethodName);\
}
#define ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC)\
{\
ASWNAMEDCODESEGSTRING(__FILE__ "P_TEXT", ASWSTR, FORMAT_STR);\
if(__pC)\
   __pC->Printf PRINTF_SPEC;\
}
#define ASWSETCHANNELS(CHANNEL_LIST)\
__MessageChannelMap.SetChannels CHANNEL_LIST
#define ASWCLEARCHANNELS(CHANNEL_LIST)\
__MessageChannelMap.ClearChannels CHANNEL_LIST
#define ASWPRINTFX(FORMAT_STR, PRINTF_SPEC)\
if(__pC)\
{\
ASWNAMEDCODESEGSTRING("PRINTF2_TEXT", ASWSTR, FORMAT_STR);\
__pC->SetMessageChannelMap( &__MessageChannelMap);\
__pC->Printf PRINTF_SPEC;\
__pC->SetMessageChannelMap( NULL);\
}
#define ASWPRINTF(FORMAT_STR, PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
ASWENDMESSAGE()\
}
#define ASWPRINTFNAFS(PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
if(__pC)\
   __pC->Printf PRINTF_SPEC ;\
ASWENDMESSAGE()\
}
#define ASWPRINTFXXNAFS(PRINTF_SPEC)\
{\
if(__pC)\
   __pC->Printf PRINTF_SPEC ;\
}
#define ASWSETINSTANCEID() SetInstanceID()
#define ASWSETCLASSNAME(NAME)\
{\
ASWCODESEGSTRING(szClass,NAME);\
SetClassName(szClass);\
}
#define ASWMETHOD(METHOD_NAME,CHANNEL_LIST)\
PASWCONTROL __pC=GetControl();\
CAswChannelMap __MessageChannelMap;\
ASWCODESEGSTRING(__szMethodName,METHOD_NAME);\
if(__pC) InitDebugBuffer();\
ASWSETCHANNELS(CHANNEL_LIST);\
ASWSETCHANNELS((m_AddlChannel));\
ASWINDENT(TRUE)
#define ASWENTRY_NC()\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szEntryShort, ASszEntryShort);\
ASWPRINTFXXNAFS((szEntryShort));\
ASWENDMESSAGE();\
}
#define ASWENTRYF_NCNAFS(PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szEntry, ASszEntry);\
ASWPRINTFXXNAFS((szEntry));\
ASWPRINTFXXNAFS((PRINTF_SPEC));\
ASWENDMESSAGE();\
}
#define ASWENTRYF_NC(FORMAT_STR, PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szEntry, ASszEntry);\
ASWPRINTFXXNAFS((szEntry));\
ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
ASWENDMESSAGE();\
}
#define ASWCONSTRUCTORENTRY()\
{\
ASWENTRY_NC();\
DebugSetSetup(FALSE);\
}
#define ASWCONSTRUCTORENTRYF(FORMAT_STR, PRINTF_SPEC)\
{\
ASWENTRYF_NC(FORMAT_STR,PRINTF_SPEC);\
DebugSetSetup(FALSE);\
}
#define ASWCONSTRUCTOREXIT()\
{\
REFASWEXTRNCODESEGSTRING(szCTORXC,ASszCTORXC);\
ASWPRINTFNAFS((szCTORXC,sizeof(*this)));\
ASWEXITX();\
}
#define ASWCONSTRUCTOREXIT_FROMTHEMIDDLE()\
{\
REFASWEXTRNCODESEGSTRING(szCTORXC,ASszCTORXC);\
ASWPRINTFNAFS((szCTORXC,sizeof(*this)));\
ASWEXITX();\
return;\
}
#define ASWDESTRUCTORENTRY()\
{\
ASWENTRY_NC();\
ASWASSERT(!DebugNeedsShutdown());\
}
#define ASWDESTRUCTOREXIT()\
{\
ASWEXITX();\
}
#define ASWDESTRUCTOREXIT_FROMTHEMIDDLE()\
{\
ASWEXITX();\
return;\
}
#define ASWSETUPENTRY()\
{\
ASWENTRY_NC();\
ASWASSERT(FALSE==DebugIsSetup());\
}
#define ASWSETUPENTRYF(FORMAT_STR, PRINTF_SPEC)\
{\
ASWENTRYF_NC(FORMAT_STR, PRINTF_SPEC);\
ASWASSERT(FALSE==DebugIsSetup());\
}
#define ASWSETUPEXITR(ar)\
{\
CAswResult __ar=(ar);\
if(ASWSUCCEEDED(__ar))\
{\
  ASWASSERT(DebugIsSetup());\
}\
else\
{\
  if(ASW_E_ALREADYSETUP!=__ar.Scode())\
 {\
  ASWASSERT(!DebugIsSetup());\
 }\
}\
ASWEXITR(__ar);\
}
#define ASWSHUTDOWNENTRY(flag)\
REFASWEXTRNCODESEGSTRING(szPanicC,ASszPanicC);\
ASWENTRYF_NCNAFS((szPanicC,ASWSHOWTF(flag)));\
ASWDOSHUTDOWNENTRY()
#define ASWSHUTDOWNEXITR(ar)\
ASWEXITX();\
ASWDOSHUTDOWNEXIT(ar)
#define ASWENTRY()\
{\
ASWENTRY_NC();\
ASWASSERT(DebugIsSetup());\
}
#define ASWENTRYF(FORMAT_STR, PRINTF_SPEC)\
{\
ASWENTRYF_NC(FORMAT_STR, PRINTF_SPEC);\
ASWASSERT(DebugIsSetup())\
}
#define ASWEXITX()\
{\
ASWINDENT(FALSE);\
if(__pC)\
{\
  __pC->SetMessageChannelMap( NULL);\
}\
}
#define ASWEXIT()\
{\
REFASWEXTRNCODESEGSTRING(szXShort, ASszXShort);\
ASWPRINTFNAFS((szXShort));\
ASWEXITX();\
return;\
}
#define ASWEXITVF(FORMAT_STR,PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szXShort, ASszXShort);\
ASWPRINTFXXNAFS((szXShort));\
ASWPRINTFXX(FORMAT_STR,PRINTF_SPEC);\
ASWENDMESSAGE();\
ASWEXITX();\
return;\
}
#define ASWEXITR(ar)\
{\
REFASWEXTRNCODESEGSTRING(szXReturnsCtl,ASszXReturnsCtl);\
ASWPRINTFNAFS((szXReturnsCtl,ScodeMsg((ar).Scode())));\
ASWEXITX();\
return (ar);\
}
#define ASWEXITH(hr)\
{\
REFASWEXTRNCODESEGSTRING(szXReturnsCtl,ASszXReturnsCtl);\
ASWPRINTFNAFS((szXReturnsCtl,ScodeMsg(GetScode(hr))));\
ASWEXITX();\
return (hr);\
}
#define ASWEXITS(sc)\
{\
REFASWEXTRNCODESEGSTRING(szXReturnsCtl,ASszXReturnsCtl);\
ASWPRINTFNAFS((szXReturnsCtl,ScodeMsg(sc)));\
ASWEXITX();\
return ResultFromScode(sc);\
}
#define ASWEXITB(BOOLRETURN)\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szXReturnsCtl,ASszXReturnsCtl);\
ASWPRINTFXXNAFS((szXReturnsCtl,ASWSHOWTF(BOOLRETURN)));\
ASWENDMESSAGE();\
ASWEXITX();\
return (BOOLRETURN);\
}
#define ASWEXITF(RETVAL, FORMAT_STR, PRINTF_SPEC)\
{\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szXString, ASszXString);\
ASWPRINTFXXNAFS((szXString));\
ASWPRINTFXX(FORMAT_STR,PRINTF_SPEC);\
ASWENDMESSAGE();\
ASWEXITX();\
return (RETVAL);\
}
#define ASWCALL(CALL_NAME)\
{\
ASWCODESEGSTRING(szCall,CALL_NAME);\
REFASWEXTRNCODESEGSTRING(szCallingCtl,ASszCallingCtl);\
ASWPRINTFNAFS((szCallingCtl,(LPSTR)szCall))
#define ASWCALLF(CALL_NAME,FORMAT_STR, PRINTF_SPEC)\
{\
ASWCODESEGSTRING(szCall,CALL_NAME);\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szCalling2Ctl,ASszCalling2Ctl);\
ASWPRINTFXXNAFS((szCalling2Ctl,(LPSTR)szCall));\
ASWPRINTFXX(FORMAT_STR,PRINTF_SPEC);\
ASWENDMESSAGE()
#define ASWRETURN()\
REFASWEXTRNCODESEGSTRING(szReturnsCtl,ASszReturnsCtl);\
ASWPRINTFNAFS((szReturnsCtl,(LPSTR)szCall));\
}
#define ASWRETURNF(FORMAT_STR, PRINTF_SPEC)\
ASWIDENTIFYMSG();\
REFASWEXTRNCODESEGSTRING(szReturns2Ctl,ASszReturns2Ctl);\
ASWPRINTFXXNAFS((szReturns2Ctl,(LPSTR)szCall));\
ASWPRINTFXX(FORMAT_STR,PRINTF_SPEC);\
ASWENDMESSAGE();\
}
#define ASWRETURNH(HRESULT)\
if(FAILED(HRESULT))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
}\
REFASWEXTRNCODESEGSTRING(szCallRetStrCtl,ASszCallRetStrCtl);\
ASWPRINTFNAFS((szCallRetStrCtl,(LPSTR)szCall,ScodeMsg(GetScode(HRESULT))));\
if(FAILED(HRESULT))\
{\
  ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWRETURNB(bool)\
if(!bool)\
{\
 ASWSETCHANNELS((CH_ERRORS));\
}\
REFASWEXTRNCODESEGSTRING(szCallRetStrCtl,ASszCallRetStrCtl);\
ASWPRINTFNAFS((szCallRetStrCtl,(LPSTR)szCall,ASWSHOWTF(bool)));\
if(!bool)\
{\
 ASWCLEARCHANNELS( (CH_ERRORS));\
}\
}
#define ASWSHOWPRECT(pR)\
REFASWEXTRNCODESEGSTRING(szShowPRectCtl,ASszShowPRectCtl);\
ASWPRINTFNAFS((szShowPRectCtl,(LPSTR)#pR,pR,pR->left,pR->right,pR->top,pR->bottom));
#define ASWSHOWRECT(R)\
REFASWEXTRNCODESEGSTRING(szShowRectCtl,ASszShowRectCtl);\
ASWPRINTFNAFS((szShowRectCtl,(LPSTR)#R,R.left,R.right,R.top,R.bottom));
#define SHOWFRAMEINFO(FI)\
REFASWEXTRNCODESEGSTRING(szFrameInfoCtl,ASszFrameInfoCtl);\
ASWPRINTFNAFS((szFrameInfoCtl,ASWSHOWTF(FI.fMDIApp),ASWHANDLE(FI.hwndFrame),\
 ASWHANDLE(FI.haccel),FI.cAccelEntries));
#define ASWSHOWOLESTR(STRVAL)\
{\
REFASWEXTRNCODESEGSTRING(szShowOLEStringCtl,ASszShowOLEStringCtl);\
if(ISRPTROK(STRVAL))\
{\
 CAswANSIString lpsz(STRVAL);\
 ASWPRINTFNAFS((szShowOLEStringCtl,(LPCSTR)#STRVAL,(LPCSTR)lpsz));\
}\
else\
{\
 if(NULL==STRVAL)\
 {\
  REFASWEXTRNCODESEGSTRING(szNULLString, ASszNULLString);\
  ASWPRINTFNAFS((szShowOLEStringCtl,(LPCSTR)#STRVAL,(LPCSTR)szNULLString));\
 }\
 else\
 {\
  REFASWEXTRNCODESEGSTRING(szBadPointer, ASszBadPointer);\
  ASWPRINTFNAFS((szShowOLEStringCtl,(LPCSTR)#STRVAL,(LPCSTR)szBadPointer));\
 }\
}\
}
#define ASWERRORR(ar)\
{\
if(ASWFAILED(ar))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFRCtl,ASszASWERRORFRCtl);\
 ASWPRINTFXXNAFS((szASWERRORFRCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg((ar).Scode()),(ar).Disp()));\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWERRORFR(ar, FORMAT_STR, PRINTF_SPEC)\
{\
if(ASWFAILED((ar)))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFRCtl,ASszASWERRORFRCtl);\
 ASWPRINTFXXNAFS((szASWERRORFRCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg((ar).Scode()),(ar).Disp()));\
 ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWERRORH(HRESULT)\
{\
if(FAILED(HRESULT))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFCtl,ASszASWERRORFCtl);\
 ASWPRINTFXXNAFS((szASWERRORFCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg(GetScode(HRESULT))));\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWERRORFH(HRESULT, FORMAT_STR, PRINTF_SPEC)\
{\
if(FAILED(HRESULT))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFXCtl,ASszASWERRORFXCtl);\
 ASWPRINTFXXNAFS((szASWERRORFXCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg(GetScode(HRESULT))));\
 ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWERRORS(sc)\
{\
if(FAILED(sc))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFCtl,ASszASWERRORFCtl);\
 ASWPRINTFXXNAFS((szASWERRORFCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg(sc)));\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWERRORFS(sc, FORMAT_STR, PRINTF_SPEC)\
{\
if(FAILED(sc))\
{\
 ASWSETCHANNELS((CH_ERRORS));\
 ASWIDENTIFYMSG();\
 REFASWEXTRNCODESEGSTRING(szASWERRORFXCtl,ASszASWERRORFXCtl);\
 ASWPRINTFXXNAFS((szASWERRORFXCtl,(LPSTR)__FILE__,__LINE__,ScodeMsg(sc)));\
 ASWPRINTFXX(FORMAT_STR, PRINTF_SPEC);\
 ASWENDMESSAGE();\
 ASWCLEARCHANNELS((CH_ERRORS));\
}\
}
#define ASWBLANKLINE()\
if(__pC)\
{\
__pC->SetMessageChannelMap( &__MessageChannelMap);\
__pC->EndMessage();\
__pC->SetMessageChannelMap( NULL);\
}
#define ASWCLASSID( ASWCLASS ) ConstructClassId((CAswDebugBase *)ASWCLASS)
#else 
#define ASWSETCHANNELS(CHANNEL_LIST)
#define ASWCLEARCHANNELS(CHANNEL_LIST)
#define ASWPRINTFX(FORMAT_STR, PRINTF_SPEC)
#define ASWPRINTF(FORMAT_STR, PRINTF_SPEC)
#define ASWPRINTFNAFS(PRINTF_SPEC)
#define ASWSETINSTANCEID()
#define ASWSETCLASSNAME(NAME)
#define ASWMETHOD(METHOD_NAME,CHANNEL_LIST)
#define ASWENTRY_NC()
#define ASWENTRYF_NC(FORMAT_STR, PRINTF_SPEC)
#define ASWCONSTRUCTORENTRY()
#define ASWCONSTRUCTORENTRYF(FORMAT_STR, PRINTF_SPEC)
#define ASWCONSTRUCTOREXIT()                          
#define ASWCONSTRUCTOREXIT_FROMTHEMIDDLE() return
#define ASWDESTRUCTORENTRY()
#define ASWDESTRUCTOREXIT()                           
#define ASWDESTRUCTOREXIT_FROMTHEMIDDLE() return
#define ASWSETUPENTRY()
#define ASWSETUPENTRYF(FORMAT_STR, PRINTF_SPEC)
#define ASWSETUPEXITR(ar) return (ar)
#define ASWSHUTDOWNENTRY(flag) ASWDOSHUTDOWNENTRY()
#define ASWSHUTDOWNEXITR(ar) ASWDOSHUTDOWNEXIT(ar)
#define ASWBLANKLINE()
#define ASWENTRY()
#define ASWENTRYF(FORMAT_STR, PRINTF_SPEC)
#define ASWEXITX()
#define ASWEXIT() return
#define ASWEXITR(ar) return (ar)
#define ASWEXITH(hr) return (hr)
#define ASWEXITS(sc) return ResultFromScode(sc)
#define ASWEXITB(BOOLRETURN) return (BOOLRETURN)
#define ASWEXITF(RETVAL, FORMAT_STR, PRINTF_SPEC) return (RETVAL)
#define ASWCALL(CALL_NAME)
#define ASWCALLF(CALL_NAME, FORMAT_STR, PRINTF_SPEC)
#define ASWRETURN()
#define ASWRETURNF(FORMAT_STR, PRINTF_SPEC)
#define ASWRETURNH(HRESULT)
#define ASWRETURNS(SCODE)
#define ASWRETURNB(bool)
#define ASWSHOWRECT(R)
#define ASWSHOWPRECT(R)
#define ASWERRORR(ar)
#define ASWSHOWOLESTR(STRVAL)
#define ASWERRORFR(ar, FORMAT_STR, PRINTF_SPEC)
#define ASWERRORH(HRESULT)
#define ASWERRORFH(HRESULT, FORMAT_STR, PRINTF_SPEC)
#define ASWERRORS(sc)
#define ASWERRORFS(sc, FORMAT_STR, PRINTF_SPEC)
#define ASWCLASSID( ASWCLASS ) ""
#endif 
#define ASW_STANDARD_CONSTRUCTOR_PROLOGUE( pControl, classname, channel )\
ASWSETCLASSNAME(#classname);\
ASWMETHOD(#classname,(channel));\
ASWCONSTRUCTORENTRYF("pControl = %s",(ASWSTR,ASWCLASSID(pControl)));\
ASWASSERT(pControl);
#define ASW_STANDARD_CONSTRUCTOR_IMPL( pControl, classname, channel )\
ASW_STANDARD_CONSTRUCTOR_PROLOGUE(pControl,classname,channel);\
ASWCONSTRUCTOREXIT();
#define ASW_STANDARD_DESTRUCTOR_IMPL( classname, channel )\
ASWMETHOD("~"#classname,(channel));\
ASWDESTRUCTORENTRY();\
Shutdown(TRUE);\
ASWDESTRUCTOREXIT()
#include <aspop.h>
#endif 
