/* NOSHIP */
/*****************************************************************************
 *
 * asdllx.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description: Delayed loading of selected DLL entrypoints
 *
 *****************************************************************************/

#if !defined(_ASWAN_DLLX_H)
#define _ASWAN_DLLX_H
#if defined(COMPASW)
#if ! defined(_ASENVMAC_H)
#include <asenvmac.h>
#endif
BOOL GetCurrentTaskPath( LPSTR     lpsz,
                         int       iSizelpsz );
#if defined(WIN16)
   #ifndef MK_FP
      #define MK_FP(s,o) ((void far *) (((DWORD) (s) << 16) | (o)))
   #endif   
   #define HINSTANCE_FROM_HTASK(hTask) \
                               (HINSTANCE) *((WORD FAR *) MK_FP((WORD)hTask, 0x1C))
#endif 
extern HINSTANCE SilentLoadLibrary( LPCSTR lpszLibFileName,
                                    LPDWORD lpdwLoadError );
extern void UnloadDLL( HINSTANCE hInstance );
extern HINSTANCE LoadSharedDLL( LPCSTR  lpszDLLName );
#ifdef __cplusplus
extern "C"
{
#endif
#ifndef LTSOS2
#define DELAYEDDLLCALL_EXTERN(funcname,signature)                       \
   typedef HRESULT (FAR PASCAL FAR *LPFN##funcname) ##signature;        \
   extern LPFN##funcname NEAR lpfn##funcname;
#else
#define DELAYEDDLLCALL_EXTERN(funcname,signature)                       \
   typedef HRESULT (* FAR PASCAL FAR LPFN##funcname) ##signature;       \
   extern LPFN##funcname NEAR lpfn##funcname;
#endif 
#if !defined(ASW_DO_SIMPLE_ASSERT)
#define ASDLLX_DO_SIMPLE_ASSERT(string) ::MessageBox( NULL, string, "Aswan Assertion Failure", MB_ICONSTOP | MB_OK )
#else
#define ASDLLX_DO_SIMPLE_ASSERT(string) ASW_DO_SIMPLE_ASSERT(string)
#endif
#if defined(WIN16)
extern HMODULE NEAR g_hStorageDLL;
DELAYEDDLLCALL_EXTERN( StgCreateDocfile, (const OLECHAR FAR* pwcsName,
                                         DWORD grfMode,
                                         DWORD reserved,
                                         IStorage FAR * FAR *ppstgOpen) );
DELAYEDDLLCALL_EXTERN( StgCreateDocfileOnILockBytes, (ILockBytes FAR *plkbyt,
                                                     DWORD grfMode,
                                                     DWORD reserved,
                                                     IStorage FAR * FAR *ppstgOpen) );
DELAYEDDLLCALL_EXTERN( StgOpenStorage, (const OLECHAR FAR* pwcsName,
                                       IStorage FAR *pstgPriority,
                                       DWORD grfMode,
                                       SNB snbExclude,
                                       DWORD reserved,
                                       IStorage FAR * FAR *ppstgOpen) );
DELAYEDDLLCALL_EXTERN( StgOpenStorageOnILockBytes, (ILockBytes FAR *plkbyt,
                                                   IStorage FAR *pstgPriority,
                                                   DWORD grfMode,
                                                   SNB snbExclude,
                                                   DWORD reserved,
                                                   IStorage FAR * FAR *ppstgOpen) );
extern void PASCAL ResetStorageTripwires( void );
#else
#define lpfnStgCreateDocfile              StgCreateDocfile
#define lpfnStgCreateDocfileOnILockBytes  StgCreateDocfileOnILockBytes
#define lpfnStgOpenStorage                StgOpenStorage
#define lpfnStgOpenStorageOnILockBytes    StgOpenStorageOnILockBytes
#define ResetStorageTripwires()
#endif
extern HMODULE NEAR g_hBentoDLL;
DELAYEDDLLCALL_EXTERN( StgCreateBento, (const OLECHAR FAR* pwcsName,
                                       DWORD grfMode,
                                       DWORD reserved,
                                       IStorage FAR * FAR *ppstgOpen) );
DELAYEDDLLCALL_EXTERN( StgOpenBento, (const OLECHAR FAR* pwcsName,
                                     IStorage FAR *pstgPriority,
                                     DWORD grfMode,
                                     SNB snbExclude,
                                     DWORD reserved,
                                     IStorage FAR * FAR *ppstgOpen) );
extern void PASCAL ResetBentoTripwires( void );
#define DELAYEDDLL_CALLPTRNAME(funcname) LPFN##funcname NEAR lpfn##funcname =
#define DELAYEDDLL_SHARED    TRUE
#define DELAYEDDLL_NOTSHARED FALSE
#define DELAYEDDLL_TRIPWIRENAME(funcname) Tripwire##funcname
#define DELAYEDDLLCALL(gmodule,dllname,bShared,funcname,exportname,signature,callparams)\
HRESULT FAR PASCAL DELAYEDDLL_TRIPWIRENAME(funcname) ##signature\
{\
   if ( ! INSTANCEHANDLE_OK( gmodule ) )\
      gmodule = (DELAYEDDLL_SHARED == bShared) ? LoadSharedDLL( dllname )\
                                               : ::LoadLibrary( dllname );\
\
   if ( INSTANCEHANDLE_OK( gmodule ) )\
   {\
      FARPROC lpfunc = ::GetProcAddress( gmodule, (LPCSTR)#exportname );\
      if ( NULL != lpfunc )\
      {\
         lpfn##funcname = (LPFN##funcname) lpfunc;\
         return ( (lpfn##funcname) ##callparams );\
      }\
      else\
         ASDLLX_DO_SIMPLE_ASSERT( #dllname" was loaded but "#exportname" could not be found in it by Tripwire"#funcname"\nReturing E_FAIL" );\
   }\
   else\
      ASDLLX_DO_SIMPLE_ASSERT( #dllname" was not loaded by Tripwire"#funcname"\n"#exportname" Returing E_FAIL" );\
   return ( ResultFromScode( E_FAIL ) );\
}\
\
DELAYEDDLL_CALLPTRNAME(funcname) DELAYEDDLL_TRIPWIRENAME(funcname)
void PASCAL ClearTripwireDLLs( void );
#ifdef __cplusplus
}  
#endif
#endif 
#endif 
