/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswDataObjectHolder
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Contain the IDataObject used during paste or drop target
 *    operations.
 *
 *    This class is designed to be used internally by Aswan.
 *
 *****************************************************************************/

#ifndef ASDOBJHL_H
#define ASDOBJHL_H
#include <aspack.h>
class ASWPUBCLASS CAswDataObjectHolder : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswDataObjectHolder(PASWCONTROL pCtl);
   ASWPUBMETHOD ~CAswDataObjectHolder(void);
   CAswResult ASWPUBMETHOD Setup(void);
   CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE);
   inline PASWREFHOLDER GetDataObjectRH(void)
   {
      return &m_rfDataObject;
   }
   inline PASWOBJECTDESCRIPTOR GetObjectDescriptor(void)
   {
      PASWOBJECTDESCRIPTOR pRet;
      if (   m_ObjectDescriptor.IsValid() 
          || m_ObjectDescriptor.FillFromData(&m_rfDataObject))
         pRet = &m_ObjectDescriptor;
      else
         pRet = NULL;
      return pRet;
   }
   inline CAswResult SetReturnedInterface(LPDATAOBJECT pIData)
   {
      return m_rfDataObject.SetReturnedInterface(pIData, IID_IDataObject);
   }
   inline CAswResult SetGivenInterface(LPDATAOBJECT pIData)
   {
      return m_rfDataObject.SetGivenInterface(pIData, IID_IDataObject);
   }
   inline void Release(void)
   {
      m_ObjectDescriptor.ClearDescriptor();
      m_rfDataObject.Release();
   }
   BOOL ASWPUBMETHOD QueryObjectFormat(LPFORMATETC pFormatEtc);
   LPFORMATETC ASWPUBMETHOD
   GetHighestFormatMatch(PASWTARGETFORMATSET pAswTargetFormatSet,
                         LPUINT              pIndex);
   CAswResult ASWPUBMETHOD GetData(LPFORMATETC     pFmtEtc,
                                   PASWSTGMEDUNION pAswStgMedium,
                                   PASWSTORAGE     pAswStorage,
                                   PASWSTREAM      pAswStream);
private:
   CAswRefHolder        m_rfDataObject;
   CAswObjectDescriptor m_ObjectDescriptor;
};
#include <aspop.h>
#endif
