/* NOSHIP */
/*****************************************************************************
 *
 * asenvmac.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description: Environment-specific macros that don't end up dragging in
 *              the rest of the Aswan environment
 *
 *              Can be included in .c and .cpp files.
 *
 *****************************************************************************/

#if ! defined(_ASENVMAC_H)
#define _ASENVMAC_H
#if defined (_WIN32)
   #define INSTANCEHANDLE_OK(handle) (0 != handle)
#else
   #define INSTANCEHANDLE_OK(handle) (HINSTANCE_ERROR < handle)
#endif
#if defined(WIN16)
   typedef char   OLECHAR;
#endif
#ifdef __cplusplus
const UINT MAX_RESOURCESTRING = 255;
const UINT CB_RESOURCESTRING = (MAX_RESOURCESTRING + 1);
const UINT MAXMSGBOXTEXTLEN = 256;
#else
#define MAX_RESOURCESTRING 255
#define CB_RESOURCESTRING (MAX_RESOURCESTRING + 1)
#define MAXMSGBOXTEXTLEN 256
#endif
#define ISRPTROKLEN(ptr,len) (ptr ? FALSE==IsBadReadPtr( ((const LPVOID)(ptr)),(len)) : FALSE)
#define ISRPTROK(ptr)        (ISRPTROKLEN((ptr),1))
#define ISRPTROKS(ptr)       (ISRPTROKLEN((ptr),sizeof(*(ptr))))
#define ISWPTROKLEN(ptr,len) (ptr ? FALSE==IsBadWritePtr(((LPVOID)(ptr)),(len)) : FALSE)
#define ISWPTROK(ptr)        (ISWPTROKLEN((ptr),1))
#define ISWPTROKS(ptr)       (ISWPTROKLEN((ptr),sizeof(*(ptr))))
#define ISRPTROKLEN_NULLOK(ptr,len) ((NULL == ((const LPVOID)(ptr))) ? TRUE : ISRPTROKLEN(ptr,len))
#define ISRPTROK_NULLOK(ptr)        (ISRPTROKLEN_NULLOK((ptr),1))
#define ISRPTROKS_NULLOK(ptr)       (ISRPTROKLEN_NULLOK((ptr),sizeof(*(ptr))))
#define ISWPTROKLEN_NULLOK(ptr,len) ((NULL == ((LPVOID)(ptr))) ? TRUE : ISWPTROKLEN(ptr,len))
#define ISWPTROK_NULLOK(ptr)        (ISWPTROKLEN_NULLOK((ptr),1))
#define ISWPTROKS_NULLOK(ptr)       (ISWPTROKLEN_NULLOK((ptr),sizeof(*(ptr))))
#define ISHUGERPTROKLEN(ptr,len) (ptr ? FALSE==IsBadHugeReadPtr(((const void _huge *)(ptr)),(len)) : FALSE)
#define ISHUGERPTROK(ptr)        (ISHUGERPTROKLEN((ptr),1))
#define ISHUGERPTROKS(ptr)       (ISHUGERPTROKLEN((ptr),sizeof(*(ptr))))
#define ISHUGEWPTROKLEN(ptr,len) (ptr ? FALSE==IsBadHugeWritePtr(((void _huge *)(ptr)),(len)) : FALSE)
#define ISHUGEWPTROK(ptr)        (ISHUGEWPTROKLEN((ptr),1))
#define ISHUGEWPTROKS(ptr)       (ISHUGEWPTROKLEN((ptr),sizeof(*(ptr))))
#define ISHUGERPTROKLEN_NULLOK(ptr,len) ((NULL == ((const void _huge *)(ptr))) ? TRUE : ISHUGERPTROKLEN(ptr,len))
#define ISHUGERPTROK_NULLOK(ptr)        (ISHUGERPTROKLEN_NULLOK((ptr),1))
#define ISHUGERPTROKS_NULLOK(ptr)       (ISHUGERPTROKLEN_NULLOK((ptr),sizeof(*(ptr))))
#define ISHUGEWPTROKLEN_NULLOK(ptr,len) ((NULL == (((void _huge *))(ptr))) ? TRUE : ISHUGEWPTROKLEN(ptr,len))
#define ISHUGEWPTROK_NULLOK(ptr)        (ISHUGEWPTROKLEN_NULLOK((ptr),1))
#define ISHUGEWPTROKS_NULLOK(ptr)       (ISHUGEWPTROKLEN_NULLOK((ptr),sizeof(*(ptr))))
#if defined (_MSC_VER)
   #if defined (_WIN32)
      #if defined (MAKEDLL)
         #define ASWCALLBACK      __declspec(dllexport)
         #define ASWPUBCLASS
         #define ASWPUBMETHOD     __declspec(dllexport)
         #define ASWPUBFUNC       __declspec(dllexport) __cdecl
         #define ASWPUBFUNC2      __declspec(dllexport) __stdcall
         #define ASWPRIVCLASS
         #define ASWPTR
         #define ASWPUBOLEMETHOD  __declspec(dllexport)
         #define ASWEXPORTEDDATA  __declspec(dllexport)
      #else
         #define ASWCALLBACK
         #define ASWPUBCLASS
         #define ASWPUBMETHOD
         #define ASWPUBFUNC       __cdecl
         #define ASWPUBFUNC2      __stdcall
         #define ASWPRIVCLASS
         #define ASWPTR
         #define ASWPUBOLEMETHOD
         #define ASWEXPORTEDDATA  
      #endif
   #else
      #if defined (MAKEDLL)
         #define ASWCALLBACK     __far __export
         #define ASWPUBCLASS     __far
         #define ASWPUBMETHOD    __far __export
         #define ASWPUBFUNC      __far __export __cdecl
         #define ASWPUBFUNC2     __far __export __cdecl
         #define ASWPRIVCLASS    __far
         #define ASWPTR          __far
         #define ASWPUBOLEMETHOD
         #define ASWEXPORTEDDATA __export
      #else
         #define ASWCALLBACK     __far __export
         #define ASWPUBCLASS     __far
         #define ASWPUBMETHOD    __far
         #define ASWPUBFUNC      __far __cdecl
         #define ASWPUBFUNC2     __far __cdecl
         #define ASWPRIVCLASS    __far
         #define ASWPTR          __far
         #define ASWPUBOLEMETHOD
         #define ASWEXPORTEDDATA 
      #endif
   #endif
   #if defined(UNICODE)
   #else
      #if defined(_WIN32) && !defined(LTSOS2)
         #define ASWWSPRINTFW    swprintf
         #define ASWLSTRLENW     wcslen
         #define ASWLSTRCPYW     wcscpy
         #define ASWLSTRCPYNW    wcsncpy
         #define ASWLSTRCATW     wcscat
         #define ASWLSTRCMP      wcscmp
      #else
         #define ASWWSPRINTFW    wsprintf
         #define ASWLSTRLENW     lstrlen
         #define ASWLSTRCPYW     lstrcpy
         #define ASWLSTRCPYNW    lstrcpyn
         #define ASWLSTRCATW     lstrcat
         #define ASWLSTRCMP      lstrcmp
      #endif
   #endif
   #if defined(_WIN32) && !defined(LTSOS2)
      typedef WCHAR ASWOLECHAR;
      typedef  ASWOLECHAR __RPC_FAR *LPASWOLESTR;
      typedef  const ASWOLECHAR __RPC_FAR *LPASWCOLESTR;
      typedef  ASWOLECHAR __RPC_FAR *__RPC_FAR *ASWSNB;  
      #define ASWOLESTR(str) L##str
      #define ASWDEVMODE    DEVMODEW
      #define PAWSDEVMODE   PDEVMODEW
      #define NPASWDEVMODE  NPDEVMODEW
      #define LPASWDEVMODE  LPDEVMODEW
   #else
      typedef char ASWOLECHAR;
      typedef ASWOLECHAR FAR* LPASWOLESTR;
      typedef const ASWOLECHAR FAR* LPASWCOLESTR;
      #define ASWOLESTR(str) str
      #define  ASWSNB SNB   
      #define ASWDEVMODE    DEVMODE
      #define PAWSDEVMODE   PDEVMODE
      #define NPASWDEVMODE  NPDEVMODE
      #define LPASWDEVMODE  LPDEVMODE
   #endif
#elif defined(__IBMCPP__) || defined(__IBMC__)
   #if defined (_WIN32)
      #if defined (MAKEDLL)
         #define ASWCALLBACK      __declspec(dllexport)
         #define ASWPUBCLASS
         #define ASWPUBMETHOD     __declspec(dllexport)
         #define ASWPUBFUNC       __declspec(dllexport) __cdecl
         #define ASWPUBFUNC2      __declspec(dllexport) __stdcall
         #define ASWPRIVCLASS
         #define ASWPTR
         #define ASWPUBOLEMETHOD  __declspec(dllexport)
         #define ASWEXPORTEDDATA  __declspec(dllexport)
      #else
         #define ASWCALLBACK
         #define ASWPUBCLASS
         #define ASWPUBMETHOD
         #define ASWPUBFUNC       __cdecl
         #define ASWPUBFUNC2      __stdcall
         #define ASWPRIVCLASS
         #define ASWPTR
         #define ASWPUBOLEMETHOD
         #define ASWEXPORTEDDATA  
      #endif
   #else
      #error 16bit is not supported by IBM VisualAge++
   #endif
   #if defined(UNICODE)
   #else
      #if defined(_WIN32) && !defined(LTSOS2)
         #define ASWWSPRINTFW    swprintf
         #define ASWLSTRLENW     wcslen
         #define ASWLSTRCPYW     wcscpy
         #define ASWLSTRCPYNW    wcsncpy
         #define ASWLSTRCATW     wcscat
         #define ASWLSTRCMP      wcscmp
      #else
         #define ASWWSPRINTFW    wsprintf
         #define ASWLSTRLENW     lstrlen
         #define ASWLSTRCPYW     lstrcpy
         #define ASWLSTRCPYNW    lstrcpyn
         #define ASWLSTRCATW     lstrcat
         #define ASWLSTRCMP      lstrcmp
      #endif
   #endif
   #if defined(_WIN32) && !defined(LTSOS2)
      typedef WCHAR ASWOLECHAR;
      typedef  ASWOLECHAR __RPC_FAR *LPASWOLESTR;
      typedef  const ASWOLECHAR __RPC_FAR *LPASWCOLESTR;
      typedef  ASWOLECHAR __RPC_FAR *__RPC_FAR *ASWSNB;  
      #define ASWOLESTR(str) L##str
      #define ASWDEVMODE    DEVMODEW
      #define PAWSDEVMODE   PDEVMODEW
      #define NPASWDEVMODE  NPDEVMODEW
      #define LPASWDEVMODE  LPDEVMODEW
   #else
      typedef char ASWOLECHAR;
      typedef ASWOLECHAR FAR* LPASWOLESTR;
      typedef const ASWOLECHAR FAR* LPASWCOLESTR;
      #define ASWOLESTR(str) str
      #define  ASWSNB SNB   
      #define ASWDEVMODE    DEVMODE
      #define PAWSDEVMODE   PDEVMODE
      #define NPASWDEVMODE  NPDEVMODE
      #define LPASWDEVMODE  LPDEVMODE
   #endif
#else
   this->only( works( with( the( IBM VisualAge++ or Microsoft( compiler ) ) ) ) );
#endif
#if defined (ASWDLL)
   #if defined (_WIN32)
      #define ASWCLIENTMETHOD
   #else
      #define ASWCLIENTMETHOD    __export
   #endif
#else
   #define ASWCLIENTMETHOD
#endif
#define TYPEDEFLP( Thing ) typedef Thing  FAR * LP##Thing
#define TYPEDEFNP( Thing ) typedef Thing NEAR * NP##Thing
#define TYPEDEFP( Thing )  typedef Thing      *  P##Thing
TYPEDEFLP(UINT);
TYPEDEFLP(ULONG);
TYPEDEFLP(LARGE_INTEGER);
TYPEDEFLP(ULARGE_INTEGER);
TYPEDEFLP(STATSTG);
TYPEDEFP(STATSTG);
TYPEDEFLP(FILETIME);
TYPEDEFLP(DVTARGETDEVICE);
typedef void ASWPTR * PASWVOID;
typedef REFIID ASWREFIID;
#define FORWARD_CLASS_REF( classname, ptrname) \
class ASWPUBCLASS classname ;\
typedef classname ASWPTR * PASW##ptrname ;\
typedef const classname ASWPTR * PCASW##ptrname ;\
typedef PASW##ptrname ASWPTR * PPASW##ptrname
#endif
