/* NOSHIP */
/*****************************************************************************
 *
 * asevents.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswEventSink, CAswStdEventSink
 *
 * Description:
 *      The connection manager classes in this file are used by classes which
 * provide an outgoing interface, and need a common mechanism for pushing and
 * managing the connection.
 *
 *****************************************************************************/

#ifndef ASEVENTS_H
#define ASEVENTS_H
#include <aspack.h>
class ASWPUBCLASS CAswEventSink : public CAswCOMBase
{
public:
   ASWPUBMETHOD CAswEventSink( PASWCONTROL pControl, LPUNKNOWN punkOuter=NULL );
   ASWPUBMETHOD ~CAswEventSink( void );
   CAswResult ASWPUBMETHOD Setup( PASWBASE pConnectingComponent );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   inline CAswResult GetPrimaryEventsIID( LPIID piid )
   {
      CAswResult ar(S_OK,ASD_OK);
      return( GetParent()->GetIIDbyFlags( piid,
                        IMPLTYPEFLAG_FDEFAULT | IMPLTYPEFLAG_FSOURCE));
   }
   inline CAswResult ASWPUBMETHOD Connect(REFIID riid)
   {
      CAswResult ar(S_OK,ASD_OK);
      ar = m_AutoConnMgr.Connect(riid, GetEventsIDispatch() );
      if (ASWSUCCEEDED(ar))
      {
#if 1
         SetEventSetIID(riid);
#else
         m_pIID = &riid;
#endif
      }
      return(ar);
   }
   inline PASWBASE GetParent(void)
   {
      return(m_AutoConnMgr.GetParent());
   }
   inline REFIID GetEventSetIID(void)
   {
      return(m_iidEventSet);
   }
   virtual CAswResult Invoke(
             DISPID dispidMember,
             REFIID riid,
             LCID lcid,
             WORD wFlags,
             DISPPARAMS __RPC_FAR *pdispparams,
             VARIANT __RPC_FAR *pvarResult,
             EXCEPINFO __RPC_FAR *pexcepinfo,
             UINT __RPC_FAR *puArgErr) PURE;
   virtual HRESULT ASWPUBOLEMETHOD STDMETHODCALLTYPE
   QueryInterface(REFIID riid, LPVOID ASWPTR* ppvObj);
protected:                          
   IID m_iidEventSet;               
private:
   ASWAN_DECLARATIONS(1);
   inline PASWBASE GetConnectingComponent(void)
   {
      return(m_AutoConnMgr.GetConnectingComponent());
   }
   inline BOOL IsSetup(void)
   {
      return( NULL != GetConnectingComponent() );
   }
   inline BOOL IsEventSetIID(REFIID riid)
   {
      return( riid == m_iidEventSet );
   }
   inline void SetEventSetIID(REFIID riid)
   {
      m_iidEventSet = riid;
   }
   inline LPUNKNOWN GetEventsIDispatch(void)
   {
      return( &m_idispEvents );
   }
   CAswAutoConnMgr m_AutoConnMgr;   
   CAswIDispatchEventsImpl m_idispEvents;
   BOOL m_fSetup;                   
   PASWBASE m_pConnectingComponent; 
};
class ASWPUBCLASS CAswStdEventSink : public CAswEventSink
{
public:
   ASWPUBMETHOD CAswStdEventSink( PASWCONTROL pControl );
   ASWPUBMETHOD ~CAswStdEventSink( void );
   CAswResult ASWPUBMETHOD Setup( PASWBASE pConnectingComponent );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   CAswResult ASWPUBMETHOD Connect( void );
   CAswResult ASWPUBMETHOD Click(void);
   CAswResult ASWPUBMETHOD DblClick(void);
   CAswResult ASWPUBMETHOD Error(short sNumber, BSTR *bstrDescription,
      SCODE scode, BSTR bstrSource, BSTR bstrHelpFile, long lHelpContext,
      BOOL *pfCancelDisplay);
   virtual CAswResult ASWPUBMETHOD Invoke(
             DISPID dispidMember,
             REFIID riid,
             LCID lcid,
             WORD wFlags,
             DISPPARAMS __RPC_FAR *pdispparams,
             VARIANT __RPC_FAR *pvarResult,
             EXCEPINFO __RPC_FAR *pexcepinfo,
             UINT __RPC_FAR *puArgErr);
   virtual LPSTR ASWPUBMETHOD StdEventName( DISPID dispidMember );
private:
};
#include <aspop.h>
#endif 
