/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswDataObjectImpl2
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Implementation of the IDataObject class for CAswObjectInstance. This
 *    class is designed as an abstract base class for generic data objects.
 *
 *    To use this class, you must provide a subclass that implements the
 *    PURE methods (SetData, GetData, and FindFormatSet).
 *
 *****************************************************************************/

#ifndef ASIDATA2_H
#define ASIDATA2_H
#include <aspack.h>
class CAswDataObjectImpl2 : public CAswIDataObject
{
public:
   CAswDataObjectImpl2(PASWCONTROL pCtl,PASWCOMBASE pCOMBase);
   ~CAswDataObjectImpl2(void);
   CAswResult Setup(BOOL fDataTransferObject = FALSE);
   virtual CAswResult Shutdown(BOOL fEmergency = FALSE);
   STDMETHOD(GetData) (LPFORMATETC pformatetcIn,LPSTGMEDIUM pmedium);
   STDMETHOD(GetDataHere) (LPFORMATETC pformatetc,LPSTGMEDIUM pmedium);
   STDMETHOD(QueryGetData) (LPFORMATETC pformatetc);
   STDMETHOD(GetCanonicalFormatEtc) (LPFORMATETC   pformatetc,
                                     LPFORMATETC   pformatetcOut);
   STDMETHOD(SetData) (LPFORMATETC  pformatetc,
                       LPSTGMEDIUM  pmedium,
                       BOOL         fRelease);
   STDMETHOD(EnumFormatEtc) (DWORD                 dwDirection,
                             LPENUMFORMATETC FAR*  ppenumFormatEtc);
   STDMETHOD(DAdvise) (LPFORMATETC     pFormatetc,
                       DWORD           advf, 
                       LPADVISESINK    pAdvSink,
                       LPDWORD         pdwConnection);
   STDMETHOD(DUnadvise) (DWORD dwConnection);
   STDMETHOD(EnumDAdvise) (LPENUMSTATDATA FAR* ppenumAdvise);
   virtual CAswResult SetData(LPFORMATETC       lpFormatEtc, 
                              PASWSTGMEDUNION   pAswStgMedium);
   virtual CAswResult GetData(LPFORMATETC     lpFormatEtc, 
                              PASWSTGMEDUNION pAswStgMedium) PURE;
   CAswResult SendOnDataChange(DWORD advf = NULL);
   inline void ReleaseDataAdviseHolder(void)
   {
      m_rhDataAdviseHolder.Release();
   }
private:
   virtual PASWSOURCEFORMATSET FindFormatSet(void) PURE;
   BOOL           m_fSetup;               
   BOOL           m_fDataTransferObject;  
   CAswRefHolder  m_rhDataAdviseHolder;   
};
#include <aspop.h>
#endif
