/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswMenuBase
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    This base class defines the interface between Aswan and the user
 *    replaceable class CAswContMenu.  If you want to have custom menu
 *    processing you should subclass the CAswContMenu class which is
 *    derived from CAswMenuBase.  The block diagram below shows the
 *    relationship between CAswContMenu, CAswMenuBase, and the rest of Aswan. 
 *
 *****************************************************************************/

#ifndef ASMENBS_H
#define ASMENBS_H
#include <aspack.h>
const UINT ASW_MAX_MENU_TEXT = 256;
class ASWPUBCLASS CAswMenuBase : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswMenuBase( PASWCONTROL pAswControl );
   ASWPUBMETHOD ~CAswMenuBase( void ); 
   CAswResult ASWPUBMETHOD Setup( void ); 
   virtual CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   virtual CAswResult InsertMenus( HMENU                 hmenuShared, 
                                   LPOLEMENUGROUPWIDTHS  lpMenuWidths) PURE; 
   virtual CAswResult SetMenu( HMENU      hmenuShared, 
                               HOLEMENU   holemenu, 
                               HWND       hwndActiveObject) PURE; 
   virtual CAswResult RemoveMenus( HMENU hmenuShared ) PURE; 
   inline void SetFrameWindow(PASWFRAMEWINDOW pAswFrameWindow)
   {
      m_pAswFrameWindow = pAswFrameWindow;
   }
   inline PASWFRAMEWINDOW GetFrameWindow(void) const
   {
      return m_pAswFrameWindow;
   }
private:
   PASWFRAMEWINDOW   m_pAswFrameWindow;
};
#include <aspop.h>
#endif   
