/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswObjectDescriptor
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Maintaina full description of an embedded Aswan object.
 *
 *****************************************************************************/

#ifndef ASODESCR_H
#define ASODESCR_H
#include <aspack.h>
class ASWPUBCLASS CAswObjectDescriptor : public CAswDebugBase
{
public:
   ASWPUBMETHOD CAswObjectDescriptor(PASWCONTROL pCtl);
   ASWPUBMETHOD ~CAswObjectDescriptor(void);
   CAswResult ASWPUBMETHOD Setup(void);
   CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE);
   BOOL ASWPUBMETHOD FillFromData(PASWDROPTARGET  pTgt);
   BOOL ASWPUBMETHOD FillFromData(PASWPASTETARGET pTgt);
   void ASWPUBMETHOD ClearDescriptor(void);
   BOOL ASWPUBMETHOD
   FillFromContainedObject(PASWCONTAINEDOBJECT  pCntObj,
                           PASWASPECT           pAswAspect,
                           LPASWOLESTR          pszSrcOfCopy = NULL,
                           POINTL ASWPTR*       pPointl = NULL,
                           LPSIZEL              pSizelHim = NULL);
   BOOL ASWPUBMETHOD
   FillFromObjectInstance(PASWOBJECTINSTANCE    pObjInst,
                          LPASWOLESTR           pszSrcOfCopy = NULL,
                          POINTL ASWPTR*        pPointl = NULL,
                          LPSIZEL               pSizelHim = NULL);
   BOOL ASWPUBMETHOD
   FillFromPseudoObject(PASWPSEUDOOBJECT        pPseudoObj,
                        LPASWOLESTR             pszSrcOfCopy = NULL,
                        POINTL ASWPTR*          pPointl = NULL,
                        LPSIZEL                 pSizelHim = NULL);
   BOOL ASWPUBMETHOD FillObjectDescriptor(CLSID       clsid,
                                          DWORD       dwAspect,
                                          SIZEL       sizel,
                                          POINTL      pointl,
                                          DWORD       dwStatus,
                                          LPASWOLESTR pszFullUserTypeName,
                                          LPASWOLESTR pszSrcOfCopy);
   void ASWPUBMETHOD SetOffsetPoint(POINTL ptlUpperLeft,POINTL ptlMouse);
   CAswResult ASWPUBMETHOD CopyTo(HGLOBAL ASWPTR* phMem);
   inline BOOL IsValid(void) const
   {
      return (NULL != m_hMem);
   }
   inline CLIPFORMAT GetClipFormat(void) const
   {
      return m_cf;
   }
   inline CLSID GetCLSID(void) const
   {
      return (IsValid()) ? m_pObjDescriptor->clsid : CLSID_NULL;
   }
   inline DWORD GetDrawAspect(void) const
   {
      return (IsValid()) ? m_pObjDescriptor->dwDrawAspect : 0;
   }
   inline SIZEL GetExtent(void) const
   {
      SIZEL sizel = { 0, 0 };
      return (IsValid()) ? m_pObjDescriptor->sizel : sizel;
   }
   inline POINTL GetOffsetPoint(void) const
   {
      POINTL ptl = { 0, 0 };
      return (IsValid()) ? m_pObjDescriptor->pointl : ptl;
   }
   inline DWORD GetStatus(void) const
   {
      return (IsValid()) ? m_pObjDescriptor->dwStatus : 0;
   }
   inline LPCSTR GetFullUserTypeName(void) const
   {
      return (IsValid() && 0 < m_pObjDescriptor->dwFullUserTypeName)
         ? (LPCSTR)((LPBYTE)m_pObjDescriptor + m_pObjDescriptor->dwFullUserTypeName)
         : NULL;
   }
   inline LPCSTR GetSourceOfCopy(void) const
   {
      return (IsValid() && 0 < m_pObjDescriptor->dwSrcOfCopy)
         ? (LPCSTR)((LPBYTE)m_pObjDescriptor + m_pObjDescriptor->dwSrcOfCopy)
         : NULL;
   }
   BOOL ASWPUBMETHOD FillFromData(PCASWREFHOLDER prhData);
   BOOL ASWPUBMETHOD FillFromOleObject(PCASWREFHOLDER prhOleObject,
                                       PASWASPECT     pAswAspect,
                                       LPASWOLESTR    pszSrcOfCopy = NULL,
                                       POINTL ASWPTR* pPointl = NULL,
                                       LPSIZEL        pSizelHim = NULL);
   BOOL ASWPUBMETHOD FillFromOleObject(LPOLEOBJECT    pIOleObject,
                                       DWORD          dwAspect = DVASPECT_CONTENT,
                                       LPASWOLESTR    pszSrcOfCopy = NULL,
                                       POINTL ASWPTR* pPointl = NULL,
                                       LPSIZEL        pSizelHim = NULL);
private:
   HGLOBAL              m_hMem;
   CLIPFORMAT           m_cf;
   STGMEDIUM            m_medium;
   LPOBJECTDESCRIPTOR   m_pObjDescriptor;
};
#include <aspop.h>
#endif
