/* NOSHIP */
/*****************************************************************************
 *
 * asrefh.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswRefHolder
 *
 * Description:
 *      The class in this file is used whereever Aswan or an Aswan user
 *      is holding a reference to a COM IUnknown.  This class is responsible
 *      for proper reference counting of the object.
 *
 *****************************************************************************/

#ifndef ASREFH_H
#define ASREFH_H
#include <aspack.h>
#ifdef ASWANDEBUG
#define RHNAME(MEMBER, NAME, CHANNEL)                                      \
   {                                                                       \
      MEMBER.SetName(NAME);                                                \
                         \
   }
#else
#define RHNAME(MEMBER, NAME, CHANNEL)
#endif 
class ASWPUBCLASS CAswRefHolder : public CAswDebugBase
{
public:
   ASWPUBMETHOD CAswRefHolder( PASWCONTROL pControl );
   ASWPUBMETHOD ~CAswRefHolder( void );
   CAswResult ASWPUBMETHOD Setup( void );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   CAswResult ASWPUBMETHOD SetFromQuery( PASWBASE pAswBase, REFIID riid );
   CAswResult ASWPUBMETHOD SetFromQuery( PASWREFHOLDER prhHolderToQuery,
                                         REFIID riid );
   CAswResult ASWPUBMETHOD SetFromQuery( LPUNKNOWN pUnknownToQuery,
                                         REFIID riid );
   inline CAswResult SetGivenInterface( LPUNKNOWN pInterface );
   inline CAswResult SetGivenInterface( LPUNKNOWN pInterface,
                                        REFIID riid,
                                        BOOL bCheckInProduction = FALSE );
   inline CAswResult SetReturnedInterface( LPUNKNOWN pInterface );
   inline CAswResult SetReturnedInterface( LPUNKNOWN pInterface,
                                           REFIID riid,
                                           BOOL bCheckInProduction = FALSE );
   CAswResult ASWPUBMETHOD SetGivenOrReturnedInterface( LPUNKNOWN pInterface,
                                           const IID  FAR * const lpIid,
                                           BOOL bGivenInterface,
                                           BOOL bOnlyCheckInDebugMode );
   inline LPUNKNOWN Get( void ) const;
   void ASWPUBMETHOD Release( void );
   CAswResult ASWPUBMETHOD CheckIID( REFIID riid, BOOL bReportAsAssert ) const;
   inline BOOL IsSet(void) const
   {
      return (NULL != m_lpUnknown);
   }
#ifdef ASWANDEBUG
   virtual LPCSTR GetAswanClassName( void ) const;
   void SetName( LPSTR szName );
#endif
private:
   void SetInterface( LPUNKNOWN pInterface );
   LPUNKNOWN  m_lpUnknown;       
   #ifdef ASWANDEBUG
   char m_szName[ MAX_ASWCLASSNAME + MAX_ASWCLASSNAME + 1 ];
   #endif 
};
inline
LPUNKNOWN CAswRefHolder::Get( void ) const
{
   ASWMETHOD("Get", (CH_CLASS_ASREFH));
   ASWENTRY();
   ASWEXITF(m_lpUnknown, "Returns pUnknown=%p", (ASWSTR, m_lpUnknown));
}
inline
CAswResult CAswRefHolder::SetGivenInterface(LPUNKNOWN pInterface)
{
  return SetGivenOrReturnedInterface(pInterface, NULL, TRUE, FALSE);
};
inline
CAswResult CAswRefHolder::SetGivenInterface(LPUNKNOWN pInterface, REFIID riid,
                         BOOL bCheckInProduction)
{
  return SetGivenOrReturnedInterface( pInterface, &riid,
                                      TRUE, bCheckInProduction);
};
inline
CAswResult CAswRefHolder::SetReturnedInterface(LPUNKNOWN pInterface)
{
  return SetGivenOrReturnedInterface(pInterface, NULL, FALSE, FALSE);
};
inline
CAswResult CAswRefHolder::SetReturnedInterface(LPUNKNOWN pInterface,
                           REFIID riid, BOOL bOnlyCheckInDebugMode)
{
  return SetGivenOrReturnedInterface(pInterface, &riid, FALSE,
                            bOnlyCheckInDebugMode);
};
#include <aspop.h>
#endif 
