/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswResize
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Aswan Toolkit class that wrappers IOleHints and IOleOPResize 
 *    interfaces.  These interfaces are NOT standard OLE interface. They were
 *    designed by Lotus to help over come the short comings of the OLE resize 
 *    protocol 
 *    
 *
 *****************************************************************************/

#ifndef ASRESIZE_H
#define ASRESIZE_H
#include <aspack.h>
class ASWPUBCLASS CAswResize : public CAswBase
{
public:
   enum enumHINT_PROPERTYID
   {
      propidProportionalSizing,
      propidClipScale,
      propidAdjustingExtents,
      propidWakeUpEnlarge,
      propidWakeUpShrink,
      propidFastMetafileDraw,
      propidResizeFeedbackWhenActive,
      propidMinExtent,
      propidMaxExtent
   }; 
   enum enumPROPORTIONALSIZING
   {
      propsizeRequired,
      propsizePreferred,
      propsizeNone
   };
   enum enumCLIPSCALE
   {
      clipscaleScale,
      clipscaleClip_any,
      clipscaleClip_lowerright,
      clipscaleFixed
   };
   typedef struct tagLOTUSRESIZEHINTS
   {
   SIZEL                   m_sizelMinExtent;
   SIZEL                   m_sizelMaxExtent;
   enumPROPORTIONALSIZING  m_nPropSizing;    
   enumCLIPSCALE           m_nClipScale;        
   int                     m_nWakeUpOnEnlarge;
   int                     m_nWakeUpOnShrink;
   int                     m_nFastMetafileRedraw;
   int                     m_nResizeFeedback;
   int                     m_nAdjustingExtents;
   } LOTUSRESIZEHINTS;
   typedef LOTUSRESIZEHINTS ASWPTR * PLOTUSRESIZEHINTS;
public: 
   ASWPUBMETHOD CAswResize( PASWCONTROL pAswControl );
   virtual ASWPUBMETHOD ~CAswResize(void);
   CAswResult ASWPUBMETHOD Setup( PASWASPECT pAswAspect );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency ); 
   CAswResult ASWPUBMETHOD GetResizeHint( UINT uHintId, int *pnValue );
   CAswResult ASWPUBMETHOD GetResizeHint( UINT uHintId, SIZEL *psizelValue );
   void ASWPUBMETHOD SetResizeHint( UINT uHintId, int nValue );
   void ASWPUBMETHOD SetResizeHint( UINT uHintId, SIZEL sizelValue );
   CAswResult ASWPUBMETHOD CacheResizeHintSet(void);
   CLIPFORMAT ASWPUBMETHOD GetLotusResizeHintFormat(void);
private:
   BOOL RegisterResizeHintFormat(void);
   CAswResult GetResizeHintSet(void);
private:
   PASWASPECT              m_pAswAspect;
   LPUNKNOWN               m_lpUnknownOuter;
   CLIPFORMAT       m_cfHintsFormat;
   HGLOBAL                 m_hGlobalHints;
   PLOTUSRESIZEHINTS       m_pGlobalHints;
};
#include <aspop.h>
#endif   
