/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswShutdown
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Toolkit developers should contain this object in all objects that
 *    require shutdown procesing. This class is designed to be contained
 *    in classes require special shutdown processing.
 *
 *    See the Aswan Toolkit doc for a complete description of how to
 *    use this class.
 *
 *****************************************************************************/

#ifndef ASSHUTDN_H
#define ASSHUTDN_H
#include <aspack.h>
class ASWPUBCLASS CAswShutdown : public CAswDebugBase
{
public:
   ASWPUBMETHOD CAswShutdown(PASWCONTROL pControl,PASWBASE pOuter);
   ASWPUBMETHOD ~CAswShutdown(void);
   CAswResult ASWPUBMETHOD Setup(void);
   CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE);
   PASWSHUTDOWN ASWPUBMETHOD GetShutdownParent(void);
   CAswResult ASWPUBMETHOD AddLock(void);
   void ASWPUBMETHOD ReleaseLock(void);
   inline BOOL IsShutdownOK(void)
   {
      return (0 == m_ulLockCount);
   }
   inline void SetInProgress(BOOL fInProgress = TRUE)
   {
      m_fInProgress = fInProgress;
   }
private:
   ULONG          m_ulLockCount;    
   BOOL           m_fInProgress;    
   PASWBASE const m_pOuter;         
};
#include <aspop.h>
#endif   
