/* NOSHIP */
/*****************************************************************************
 *
 * asstpwch.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *
 *      CAswStopWatch
 *      CAswStopWatch3B
 *      CAswWatch
 *
 * ===========================================================================
 *
 * Class  CAswStopWatch
 *
 *    A simple CAswStopWatch class supporting Start and Stop, much like a
 *    simple two-button stopwatch.
 *
 *    This should prove handy in performance analysis.
 *
 *    It is NOT intended to be used in the production build of Aswan ! For
 *    this reason, the class is UNDEFINED in non-debug builds.  This will
 *    force compile-time errors wherever this class is used.
 *
 * ===========================================================================
 *
 * Class  CAswStopWatch3B
 *
 *    A three-button stopwatch, like CAswStopWatch, adds Reset.
 *
 *****************************************************************************/

#if !defined (ASSTPWCH_H)
#define ASSTPWCH_H
#include <aspack.h>
#if defined (WIN16)
   #include <toolhelp.h>
#else
#if defined(__IBMCPP__) || defined(__IBMC__)
#pragma message( "largeint.h is not included for IBM Visual Age builds" )
struct LI_to_LLI
{
   union 
   { 
      LARGE_INTEGER li;
      long long int lli;
   }; 
};
#define ExtendedLargeIntegerDivide(Dividend,Divisor,Remainder) lliExtendedLargeIntegerDivide(Dividend,Divisor,Remainder)
inline LARGE_INTEGER
lliExtendedLargeIntegerDivide( LARGE_INTEGER Dividend,
                               ULONG         Divisor,
                               PULONG        Remainder )
{
   LI_to_LLI lli_dividend;
   lli_dividend.li = Dividend;
   LI_to_LLI lli_divisor;
   lli_divisor.li.u.HighPart = 0;
   lli_divisor.li.u.LowPart = Divisor;
   lldiv_t lldiv_res;
   lldiv_res = lldiv( lli_dividend.lli, lli_divisor.lli );
   if ( Remainder )
   {
      LARGE_INTEGER liremainder;
      LI_to_LLI lliremainder;
      lliremainder.lli = lldiv_res.rem;
      *Remainder = lliremainder.li.u.LowPart;
   }
   LI_to_LLI ret;
   ret.lli = lldiv_res.quot;
   return ( ret.li );
}
#define LargeIntegerDivide(Dividend,Divisor,Remainder) lliLargeIntegerDivide(Dividend,Divisor,Remainder)
inline LARGE_INTEGER
lliLargeIntegerDivide( LARGE_INTEGER  Dividend,
                       LARGE_INTEGER  Divisor,
                       PLARGE_INTEGER Remainder )
{
   LI_to_LLI lli_dividend;
   lli_dividend.li = Dividend;
   LI_to_LLI lli_divisor;
   lli_divisor.li = Divisor;
   lldiv_t lldiv_res;
   lldiv_res = lldiv( lli_dividend.lli, lli_divisor.lli );
   if ( Remainder )
   {
      LARGE_INTEGER liremainder;
      LI_to_LLI lliremainder;
      lliremainder.lli = lldiv_res.rem;
      *Remainder = lliremainder.li;
   }
   LI_to_LLI ret;
   ret.lli = lldiv_res.quot;
   return ( ret.li );
}
#define ConvertLongToLargeInteger( SignedInteger ) lliConvertLongToLargeInteger( SignedInteger )
inline LARGE_INTEGER
ConvertLongToLargeInteger( LONG SignedInteger )
{
   LARGE_INTEGER ret;
   ret.u.LowPart = SignedInteger;
   if ( SignedInteger < 0 )
      ret.u.HighPart = -1;
   else
      ret.u.HighPart = 0;
   return ret;
}
#define LargeIntegerSubtract(Minuend,Subtrahend) lliLargeIntegerSubtract(Minuend,Subtrahend)
inline LARGE_INTEGER
lliLargeIntegerSubtract( LARGE_INTEGER Minuend,
                         LARGE_INTEGER Subtrahend )
{
   LI_to_LLI lliM;
   LI_to_LLI lliS;
   LI_to_LLI lliRes;
   lliM.li = Minuend;
   lliS.li = Subtrahend;
   lliRes.lli = lliM.lli - lliS.lli;
   return ( lliRes.li );
}
#define LargeIntegerAdd(Addend1,Addend2) lliLargeIntegerAdd(Addend1,Addend2)
inline LARGE_INTEGER
lliLargeIntegerAdd( LARGE_INTEGER Addend1,
                    LARGE_INTEGER Addend2 )
{
   LI_to_LLI lliM;
   LI_to_LLI lliS;
   LI_to_LLI lliRes;
   lliM.li = Addend1;
   lliS.li = Addend2;
   lliRes.lli = lliM.lli + lliS.lli;
   return ( lliRes.li );
}
#define LargeIntegerEqualToZero(X) ( \
    !((X).LowPart | (X).HighPart)       \
)
#else
   #include <largeint.h>
#endif   
#endif   
#pragma warning(disable:4705)
#if defined(WIN16)
class CAswTimerInfo : public CAswMemoryBase
{
public:
   inline CAswTimerInfo( void )
   {
      m_ti.dwSize = sizeof(TIMERINFO);
   }
   DWORD TimerCount( void )
   {
      ::TimerCount( &m_ti );
      return ( m_ti.dwmsSinceStart );
   }
private:
   TIMERINFO m_ti;
};
#endif
#if defined (_WIN32) && defined(LTSOS2)
BOOL QueryPerformanceCounter( LARGE_INTEGER * );
BOOL QueryPerformanceFrequency( LARGE_INTEGER * );
#endif
class ASWPUBCLASS CAswStopWatch : public CAswMemoryBase
{
public:
   inline CAswStopWatch( void )
   {
   #if defined (_WIN32)
      LARGE_INTEGER liCountsPerSecond;
      QueryPerformanceFrequency( &liCountsPerSecond );
      m_liCountsPerMillisecond = ExtendedLargeIntegerDivide( liCountsPerSecond, 
                                                             (ULONG) 1000L, 
                                                             NULL );
      if ( LargeIntegerEqualToZero( m_liCountsPerMillisecond ) )
      {
         ASWGLOBALASSERT( FALSE );
         m_liCountsPerMillisecond = ConvertLongToLargeInteger( 1 );
      }
   #endif
   }
   inline void Start( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      m_dwmsStartTime = ti.TimerCount();
   #else
      QueryPerformanceCounter( & m_liStartTime );
   #endif
   }
   inline DWORD Stop( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      return ( ti.TimerCount() - m_dwmsStartTime );
   #else
      LARGE_INTEGER liCount;
      QueryPerformanceCounter( &liCount );
      liCount = LargeIntegerSubtract( liCount, m_liStartTime );
      liCount = LargeIntegerDivide( liCount, m_liCountsPerMillisecond, NULL );
      ASWGLOBALASSERT( 0 == liCount.u.HighPart );
      return ( liCount.u.LowPart );
   #endif
   }
private:
#if defined (WIN16)
   DWORD       m_dwmsStartTime;
#else
   LARGE_INTEGER m_liStartTime;
   LARGE_INTEGER m_liCountsPerMillisecond;
#endif   
};
class ASWPUBCLASS CAswStopWatch3B : public CAswMemoryBase
{
public:
   inline CAswStopWatch3B( void )
   {
   #if defined (_WIN32)
      LARGE_INTEGER liCountsPerSecond;
      QueryPerformanceFrequency( &liCountsPerSecond );
      m_liCountsPerMillisecond = ExtendedLargeIntegerDivide( liCountsPerSecond, 
                                                             (ULONG) 1000L, 
                                                             NULL );
      if ( LargeIntegerEqualToZero( m_liCountsPerMillisecond ) )
      {
         ASWGLOBALASSERT( FALSE );
         m_liCountsPerMillisecond = ConvertLongToLargeInteger( 1 );
      }
   #endif
      Reset();
   }
   inline void Start( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      m_dwmsStartTime = ti.TimerCount();
   #else
      QueryPerformanceCounter( & m_liStartTime );
   #endif
   }
   inline DWORD Stop( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      m_dwmsAccumulatedTime += ( ti.TimerCount() - m_dwmsStartTime );
      return ( m_dwmsAccumulatedTime );
   #else
      LARGE_INTEGER liCount;
      QueryPerformanceCounter( &liCount );
      m_liAccumulatedTime = LargeIntegerAdd( m_liAccumulatedTime,
                                             LargeIntegerSubtract( liCount,
                                                                   m_liStartTime ) );
      return ( AccumulatedMilliseconds() );
   #endif
   }
   inline void Reset( void )
   {
   #if defined (WIN16)
      m_dwmsAccumulatedTime = 0;
   #else
      m_liAccumulatedTime = ConvertLongToLargeInteger( 0 );
   #endif
   }
private:
#if defined (WIN16)
   DWORD       m_dwmsStartTime;
   DWORD       m_dwmsAccumulatedTime;
#else
   LARGE_INTEGER m_liStartTime;
   LARGE_INTEGER m_liAccumulatedTime;
   LARGE_INTEGER m_liCountsPerMillisecond;
   DWORD AccumulatedMilliseconds( void )
   {
      LARGE_INTEGER lims = LargeIntegerDivide( m_liAccumulatedTime, 
                                               m_liCountsPerMillisecond,
                                               NULL );
      ASWGLOBALASSERT( 0 == lims.u.HighPart );
      return ( lims.u.LowPart );
   }
#endif
};
class ASWPUBCLASS CAswWatch : public CAswMemoryBase
{
public:
   inline CAswWatch( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      m_dwmsStartTime = ti.TimerCount();
   #else
      LARGE_INTEGER liCountsPerSecond;
      QueryPerformanceFrequency( &liCountsPerSecond );
      m_liCountsPerPeriod = ExtendedLargeIntegerDivide( liCountsPerSecond, 
                                                        Frequency(), 
                                                        NULL );
      if ( LargeIntegerEqualToZero( m_liCountsPerPeriod ) )
      {
         ASWGLOBALASSERT( FALSE );
         m_liCountsPerPeriod = ConvertLongToLargeInteger( 1 );
      }
      QueryPerformanceCounter( & m_liStartTime );
   #endif
   }
   inline DWORD Read( void )
   {
   #if defined (WIN16)
      CAswTimerInfo ti;
      return ( ti.TimerCount() - m_dwmsStartTime );
   #else
      LARGE_INTEGER liCount;
      QueryPerformanceCounter( &liCount );
      LARGE_INTEGER lims = LargeIntegerDivide( LargeIntegerSubtract( liCount, 
                                                                     m_liStartTime ),
                                               m_liCountsPerPeriod,
                                               NULL );
      ASWGLOBALASSERT( 0 == lims.u.HighPart );
      return ( lims.u.LowPart );
   #endif
   }
   inline DWORD Frequency( void )
   {
   #if defined (WIN16)
      return ( 1000L );
   #else
      return ( 10000L );
   #endif
   }
private:
#if defined (WIN16)
   DWORD       m_dwmsStartTime;
#else
   LARGE_INTEGER m_liStartTime;
   LARGE_INTEGER m_liCountsPerPeriod;
#endif
};
#pragma warning(default:4705)
FORWARD_CLASS_REF( CAswStopWatch,   STOPWATCH );
FORWARD_CLASS_REF( CAswStopWatch3B, STOPWATCH3B );
FORWARD_CLASS_REF( CAswWatch,       WATCH );
#include <aspop.h>
#endif   
