/* NOSHIP */
/*****************************************************************************
 *
 * asstream.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswStream
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#if !defined( ASWAN_STREAM_H )
#define ASWAN_STREAM_H
#include <aspack.h>
class ASWPUBCLASS CAswStream : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswStream( PASWCONTROL pControl );
   ASWPUBMETHOD ~CAswStream();
   virtual CAswResult ASWPUBMETHOD Setup( void );
   virtual CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   LPASWCOLESTR ASWPUBMETHOD GetStreamName( void ) const;
   CAswResult ASWPUBMETHOD SetStreamName( LPASWCOLESTR lpStreamName );
   CAswResult ASWPUBMETHOD Read( LPVOID  pv,
                                 ULONG   cb,
                                 LPULONG pcbRead ) const;
   CAswResult ASWPUBMETHOD Write( LPVOID  pv,
                                  ULONG   cb,
                                  LPULONG pcbWritten ) const;
   CAswResult ASWPUBMETHOD Seek( LARGE_INTEGER    dlibMove,
                                 DWORD            dwOrigin,
                                 LPULARGE_INTEGER plibNewPosition ) const;
   CAswResult ASWPUBMETHOD SetSize( ULARGE_INTEGER libNewSize ) const;
   CAswResult ASWPUBMETHOD CopyTo( PASWSTREAM       pAswStm,
                                   ULARGE_INTEGER   cb,
                                   LPULARGE_INTEGER pcbRead,
                                   LPULARGE_INTEGER pcbWritten ) const;
   CAswResult ASWPUBMETHOD Stat( PASWSTATSTG pAswStatstg );
   CAswResult ASWPUBMETHOD Clone( PASWSTREAM pAswStream );
   CAswResult ASWPUBMETHOD Commit( DWORD grfCommitFlags = STGC_DEFAULT ) const;
   CAswResult ASWPUBMETHOD Revert( void ) const;
   CAswResult ASWPUBMETHOD LockRegion( ULARGE_INTEGER libOffset, 
                                       ULARGE_INTEGER cb,
                                       DWORD          dwLockType ) const;
   CAswResult ASWPUBMETHOD UnlockRegion( ULARGE_INTEGER libOffset, 
                                         ULARGE_INTEGER cb,
                                         DWORD dwLockType ) const;
   CAswResult 
   ASWPUBMETHOD GetRefHolder( PPASWREFHOLDER ppRefHolder );
   ASWREFIID ASWPUBMETHOD GetPreferredIID( void ) const;
   CAswResult ASWPUBMETHOD SetReturnedStream( LPSTREAM lpRealStream );
   CAswResult ASWPUBMETHOD SetGivenStream( LPSTREAM lpRealStream );
   inline LPSTREAM GetRealStream( void ) const
   {
      return ( GetLPStream() );
   }
   CAswResult ASWPUBMETHOD SetClass( REFCLSID clsid ) const;
   CAswResult ASWPUBMETHOD GetClass( LPCLSID lpclsid ) const;
private:
   inline LPSTREAM GetLPStream( void ) const
   {
      return( (LPSTREAM) m_RefHolderStream.Get() );
   }
   BOOL          m_fSetup;
   CAswOLEString m_StreamName;
   CAswRefHolder m_RefHolderStream;
};
#include <aspop.h>
#endif      
