/* NOSHIP */
/*****************************************************************************
 *
 * Class: CAswUIOleLink
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Description:
 *    Header file defining the CAswUIOleLink class.  This class implements the
 *    virtual base class CAswUILink, whose overridable callout methods support
 *    the Manage Links dialog box.  This implementation specifically supports
 *    linked CAswContainedObjects.  Users wishing to have other kinds of links
 *    appear in the Edit Links dialog should implement thier own class derived
 *    from CAswUILink.
 *
 *****************************************************************************/

#ifndef ASUIOELK_H
#define ASUIOELK_H
class ASWPUBCLASS CAswUIOleLink : public CAswUILinkBase
{
public:
   ASWPUBMETHOD CAswUIOleLink(PASWCONTROL pControl, 
                              PASWCONTAINEDOBJECT pAswContainedObject);
   virtual ASWPUBMETHOD ~CAswUIOleLink(void);
   CAswResult ASWPUBMETHOD Setup(PASWUILINKCONTAINER pUILinkContainer);
   virtual CAswResult ASWPUBMETHOD Shutdown(BOOL fEmergency = FALSE);
   virtual CAswResult ASWPUBMETHOD SetLinkUpdateOptions (DWORD dwUpdateOpt);
   virtual CAswResult ASWPUBMETHOD GetLinkUpdateOptions (LPDWORD lpdwUpdateOpt);
   virtual CAswResult ASWPUBMETHOD SetLinkSource (LPASWCOLESTR lpszDisplayName,
                                                  ULONG       lenFileName,
                                                  LPULONG     pchEaten,
                                                  BOOL        fValidateSource);
   virtual CAswResult ASWPUBMETHOD GetLinkSourceEx (LPASWOLESTR ASWPTR * lplpszLinkName,
                                              LPASWOLESTR ASWPTR * lplpszSourceName,
                                              LPULONG lplenFileName,
                                              LPASWOLESTR ASWPTR * lplpszFullLinkType, 
                                              LPASWOLESTR ASWPTR * lplpszShortLinkType,
                                              BOOL ASWPTR *  lpbSourceAvailable,
                                              BOOL ASWPTR *  lpbIsSelected,
                                              BOOL ASWPTR *  lpbIsBasket,
                                              LPDWORD lpdwSupportedMask);
   virtual CAswResult ASWPUBMETHOD OpenLinkSource (void);
   virtual CAswResult ASWPUBMETHOD UpdateLink (BOOL fErrorMessage,
                                               BOOL fErrorAction);
   virtual CAswResult ASWPUBMETHOD CancelLink (void);
private:
   CAswResult GetLinkSource (LPASWOLESTR ASWPTR* lplpszDisplayName,
                             ULONG ASWPTR*  lplenFileName,
                             LPASWOLESTR ASWPTR*  lplpszFullLinkType,
                             LPASWOLESTR ASWPTR*  lplpszShortLinkType,
                             BOOL ASWPTR*   lpfSourceAvailable,
                             BOOL ASWPTR*   lpfIsSelected);
   LPOLELINK GetIOleLinkInterface(void) const;
   BOOL ValidateLinkSource( LPASWCOLESTR pszName, ULONG ASWPTR *pchEaten,
                            LPMONIKER ASWPTR *ppmk, LPCLSID pclsID );
   BOOL CreateNewSourceMoniker( LPASWCOLESTR pszName, ULONG cchName, 
                                LPMONIKER ASWPTR *ppmk );
   PASWCONTAINEDOBJECT const  m_pAswContainedObject;
   PASWUILINKCONTAINER        m_pUILinkContainer;
   BOOL                       m_fIsSetup;
   CAswOLEString              m_aostrObjectName;
};
#endif
