/* NOSHIP */
/*****************************************************************************
 *
 * aswndbs.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswWindowBase
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#ifndef ASWAN_ASWNDBS_H
#define ASWAN_ASWNDBS_H
#include <aspack.h>
class ASWPUBCLASS TKOleInPlaceUIWindow : public CAswIOleInPlaceUIWindow
{
public:
   TKOleInPlaceUIWindow(PASWCONTROL pControl, PASWDOCWINDOW pDocWindow);
   STDMETHOD(GetWindow) (THIS_ HWND FAR* lphwnd);
   STDMETHOD(ContextSensitiveHelp) (THIS_ BOOL fEnterMode);
   STDMETHOD(GetBorder) (THIS_ LPRECT lprectBorder);
   STDMETHOD(RequestBorderSpace) (THIS_ LPCBORDERWIDTHS lpborderwidths);
   STDMETHOD(SetBorderSpace) (THIS_ LPCBORDERWIDTHS lpborderwidths);
   STDMETHOD(SetActiveObject) (THIS_ LPOLEINPLACEACTIVEOBJECT lpActiveObject,
                       LPCOLESTR lpszObjName);  
   inline PASWDOCWINDOW GetDocWindow()       
   {
      return m_pDocWindow;
   }
private:
   PASWDOCWINDOW m_pDocWindow;
};
class ASWPUBCLASS CAswWindowBase : public CAswCOMBase
{
public:
   ASWPUBMETHOD CAswWindowBase( PASWCONTROL pAswControl,
                                PMAPSTATE   pMapState,
                                LPUNKNOWN   pUnk = NULL );
   ASWPUBMETHOD ~CAswWindowBase(void);
   CAswResult ASWPUBMETHOD Setup( HWND hWnd, BOOL bTrueMDI );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   virtual void ASWPUBMETHOD IndicateInPlaceInCaption( BOOL   bActive,
                                                       LPASWCOLESTR lpszObjName );
   inline void MouseButtonDown(void)
   {
      ASWMETHOD("MouseButtonDown", (CH_CLASS_CASWWINDOWBASE));
      ASWENTRY();
      m_fProcessingDoubleClick = FALSE;      
      SetPendingUIDeactivate();
      ASWEXIT();
   }
   CAswResult ASWPUBMETHOD SetPendingUIDeactivate(void);
   enum PossibleActivation
   {
      ASW_POSSACTIVATE_NO          = 0,   
      ASW_POSSACTIVATE_YES         = 1,   
      ASW_POSSACTIVATE_TKDETERMINE = 2    
   };
   CAswResult ASWPUBMETHOD MouseButtonUp( PossibleActivation fActivateAnotherPossible =
                                             ASW_POSSACTIVATE_TKDETERMINE );
   CAswResult ASWPUBMETHOD DoUIDeactivate( PossibleActivation fActivateAnotherPossible =
                                             ASW_POSSACTIVATE_TKDETERMINE );
   inline void EndDblClkProcessing(void)
   {
      ASWMETHOD("EndDblClkProcessing", (CH_CLASS_CASWWINDOWBASE));
      ASWENTRY();
      m_fProcessingDoubleClick = TRUE;
      EndPossibleActivation();
      ASWEXIT();
   }
   void ASWPUBMETHOD EndPossibleActivation(void);
   inline void ForceEndDblClk(void)
   {
      m_fProcessingDoubleClick = FALSE;
   }
   virtual HRESULT ASWPUBMETHOD OnInPlaceActivatePassThru( PASWINPLACEPRESSITE pIPPresSite,
                                                           PASWREFHOLDER       pRefHoldOleInPlaceObj);
   virtual void    ASWPUBMETHOD OnInPlaceDeactivatePassThru( PASWINPLACEPRESSITE pIPPresSite);
   virtual HRESULT ASWPUBMETHOD OnUIActivatePassThru( PASWINPLACEPRESSITE pIPPresSite,
                                                      PASWREFHOLDER       pRefHoldOleInPlaceObj );
   virtual HRESULT ASWPUBMETHOD OnUIDeactivatePassThru( BOOL fUndoable );
   CAswResult ASWPUBMETHOD StartDragDrop( PASWDRAGSOURCE pAswDragSource,
                                          DWORD          dwEffect,
                                          LPDWORD        pdwEffect );
   virtual void ASWPUBMETHOD AddUI( BOOL fShow );
   void ASWPUBMETHOD SetActivate( BOOL bActive );
   virtual void ASWPUBMETHOD SetFocus( BOOL fSetFocus = TRUE );
   void AllowInSideOutObjects( BOOL fAllow )
   {
      m_fInsideOutSupported = fAllow;
   }
public:
   inline void SetSpaceHandler( PASWSPACEBASE pAswSpaceBase )
   {
      m_pAswSpaceBase = pAswSpaceBase;
   }
   inline PASWSPACEBASE GetSpaceHandler() const
   {
      return m_pAswSpaceBase;
   }
   inline HWND GetWnd(void) const
   {
      return m_hWnd;
   }
   inline PASWREFHOLDER GetOleInPlaceActiveObjectRefHolder(void)
   {
      return &m_refhIOleInPlaceActiveObject;
   }
   inline BOOL IsAnyObjIPActive(void)
   {
      return (NULL != GetFirstInPlacePresSite()) ? TRUE : FALSE;
   }
   inline BOOL IsAnyObjIPUIActive(void)
   {
      return ( (NULL==m_pCurUIActPresSite) ? FALSE : TRUE );
   }
   inline PASWINPLACEPRESSITE GetCurrentIPUIActiveObj( void )
   {
      return m_pCurUIActPresSite;
   }
   inline PASWREFHOLDER GetOleIPObjectRefholder(void)
   {
      return m_pRefHoldOleInPlaceObject;
   }
   inline void SetUIActFlag( PASWINPLACEPRESSITE pIPPresSite,
                             PASWREFHOLDER pRefHold )
   {
      m_pRefHoldOleInPlaceObject = pRefHold;
      m_pCurUIActPresSite = pIPPresSite;
   }
   virtual void ASWPUBMETHOD SetFocusOnUIDeactivate(HWND hwnd);
   virtual BOOL                 ASWPUBMETHOD IsFrameWindow( void ) PURE;
   virtual PASWFRAMEWINDOW      ASWPUBMETHOD GetFrameWindow( void ) PURE;
   virtual LPOLEINPLACEUIWINDOW ASWPUBMETHOD GetOleInPlaceUIWindow(void) PURE;
   inline void AddInPlacePresSiteToList( PASWINPLACEPRESSITE pIPPresSite )
   {
      m_lhListOfIPPresSites.Insert(pIPPresSite);
   }
   inline void RemoveInPlacePresSiteFromList( PASWINPLACEPRESSITE pIPPresSite )
   {
      m_lhListOfIPPresSites.Remove(pIPPresSite);
   }
   inline PASWINPLACEPRESSITE GetFirstInPlacePresSite( void )
   {
      return m_lhListOfIPPresSites.GetFirst();
   }
   inline PASWINPLACEPRESSITE GetNextInPlacePresSite( void )
   {
      return m_lhListOfIPPresSites.GetNext();
   }
private:
   void TellContToPutUpUI( void );
   void TellContToTakeDownUI( void );
   CAswResult ReallyUIDeactivate(void);
private:
   HWND                 m_hWnd;
   PASWSPACEBASE        m_pAswSpaceBase;
   CAswRefHolder        m_refhIOleInPlaceActiveObject;
   PASWREFHOLDER        m_pRefHoldOleInPlaceObject;
   PASWINPLACEPRESSITE  m_pCurUIActPresSite;
   CAswInPlacePresSiteListHead    m_lhListOfIPPresSites;
   BOOL                 m_fPendingUIDeactivate;
   PossibleActivation   m_fActivateAnotherPossible;
   BOOL                 m_fAddContUI;
   BOOL                 m_fInsideOutSupported;
   BOOL                 m_fProcessingDoubleClick;
   BOOL                 m_fWindowShutdown;
};
#include <aspop.h>
#endif      
