/* NOSHIP */
/*****************************************************************************

    File: 	LSIVAL.H

    (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.

    Description: LotusScript API Value Definitions.

 *****************************************************************************/

#if !defined(LSIVAL_H)
#    define  LSIVAL_H
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(push, 1)
#else
#pragma pack(1)
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack(1)
#elif LSCOMPILER_WATCOMC
#pragma pack(1)
#endif
typedef	LSPTR(class OMcBaseObject)		PLSO;
typedef	LSPTR(class OMcClientObject)	PLSCO;
typedef	LSPTR(class OMcNativeObject)	PLSNO;
#if defined(_COMPOBJ_H_)
typedef	LSPTR(interface IDispatch)		PLSIDISPATCH;
typedef	LSPTR(interface IUnknown)		PLSIUNKNOWN;
typedef	LSPTR(interface IEnumVARIANT)	PLSIENUMVARIANT;
#else
typedef	LSPTR(struct IDispatch)			PLSIDISPATCH;
typedef	LSPTR(struct IUnknown)			PLSIUNKNOWN;
typedef	LSPTR(struct IEnumVARIANT)		PLSIENUMVARIANT;
#endif
#ifndef _VARIANT_H_
typedef	struct LS_DT_FAR_ tagVARIANT LS_DT_FAR_ * LPVARIANT;
#endif
enum LSeVALTYPE
{
	LSVT_EMPTY				=  0,					
	LSVT_NULL				=  1,					
	LSVT_SHORT				=  2,					
	LSVT_LONG				=  3,					
	LSVT_SINGLE				=  4,					
	LSVT_DOUBLE				=  5,					
	LSVT_CURRENCY			=  6,					
	LSVT_DATE				=  7,					
	LSVT_STRING				=  8,					
	LSVT_IDISPATCH			=  9,					
	LSVT_ERROR				= 10,					
	LSVT_BOOLEAN			= 11,					
	LSVT_VARIANT			= 12,					
	LSVT_IUNKNOWN			= 13,					
	LSVT_UNISTR				= 14,					
	LSVT_LASTVALUE			= 15,					
	LSVT_CLIENTHDL			= 32,					
	LSVT_TINSTANCE			= 33,					
	LSVT_CINSTANCE			= 34,					
	LSVT_AINSTANCE			= 35,					
	LSVT_AMEMBERREF		= 36,					
	LSVT_STRINGDESC		= 37,					
	LSVT_IPRTAB				= 64,					
	LSVT_IPRSPC				= 65,					
	LSVT_IPRTABS			= 66,					
	LSVT_FRAME				= 67,					
	LSVT_GOSUB				= 68,					
	LSVT_NUMREAL = LSVT_DOUBLE,				
	LSVT_FROMVAR			= ((int)0x8000),	
	LSVT_BYREF				= ((int)0x4000),	
	LSVT_ARRAY				= ((int)0x2000),	
	LSVT_FIXED				= ((int)0x1000),	
	LSVT_LIST				= ((int)0x0800),	
	LSVT_BYVAL				= ((int)0x0400),	
	LSVT_DYNAMIC			= ((int)0x0200), 	
	LSVT_CLIENUM			= ((int)0x0100),	
	LSVT_CLIVAR				= LSVT_CLIENUM,	
	LSVT_OMITTED			= ((int)0x0080),	
	_LSVT_LAST_
};
#define	LSVT_NONE				((int)0)
#define	LSVT_MASK				((int)0x007F)
#define	LSVT_MASKCLI			LSVT_CLIENUM
#define	LSVT_MASKREF			(~(LSVT_MASK|LSVT_MASKCLI|LSVT_BYVAL))
#define	LSVT_MASKCONTAINER	(LSVT_ARRAY|LSVT_LIST)
#define	LSVT_BASEVALTYPE(x)	(LSVALTYPE)( (x) & LSVT_MASK )
#define	LSVT_IS_OMITTED(x)	( (x) & LSVT_OMITTED )
#define	LSVT_IS_CLIVAR(x)		(((x) & (LSVT_BYREF|LSVT_CLIVAR))==(LSVT_BYREF|LSVT_CLIVAR))
typedef	unsigned short							LSVALTYPE;
typedef	LSFLOAT8									LSNUMREAL;
typedef	short										LSsValueBool;
#define	LS_VAL_TRUE		((LSsValueBool) -1)
#define	LS_VAL_FALSE	((LSsValueBool)  0)
typedef	long										LSsValueError;
struct LSsCurrency
{
	unsigned long 	Lo;
	long				Hi;
};
typedef	LSPTR(struct LSsStringHeader)		PLSSTRINGHEADER;
struct LSsStringHeader
{
	LSUSHORT			sTemp : 1;
	LSUSHORT			sFlag : 15;					
	LSUSHORT			sSize;						
	LSUSHORT			sRefc;						
	LSREGNAMETYPE	sType;						
#define LSLIT_USED_FLAG		((LSUSHORT)0x494c)
#define LSLIT_HEADER(s)		(((PLSSTRINGHEADER)s)[-1])
#define LSIisString(s)		(((s)!=LSNULL)&&(LSIStringFlag(s)==LSLIT_USED_FLAG))
#define LSIStringSize(s)	(LSUSHORT)(((s)!=LSNULL) ? LSUINT(LSLIT_HEADER(s).sSize) : 0)
#define LSIStringFlag(s)	LSLIT_HEADER(s).sFlag
#define LSIStringRefc(s)	LSLIT_HEADER(s).sRefc
#define LSIStringType(s)	LSLIT_HEADER(s).sType
};
typedef	LSPTR(LSUSHORT)						LSsValueUniStr;
struct LSsFixedStr
{
	LSSTRING			Str;
	LSUSHORT			Len;
};
typedef	LSPTR(LSsFixedStr)					PLSFIXEDSTR;
struct LSsValueInst
{
	union
	{
		LSPBYTE		Data;							
		PLSO			pObject;						
		PLSCO			pClientObj;
		PLSNO			pNativeObj;
	};
	LShMODULE		TypeMod;						
};
struct LSsAdtMembRef
{
	PLSCO				pClientObj;					
	LShMODULE		hPropMod;					
};
typedef	LSPTR(LSsAdtMembRef)					PLSADTMEMBERREF;
typedef	LSPTR(struct LSsArrDesc)			PLSSARRDESC;
typedef	LSPTR(struct LSsArrBound)			PLSSARRBOUND;
typedef	LSPTR(struct LSsValueArray)		PLSVALUEARR;
struct LSsValueArray
{
	LSPBYTE			Data;							
	PLSSARRDESC		Desc;							
};
struct LSsArrBound								
{
	LSSSHORT			Lower;						
	LSUSHORT			Count;						
	LSmthN(unsigned int) SwapBytes();
};
struct LSsArrDesc									
{
	LSUSHORT			Type;							
	LSUSHORT			Align;
	LSUSHORT			Dims;							
	LSUSHORT			ElemSize;					
	LSBASETYPE		DataType;					
	LSSYMREL			TypeSym;						
	LShMODULE		TypeMod;						
	LSsArrBound		Bounds[1];					
	LSmthN(unsigned int) SwapBytes();
#define LSI_MAX_ARRAY_DIMS		8
};
typedef	PLSVALUEARR								LSDYNARRAY;
typedef	LSPTR(PLSVALUEARR)					PLSDYNARRAY;
struct LSsVariantArr
{
	LSDYNARRAY		VarArr;
	PLSSARRDESC		VarDesc;
};
struct LSsValueDynRef
{
	PLSDYNARRAY		pDynArr;
	PLSSARRDESC		pDynDesc;
};
typedef	LSPTR(struct LSsList)				PLSLIST;
typedef	LSPTR(struct LSsListNode)			PLSLISTNODE;
struct LSsValueList
{
	PLSLIST			Data;
	LShMODULE		hMod;
};
typedef	struct LSsStringDesc					LSSTRINGDESC;
typedef	LSPTR(LSSTRINGDESC)					PLSSTRINGDESC;
struct LSsStringDesc
{
	LSSTRING			pString;						
	LShINSTANCE		hInstance;					
};
typedef struct LSsCliHandle					LSCLIHANDLE;
typedef LSPTR(LSCLIHANDLE)						PLSCLIHANDLE;
struct LSsCliHandle
{
	PILSIADTCONTROL	ObjectHdl;				
	LSADTCLSIDHDL		ClassHdl;				
};
typedef LSPTR(struct LSsCliVar)				PLSSCLIVAR;
struct LSsValueCliVar
{
	PLSSCLIVAR		pCliVar;						
	LShMODULE		TypeMod;						
};
struct LSsIter
{
	PLSVALUE		pVar;
	LSUSHORT		Type;
};
union LSsValueData
{
	LSSSHORT			vShort;						
	LSSLONG			vLong;						
	LSFLOAT4			vSingle;						
	LSFLOAT8			vDouble;						
	LSNUMREAL		vNumReal;					
	LSsCurrency		vCurrency;					
	LSsDate			vDate;						
	LSSTRING			vString;						
	PLSIDISPATCH	vIDispatch;					
	LSsValueError	vError;						
	LSsValueBool	vBool;						
	PLSVALUE			vVar;							
	PLSIUNKNOWN		vIUnknown;					
	LSsValueUniStr	vUniStr;						
	LSPBYTE        vLmbcs;                 
	LSPLTSTR       vChars;					   
	LSPBYTE        vBytes;                 
	LSsFixedStr		vFixed;						
	LSsCliHandle	vCliHandle;					
	LSPBYTE			vTypeData;					
	LSsValueInst	vInstance;					
	LSsAdtMembRef	vAMemberRef;				
	PLSLIST			vListData;					
	LSPBYTE			vArrayData;					
	LSDYNARRAY		vDynArrData;				
	LSsVariantArr	vVarArrData;				
};
typedef	LSPTR(LSsValueData)					PLSVALUEDATA;
struct LSsValue
{
	union
	{
	LSSSHORT			vShort;						
	LSSLONG			vLong;						
	LSFLOAT4			vSingle;						
	LSFLOAT8			vDouble;						
	LSNUMREAL		vNumReal;					
	LSsCurrency		vCurrency;					
	LSsDate			vDate;						
	LSSTRING			vString;						
	PLSIDISPATCH	vIDispatch;					
	LSsValueError	vError;						
	LSsValueBool	vBool;						
	PLSVALUE			vVar;							
	PLSIUNKNOWN		vIUnknown;					
	LSsValueUniStr	vUniStr;						
	LSPBYTE        vLmbcs;                 
	LSPLTSTR       vChars;					   
	LSPBYTE        vBytes;                 
	LSsFixedStr		vFixed;						
	LSsCliHandle	vCliHandle;					
	LSPBYTE			vTypeData;					
	LSsValueInst	vInstance;					
	LSsAdtMembRef	vAMemberRef;				
	LSsStringDesc	vStringDesc;				
	LSsValueCliVar	vCliVar;						
	LSsValueList	vList;						
	LSsValueArray	vArray;						
	LSsValueDynRef	vDynRef;						
	LSsVariantArr	vVarArr;						
	LSsIter			vIter;						
	PLSVALUE			vByRef;						
	};
	LSVALTYPE		Type;							
	LSUSHORT			vvSymRel;
	LSUSHORT			Type3;
	LSUSHORT			Type4;
};
inline PLSVALUEARR	LSIValueArray(PLSVALUE PVAL)
{
	switch( PVAL->Type & (LSVT_DYNAMIC|LSVT_BYREF) )
	{
	case LSVT_DYNAMIC:					return PVAL->vVarArr.VarArr;
	case LSVT_BYREF | LSVT_DYNAMIC:	return *PVAL->vDynRef.pDynArr;
	default:									return &PVAL->vArray;
	}
}
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(pop)
#else
#pragma pack()
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack()
#elif LSCOMPILER_WATCOMC
#pragma pack()
#endif
#endif 
