/* NOSHIP */
/*****************************************************************************
 *
 * Description: System Asset Manager Public header file.
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 *****************************************************************************/

#if !defined (LSSAM_H)
#define LSSAM_H
#include "lssdefs.h"
#if LSAPI_WIN16
#define _JMP_BUF_DEFINED
typedef	int	jmp_buf[9];					
LS_CPP_PASCAL_LINKAGE_BEGIN
int     LSFAR LSPASCAL Catch(int LSFAR*);
void    LSFAR LSPASCAL Throw(const int LSFAR*, int);
LS_CPP_PASCAL_LINKAGE_END
#define	longjmp(j,c)	Throw(j,c)
#define	setjmp(j)		Catch(j)
#endif 
#if LSAPI_ANYWIN32
#include <assert.h>
#include <setjmp.h>
#endif
#if !defined(_JMP_BUF_DEFINED)
#include <setjmp.h>
#endif
#if !defined(LSS_NO_CAPI)
#define	SAM_BLOCK_BEGIN												\
			{																	\
				SAMCATCHBLOCK	_sam_cb;									\
				for   ( ; ; )												\
				{																\
					LASSAMSaveBegin((PLSSSAM)LSNULL, &_sam_cb);
#endif
#define	SAM_BLOCK_BEGIN_(P)											\
			{	SAMCATCHBLOCK	_sam_cb;									\
				for   ( ; ; )												\
				{	(P)->SaveBegin(&_sam_cb);
#if !defined(LSS_NO_CAPI)
#define	SAM_BLOCK_END													\
					break;													\
					}															\
				LASSAMSaveEnd((PLSSSAM)LSNULL, &_sam_cb);			\
			}
#endif
#define	SAM_BLOCK_END_(P)												\
					break;													\
					}															\
				(P)->SaveEnd(&_sam_cb);									\
			}
#if !defined(LSS_NO_CAPI)
#define	SAM_BLOCK_RETURN(v)											\
			LASSAMSaveEnd((PLSSSAM)LSNULL, &_sam_cb);				\
			return(v)
#endif
#define	SAM_BLOCK_RETURN_(P,v)										\
			(P)->SaveEnd(&_sam_cb);										\
			return(v)
#if !defined(LSS_NO_CAPI)
#define	SAM_BLOCK_RETURN_NOTHING									\
			LASSAMSaveEnd((PLSSSAM)LSNULL, &_sam_cb);				\
			return
#endif
#define	SAM_BLOCK_RETURN_NOTHING_(P)								\
			(P)->SaveEnd(&_sam_cb);										\
			return
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_BLOCK_BEGIN										\
			{																	\
				SAMCATCHBLOCK	_sam_cb;									\
				for (;;)														\
				{																\
					LASSAMHandlerBegin((PLSSSAM)LSNULL, &_sam_cb);\
					if (setjmp(_sam_cb.jb))								\
					{
#endif
#define	SAM_HANDLER_BLOCK_BEGIN_(P)								\
			{																	\
				SAMCATCHBLOCK	_sam_cb;									\
				for (;;)														\
				{																\
					(P)->HandlerBegin(&_sam_cb);							\
					if (setjmp(_sam_cb.jb))								\
					{
#if !defined(LSS_NO_CAPI)
#define SAM_HANDLER_BLOCK_END SAM_BLOCK_END
#endif
#define SAM_HANDLER_BLOCK_END_(P) SAM_BLOCK_END_(P)
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_RETRY												\
			LASSAMHandlerEnd((PLSSSAM)LSNULL);						\
			continue;
#endif
#define	SAM_HANDLER_RETRY_(P)										\
			(P)->HandlerEnd();												\
			continue;
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_RETURN(x)										\
			LASSAMHandlerEnd((PLSSSAM)LSNULL);						\
			return (x)
#endif
#define	SAM_HANDLER_RETURN_(P,x)									\
			(P)->HandlerEnd();												\
			return (x)
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_RETURN_NOTHING									\
			LASSAMHandlerEnd((PLSSSAM)LSNULL);						\
			return
#endif
#define	SAM_HANDLER_RETURN_NOTHING_(P)							\
			(P)->HandlerEnd();												\
			return
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_EXCEPTION(x)									\
			LASSAMHandlerEnd((PLSSSAM)LSNULL);						\
			LASSAMException((PLSSSAM)LSNULL, x)
#endif
#define	SAM_HANDLER_EXCEPTION_(P,x)								\
			(P)->HandlerEnd();												\
			(P)->Exception(x)
#if !defined(LSS_NO_CAPI)
#define	SAM_THROWN_STATUS				(_sam_cb.status)
#endif
#define	SAM_THROWN_STATUS_(P)		(_sam_cb.status)
#if !defined(LSS_NO_CAPI)
#define	SAM_HANDLER_END												\
			}
#endif
#define	SAM_HANDLER_END_(P)											\
			}
#if !defined(DEBUG)
#if !defined(LSS_NO_CAPI)
#define SAM_ASSERT_ALWAYS(msg)
#define SAM_ASSERT(exp)
#define SAM_ASSERTM(exp, msg)
#endif
#define LSS_ASSERT_(P, exp, msg)
#define SAM_ASSERT_ALWAYS_(P, msg)
#define SAM_ASSERT_(P, exp)
#define SAM_ASSERTM_(P, exp, msg)
#else
#if !defined(LSS_NO_CAPI)
#define SAM_ASSERT_ALWAYS(msg) LASSAMAssertion(LSNULL,	\
												(LSPLTSTR) msg,		\
												(LSPLTSTR) __FILE__,	\
												(LSPLTSTR)(LSULONG) __LINE__)
#define SAM_ASSERT(exp)	if (!(exp)) {SAM_ASSERT_ALWAYS((LSPLTSTR) #exp);	\
												LASSAMException(LSNULL,(LSULONG) -1L);}
#define SAM_ASSERTM(exp, msg)	if (!(exp)) {SAM_ASSERT_ALWAYS((LSPLTSTR)(msg));	\
													LASSAMException(LSNULL, (LSULONG)-1L);}
#endif
#if defined(DEBUG)
#if LSAPI_ANYWIN
#define LSS_ASSERT_(P, exp) \
	(void)( (exp) || ((P)->SimpleAssertFailure(#exp, __FILE__, __LINE__), 0))
#else
#include <assert.h>
#define LSS_ASSERT_(P, exp) assert(exp)
#endif
#else
#define LSS_ASSERT_(P, exp)
#endif
#define SAM_ASSERT_ALWAYS_(P, msg) (P)->Assertion((LSPLTSTR) msg,			\
																  (LSPLTSTR) __FILE__,	\
																  (LSPLTSTR)(LSULONG) __LINE__)
#define SAM_ASSERT_(P, exp)	if (!(exp)) {SAM_ASSERT_ALWAYS_((P), (LSPLTSTR) #exp);	\
												(P)->Exception((LSULONG) -1L);}
#define SAM_ASSERTM_(P, exp, msg)	if (!(exp)) {SAM_ASSERT_ALWAYS_((P), (LSPLTSTR)(msg));	\
													(P)->Exception((LSULONG)-1L);}
#endif
#define	SAMM_PERMANENT	0x000				 
#define	SAMM_TEMP	  	0x001				 
#define	SAMM_PROMOTE  	0x002				 
#define	SAMM_FRAME		0x004				 
#define  SAMM_REMOVED	0x008				 
#define	SAMM_MASK		0x00F           
#define  SAMM_NOEXCEPT	0x010			    
#define  SAMM_ZEROINIT  MM_ZEROINIT     
#define  SAMT_NORMAL    0x000           
#define	SAMT_BYTE		0x020				 
#define	SAMT_SHORT		0x040				 
#define	SAMT_LONG		0x080				 
#define	SAMT_MASK		0x0E0           
#define  SAM_MASK       (SAMT_MASK | SAMM_MASK | SAMM_NOEXCEPT)
#define SAM_FLAG_NORMAL 0
#define SAM_FLAG_ABORT  1
#define SAM_FLAG_TRACE  2
#define SAM_FLAG_IGNORE 3
typedef LSPTR(struct SAMsCatchBlock)		PSAMCATCHBLOCK;
LS_CPP_C_LINKAGE_BEGIN
typedef LSfncEP(void, PFNDESTROY)(LSPVOID);
LS_CPP_C_LINKAGE_END
typedef LSULONG			LGSTRINGID;
typedef LGSTRINGID		LGEMSTATUS;
typedef LGSTRINGID		LSTATUS;
typedef LSPTR(LSTATUS)  PLSTATUS;
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(push, 1)
#else
#pragma pack(1)
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack(1)
#elif LSCOMPILER_WATCOMC
#pragma pack(1)
#endif
typedef struct SAMsCatchBlock {
	PSAMCATCHBLOCK	pPrevCatchBlock;
	LGEMSTATUS		status;
	LSUSHORT			prevFP;
	jmp_buf			jb;
#if LSAPI_MAC
	LSULONG			pad1;
	LSULONG			pad2;
#endif
} SAMCATCHBLOCK;
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(pop)
#else
#pragma pack()
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack()
#elif LSCOMPILER_WATCOMC
#pragma pack()
#endif
SERVICE_DECL_TYPES(SAM);
#if defined(__cplusplus)
SERVICE_DECL_BEGIN(SAM)
	virtual LSmthID(lheap) HeapCreate	(LSPLTSTR pszHeapName, LSUSHORT wFlags) =0;
	virtual LSmthID(lheap) HeapCreateEx (LSPLTSTR     pszHeapName,
													 LSUSHORT     wFlags,
													 LSUSHORT     wInitialSize,
													 LSUSHORT     wGrowSize) =0;
	virtual LSmthID(void) HeapDestroy	(lheap hHeap) =0;
	virtual LSmthID(LSPVOID) BlkAlloc	(lheap hHeap, LSULONG wSize, LSUINT wFlags) =0;
	virtual LSmthID(LSULONG) BlkSize		(LSPVOID p)	=0;
	virtual LSmthID(LSPVOID)		BlkResize		(
													LSPVOID	mmbpBlock,
													LSULONG	wNewsize,
													LSUINT	wFlags) 	=0;
	virtual LSmthID(void)	BlkFree			(
													LSPVOID pBlock) 	=0;
	virtual LSmthID(LSULONG)		HeapInfo			(
													lheap hHeap,
													LSUSHORT whatInfo,
													LSULONG p1,
													 LSULONG p2)		=0;
	virtual LSmthID(lheap)		HeapFromBlock	(
													LSPVOID pBlock) 	=0;
	virtual LSmthID(void) SaveAsset	( LSPVOID hAsset,
												 PFNDESTROY pfnDestroy,
												 LSUSHORT mode) =0;
	virtual LSmthID(void) SaveBegin	( LSPVOID pAutoBegin) =0;
	virtual LSmthID(void) SaveEnd		( LSPVOID pAutoEnd) =0;
	virtual LSmthID(void) HandlerBegin	( PSAMCATCHBLOCK pCatch) =0;
	virtual LSmthID(void) HandlerEnd	() =0;
	virtual LSmthID(void) Exception	( LGEMSTATUS status) =0;
	virtual LSmthID(void) SaveByte 	( LSPTR(LSUBYTE)  p,
															 		LSUSHORT savemode) =0;
	virtual LSmthID(void) SaveWord	   ( LSPTR(LSUSHORT) p,
															 		LSUSHORT savemode) =0;
	virtual LSmthID(void) SaveLong 	( LSPTR(LSULONG)  p,
																	LSUSHORT savemode) =0;
	virtual LSmthID(void) ReplaceAsset	( LSPVOID hAsset,
												 LSPVOID hNewAsset,
												 PFNDESTROY pfnDestroy) =0;
	virtual LSmthID(void) Assertion	(
												LSPLTSTR pExp,
												LSPLTSTR pFile,
												LSPLTSTR pLine) =0;
	virtual LSmthID(void) HandleTraps	( 
												LSBOOL	  doit) =0;
	virtual LSmthID(LSPVOID)       GetAsset(LSUINT pos,
											LSPTR(PFNDESTROY)pfnDestroy,
											LSPTR(LSUINT) hFlags)=0;
SERVICE_DECL_END
#endif
#if defined(LSS_NO_CAPI)
#if LSCOMPILER_MICROSOFT && 0
#pragma message ("warning LSS_NO_CAPI : LASSAM calls are not available")
#endif
#else
LS_CPP_C_LINKAGE_BEGIN
LSfncE(void)
LASSAMAssetSave	(PLSSSAM hSAM, LSPVOID hAsset, PFNDESTROY pfnDestroy, LSUSHORT mode);
LSfncE(void)
LASSAMSaveBegin	(PLSSSAM hSAM, LSPVOID pAutoBegin);
LSfncE(void)
LASSAMSaveEnd			(PLSSSAM hSAM, LSPVOID pAutoEnd);
LSfncE(void)
LASSAMHandlerBegin	(PLSSSAM hSAM, PSAMCATCHBLOCK pCatch);
LSfncE(void)
LASSAMHandlerEnd		(PLSSSAM hSAM);
LSfncE(void)
LASSAMException		(PLSSSAM hSAM, LGEMSTATUS status);
LSfncE(void)
LASSAMSaveByte		(PLSSSAM hSAM, LSPTR(LSUBYTE) p, LSUSHORT savemode);
LSfncE(void)
LASSAMSaveWord		(PLSSSAM hSAM, LSPTR(LSUSHORT) p, LSUSHORT savemode);
LSfncE(void)
LASSAMSaveLong		(PLSSSAM hSAM, LSPTR(LSULONG)  p, LSUSHORT savemode);
LSfncE(void)
LASSAMAssetRemoved	(PLSSSAM hSAM, LSPVOID hAsset);
LSfncE(void)
LASSAMAssertion	(PLSSSAM hSAM,	LSPLTSTR pExp,LSPLTSTR pFile,LSPLTSTR pLine);
LSfncE(void)
LASSAMHandleTraps	(PLSSSAM hSAM,	LSBOOL	  doit);
LSfncE(lheap)
LASSAMHeapCreate 	(PLSSSAM hSAM, LSPLTSTR pszHeapName, LSUSHORT wFlags);
LSfncE(void)
LASSAMHeapDestroy	(PLSSSAM hSAM, lheap hHeap);
LSfncE(LSPVOID)
LASSAMBlkAlloc		(PLSSSAM hSAM, lheap	hHeap, LSULONG	wSize, LSUINT	wFlags);
LSfncE(LSULONG)
LASSAMBlkSize		(PLSSSAM hSAM, LSPVOID p);
LSfncE(LSPVOID)
LASSAMBlkResize	(PLSSSAM hSAM, LSPVOID	p,	LSULONG size, LSUINT Flags);
LSfncE(void)
LASSAMBlkFree		(PLSSSAM hSAM, LSPVOID p);
LSfncE(LSULONG)
LASSAMHeapInfo		(PLSSSAM hSAM, lheap hHeap, LSUSHORT type,	LSULONG p1, LSULONG p2);
LSfncE(lheap)
LASSAMHeapFromBlk	(PLSSSAM hSAM, LSPVOID p);
LSfncE(LSPVOID)
LASSAMGetAsset(PLSSSAM hSAM, LSUINT pos,LSPTR(PFNDESTROY)pfnDestroy,LSPTR(LSUINT) hFlags);
LS_CPP_C_LINKAGE_END
#endif 
#endif 
