/* NOSHIP */
/*****************************************************************************
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *****************************************************************************/

#if !defined(LSSDEFS_H)
#define LSSDEFS_H
#if !defined(LSDEFINE_H)
#include "lsdefine.h"
#endif
typedef LSUSHORT		LSS_STATUS;
typedef LSULONG		LSS_SERVICE_ID;
typedef struct SERVICE_ID
{
	LSULONG Data1;
	LSUSHORT Data2;
	LSUSHORT Data3;
	LSUBYTE Data4[ 8 ];
} SERVICE_ID;
#if defined(__cplusplus)
#define SERVREFID					const SERVICE_ID &
#else
#define SERVREFID					const LSPTR(SERVICE_ID) const
#endif
#if LSAPI_WIN16
#define LSS_NOINTERFACE					0x80000004L	
#else
#define LSS_NOINTERFACE					0x80004002L	
#endif
#define LSS_RTEOutOfMemory 7
#if defined(LSI_RTE_OutOfMemory) && (LSS_RTEOutOfMemory != LSI_RTE_OutOfMemory)
ERROR LSI_RTE_OutOfMemory is not the same as LSS_RTEOutOfMemory (7)
#endif
#if !defined(__cplusplus)
#define	SERVICE_DECL_TYPES(serv)				\
	typedef struct SRVs##serv 	 LSS##serv;		\
	typedef LSPTR(LSS##serv)	  	PLSS##serv
#endif
#if defined(__cplusplus)
#define	SERVICE_DECL_TYPES(serv)				\
	class	LSS##serv;									\
	typedef LSPTR(LSS##serv)	  	PLSS##serv
#define SERVICE_DECL_BEGIN(serv)		\
	class	LSS##serv {						\
 	public:                          \
	DECLARE_BASE_METHODS(serv)
#define	DECLARE_BASE_METHODS(serv)													    \
	virtual LSmthID(LSULONG) GetInterface	(SERVREFID sref, LSPTR(LSPVOID) ppvObject) =0; \
	virtual LSmthID(LSULONG) AddRef			() =0;                               \
	virtual LSmthID(LSULONG) Release			() =0;                               
#define SERVICE_DECL_END	};
#endif
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(push, 1)
#else
#pragma pack(1)
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack(1)
#elif LSCOMPILER_WATCOMC
#pragma pack(1)
#endif
struct tag_ServiceInfo
{
	LSPLTSTR		pSrvName;					 
	LSULONG		nSrvVersion;				 
	LSULONG		iSrvID;						 
};
typedef struct tag_ServiceInfo			LSSSERVICEINFO;
typedef LSPTR(LSSSERVICEINFO)				PLSSSERVICEINFO;
typedef	LSPVOID LLIB;
LS_CPP_C_LINKAGE_BEGIN
typedef	LSfncEP(void, LPROC)(void);
LS_CPP_C_LINKAGE_END
typedef struct LibVerInfo
{
	LSULONG InfoSize;
	LSULONG Version;
} LIBVERINFO;
typedef LSPTR(LIBVERINFO) PLIBVERINFO; 
typedef struct LibraryEntryPoint
{
	LIBVERINFO VerInfo;
	LSPVOID pMessageProc;
} LIBENTRYPOINT;
typedef LSPTR(LIBENTRYPOINT) PLIBENTRYPOINT;
LS_CPP_PASCAL_LINKAGE_BEGIN
typedef LSfncEP(void, PLSSENTRYPROC)(PLIBENTRYPOINT, LSPLTSTR);
typedef LSfncEP(long, PLSSMSGPROC)(LSUINT msg, LSULONG p1, LSULONG p2);
LS_CPP_PASCAL_LINKAGE_END
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(pop)
#else
#pragma pack()
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack()
#elif LSCOMPILER_WATCOMC
#pragma pack()
#endif
SERVICE_DECL_TYPES(MEMMGR);
typedef LSPTR(struct LSMMHEAP) 			lheap;
#define LSS_MAKEVERSION(major, minor)	((major)<<16)+(minor)
#define LSS_GETMAJORVER(version)			((version)>>16)
#define LSS_GETMINORVER(version)			((version)&0xFF)
#if defined(LSS_NO_CAPI)
#if LSCOMPILER_MICROSOFT && 0
#pragma message ("warning LSS_NO_CAPI : LSS_ASSERT is not available")
#endif
#else
LS_CPP_C_LINKAGE_BEGIN
extern LSfncED(void) LASSAMSimpleAssertFailure(LSPLTSTR msg, LSPLTSTR file, LSUINT lineno);
LS_CPP_C_LINKAGE_END
#if defined(DEBUG)
#if LSAPI_ANYWIN
#define LSS_ASSERT(exp) \
	(void)( (exp) || (LASSAMSimpleAssertFailure(#exp, __FILE__, __LINE__), 0))
#else
#include <assert.h>
#define LSS_ASSERT assert
#endif
#else
#define LSS_ASSERT(exp)
#endif
#if LSAPI_ANYWIN
#if defined(DEBUG)
#define LSS_ASSERT1(exp,msg) \
	(void)( (exp) || (LASSAMSimpleAssertFailure(msg, __FILE__, __LINE__), 0))
#else
#define LSS_ASSERT1(exp,msg) LSS_ASSERT(exp)
#endif
#else
#define LSS_ASSERT1(exp,msg) LSS_ASSERT(exp)
#endif
#endif 
#endif 
