/* NOSHIP */
/*****************************************************************************
 *
 * Description:	LotusScript Service Manager and Service Anchor
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 *****************************************************************************/

#if		!defined(LSSRVMGR_H)
#define	LSSRVMGR_H
#if      !defined(LSSDEFS_H)
#include	"lssdefs.h"
#endif
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(push, 1)
#else
#pragma pack(1)
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack(1)
#elif LSCOMPILER_WATCOMC
#pragma pack(1)
#endif
#if defined(__cplusplus)
class LSSSRVMGR;
class LSSMEMMGR;
class LSSSAM;
class LSSLIBMGR;
class LSSCLS;
class LSSFILEMGR;
class LSSPLAT;
class LSSESTR;
class LSSIPC;
typedef struct LSSsAnchor
{
	LSPTR(LSSSRVMGR)	pSRVMGR;
	LSPTR(LSSMEMMGR)	pMM;
	LSPTR(LSSSAM)		pSAM;
	LSPTR(LSSLIBMGR)	pLMGR;
	LSPTR(LSSFILEMGR) pFMGR;
	LSPTR(LSSCLS)		pCLS;					 
	LSPTR(LSSCLS)		pUNI;					 
	LSPTR(LSSPLAT)		pPLAT;
	LSPTR(LSSESTR)		pESTR;
	LSPTR(LSSIPC)		pIPC;
} LSSANCHOR;
#else
typedef struct LSSsAnchor
{
	LSPTR(void)		pSRVMGR;
	LSPTR(void)		pMM;
	LSPTR(void)		pSAM;
	LSPTR(void)		pLMGR;
	LSPTR(void)		pFMGR;
	LSPTR(void)		pCLS;
	LSPTR(void)		pUNI;
	LSPTR(void)		pPLAT;
	LSPTR(void)		pESTR;
	LSPTR(void)		pIPC;
} LSSANCHOR;
#endif
#if LSCOMPILER_MICROSOFT
#if LSAPI_ANYWIN32
#pragma pack(pop)
#else
#pragma pack()
#endif
#elif LSCOMPILER_IBMCSET
#pragma pack()
#elif LSCOMPILER_WATCOMC
#pragma pack()
#endif
typedef  LSPTR(const LSSANCHOR)  PLSSANCHOR;
typedef  LSULONG LSS_SECTION_ID;
const LSS_SECTION_ID	LSS_SECTION_LSX_20		= 1;
const LSS_SECTION_ID	LSS_SECTION_SYSSRV_30	= 2;
typedef LSPTR(struct ENUMINFO)	PENUMINFO;
const LSS_MAX_REGISTRY_KEY_LEN					= 32;
const LSS_MAX_REGISTRY_VAL_LEN					= 512;
typedef struct ENUMINFO
{
	char key[LSS_MAX_REGISTRY_KEY_LEN];
	char val[LSS_MAX_REGISTRY_VAL_LEN];
} ENUMINFO;
#if !defined(LSS_PRIVATE)
typedef LSPVOID LSREGISTRYENUMHANDLE;
#else
typedef LSPTR(struct LSsRegistryHandle) LSREGISTRYENUMHANDLE;
#endif
SERVICE_DECL_TYPES(SRVMGR);
#if defined(__cplusplus)
SERVICE_DECL_BEGIN(SRVMGR)
virtual LSmthI(PLSSANCHOR)
Anchor() = 0;
virtual LSmthI(LSPVOID)
ServiceInit(LSS_SERVICE_ID) =0;
virtual LSmthI(LSPVOID)
ServiceInitByName(LSPLTSTR name, LSPLTSTR libpath, PLIBVERINFO info) = 0;
virtual LSmthI(LSPVOID)
ServiceCreateInstance(LSS_SERVICE_ID id, LSPVOID pMM, LSPTR(LSULONG) pLib) = 0;
virtual LSmthI(LSPVOID)
ServiceCreateByName(LSPLTSTR name, LSPLTSTR libpath, LSPVOID pMM, LSPTR(LSULONG) pLib) = 0;
virtual LSmthI(void)
ServiceTerm(LSS_SERVICE_ID id) = 0;
virtual LSmthI(void)
ServiceTermByPtr(LSPVOID pService) = 0;
virtual LSmthI(LSBOOL)
ServiceDelete(LSS_SERVICE_ID id) = 0;
virtual LSmthI(LSBOOL)
ServiceDeleteByPtr(LSPVOID pService) = 0;
virtual LSmthI(LSUINT)
ServiceGetRegistryString(LSPLTSTR Section,
								 LSPLTSTR Key,
								 LSPLTSTR Default,
								 LSPLTSTR Val,
								 LSUINT ValLength) = 0;
virtual LSmthI(LSUINT)
ServiceSetRegistryString(LSPLTSTR Section,
								 LSPLTSTR Key,
								 LSPLTSTR Val) = 0;
virtual LSmthI(LSUINT)
ServiceSetRegistryStringById(LSS_SECTION_ID  Id,
									  LSPLTSTR Key,
									  LSPLTSTR Val) = 0;
virtual LSmthI(LSUINT)
ServiceGetRegistryStringById(LSS_SECTION_ID Id,
									  LSPLTSTR Key,
									  LSPLTSTR Default,
									  LSPLTSTR Val,
									  LSUINT   ValLength) = 0;
virtual LSmthI(LSREGISTRYENUMHANDLE)
ServiceEnumRegistryBegin(LSPLTSTR Section) = 0;
virtual LSmthI(LSREGISTRYENUMHANDLE)
ServiceEnumRegistryBeginByID(LSS_SECTION_ID SectionID) = 0;
virtual LSmthI(LSBOOL)
ServiceEnumRegistryNext(LSREGISTRYENUMHANDLE hdl, PENUMINFO info) = 0;
virtual LSmthI(void)
ServiceEnumRegistryEnd(LSREGISTRYENUMHANDLE hdl) = 0;
virtual LSmthI(PLSSMSGPROC)
ServiceGetMsgProc(LSS_SERVICE_ID id, LSPTR(LSULONG) pLib) = 0;
virtual LSmthI(PLSSMSGPROC)
ServiceGetMsgProcByName(LSPLTSTR name, LSPLTSTR libpath, LSPTR(LSULONG) pLib) = 0;
virtual LSmthI(PLSSMSGPROC)
ServiceMsgProcFromLibEntry(LPROC proc, LSPLTSTR name) = 0;
virtual LSmthI(PLSSMSGPROC)
LSXGetMsgProc(LSPLTSTR name, LSPTR(LSULONG) pLib) = 0;
virtual LSmthI(LSPVOID)
ServiceOverride(LSS_SERVICE_ID id, LSPVOID pService, LSULONG pLib) = 0;
virtual LSmthI(LSPVOID)
ServiceGetPtr (LSS_SERVICE_ID id) = 0;
virtual LSmthI(int)
ServiceQueryOS(LSPTR(LSULONG) pVersion) = 0;
virtual LSmthI(LSULONG)
ServiceAddRef (LSS_SERVICE_ID id) = 0;
virtual LSmthI(LSULONG)
ServiceRelease (LSS_SERVICE_ID id) = 0;
#if 0
virtual LSmthI(int)
ServiceGetVectorCnt(LSS_SERVICE_ID id) = 0;
virtual LSmthI(LSBOOL)
ServiceGetVector(LSS_SERVICE_ID id, LSPVOID pVector) = 0;
virtual LSmthI(LSBOOL)
ServiceInquire (LSS_SERVICE_ID id, PLSSSERVICEINFO pInfo) = 0;
virtual LSmthI(LSBOOL)
ServiceInquireByName (LSPLTSTR name, LSPLTSTR libpath, PLSSSERVICEINFO pInfo) = 0;
#endif
virtual LSmthID(LPROC)
ServiceGetEntryProc(LSPLTSTR pszProcName, LSUSHORT fsSAM) = 0;
SERVICE_DECL_END
#endif
#if defined(LSS_NO_CAPI)
#if LSCOMPILER_MICROSOFT && 0
#pragma message ("warning LSS_NO_CAPI : LASSrv calls are not available")
#endif
#else			
LS_CPP_C_LINKAGE_BEGIN
LSfncED(PLSSSRVMGR) LASSrvMgrInit();
LSfncED(void) LASSrvMgrTerm();
LS_CPP_C_LINKAGE_END
#endif 
#endif 
