/* NOSHIP */
/*****************************************************************************

   Module Name:      ltsguid.h

   (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.

   Description:      Common Aswan-managed Lotus GUIDs for OLE 2 Components

                     This header is designed not to be dependent on any other
                     headers.

 *****************************************************************************/

#if !defined(_LTSGUID_H)
#define _LTSGUID_H
#if defined(WIN32) || defined(_WIN32)
   #define LTSGUID_WIN32
#elif defined(WIN16) || defined(_WIN16)
   #define LTSGUID_WIN16
#elif defined(MAC) || defined(_MAC)
   #define LTSGUID_MAC
   #define LTSGUID_WIN16
#else
   #define LTSGUID_OTHER
   #define LTSGUID_WIN32
#endif
#if defined( LTSGUID_WIN32 ) && !defined( LTSGUID_OTHER )
   #if ! (defined(lint) || defined(_lint) || defined(RC_INVOKED))
      #if ( _MSC_VER >= 800 )
         #pragma warning(disable:4103)
         #if !(defined( MIDL_PASS )) || defined( __midl )
            #pragma pack(push)
         #endif
         #pragma pack(8)
      #else
         #pragma pack(8)
      #endif
   #endif
#endif
#if defined(__cplusplus)
   #define LTSGUID_EXTERN_C    extern "C"
#else
   #define LTSGUID_EXTERN_C    extern
#endif
#if defined( LTSGUID_MAC )
   #define LTSGUID_FAR
   #define LTSGUID_CDECL
   #if defined( _COMPOBJ_H_ )
      #define DEFINE_GUID_HERE 0
   #else
      #define DEFINE_GUID_HERE 1
   #endif
#elif defined( LTSGUID_WIN16 )
   #define LTSGUID_FAR     _far
   #define LTSGUID_CDECL   _cdecl
   #if defined( _COMPOBJ_H_ )
      #define DEFINE_GUID_HERE 0
   #else
      #define DEFINE_GUID_HERE 1
   #endif
#elif defined( LTSGUID_WIN32 )  && !defined( LTSGUID_OTHER )
   #define LTSGUID_FAR
   #define LTSGUID_CDECL  // RDL
   #if !defined( GUID_DEFINED )
      #define DEFINE_GUID_HERE 1
   #else
      #define DEFINE_GUID_HERE 0
   #endif
#else
   #define LTSGUID_FAR
   #define LTSGUID_CDECL
   #if !defined( GUID_DEFINED )
      #define DEFINE_GUID_HERE 1
   #else
      #define DEFINE_GUID_HERE 0
   #endif
#endif
#if ( DEFINE_GUID_HERE == 1 )
   #define GUID_DEFINED 1
   #include <string.h>
   #if defined( __cplusplus )
      #if defined( LTSGUID_WIN16 )
         struct LTSGUID_FAR GUID
         {
            unsigned long  Data1;
            unsigned short Data2;
            unsigned short Data3;
            unsigned char  Data4[ 8 ];
         };
      #else
         typedef struct LTSGUID_FAR _GUID
         {
            unsigned long  Data1;
            unsigned short Data2;
            unsigned short Data3;
            unsigned char  Data4[ 8 ];
         } GUID;
      #endif
      #if !defined( IsEqualIID )
         inline int operator==(const GUID& guidOne, const GUID& guidOther)
         {
         #if defined( LTSGUID_WIN16 ) && !defined( LTSGUID_MAC )
            return !_fmemcmp(&guidOne,&guidOther,sizeof(GUID));
         #else
            return !memcmp(&guidOne,&guidOther,sizeof(GUID));
         #endif
         }
         inline int operator!=(const GUID& guidOne, const GUID& guidOther)
         {
            return !(guidOne == guidOther);
         }
         inline int IsEqualGUID(const GUID& rguid1, const GUID& rguid2)
         {
            return (rguid1 == rguid2);
         }
      #endif
   #else
      #if defined( LTSGUID_WIN16 )
         typedef struct GUID
         {
            unsigned long  Data1;
            unsigned short Data2;
            unsigned short Data3;
            unsigned char  Data4[ 8 ];
         } GUID;
      #else
         typedef struct _GUID
         {
            unsigned long  Data1;
            unsigned short Data2;
            unsigned short Data3;
            unsigned char  Data4[ 8 ];
         } GUID;
      #endif
      #if !defined( IsEqualIID )
         #if defined( LTSGUID_WIN16 ) && !defined( LTSGUID_MAC )
            #define IsEqualGUID( guidOne, guidOther ) !_fmemcmp(&guidOne,&guidOther,sizeof(GUID));
         #else
            #define IsEqualGUID( guidOne, guidOther ) !memcmp(&guidOne,&guidOther,sizeof(GUID));
         #endif
      #endif
   #endif
   #if !defined( IsEqualIID )
      #define IsEqualIID(riid1, riid2)       IsEqualGUID(riid1, riid2)
      #define IsEqualCLSID(rclsid1, rclsid2) IsEqualGUID(rclsid1, rclsid2)
   #endif
#endif
#if !defined( DEFINE_GUID )
#if !defined( INITGUID )
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    LTSGUID_EXTERN_C const GUID LTSGUID_CDECL LTSGUID_FAR name
#else
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        LTSGUID_EXTERN_C const GUID LTSGUID_CDECL name \
                = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
#endif
#endif
#if !defined( DECLARE_GUID )
#define DECLARE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    LTSGUID_EXTERN_C const GUID LTSGUID_CDECL LTSGUID_FAR name
#endif
#define LTSGUID_D2  0x2EED
#define LTSGUID_D3  0x1069
#define LTSGUID_D41 0xBF
#define LTSGUID_D42 0x5D
#define LTSGUID_D43 0x00
#define LTSGUID_D44 0xDD
#define LTSGUID_D45 0x01
#define LTSGUID_D46 0x11
#define LTSGUID_D47 0x86
#define LTSGUID_D48 0xB7
#if defined(INITGUID) && !defined(LTS_INITGUID_DISABLED) && !defined(LTS_INITGUID)
	#define LTS_INITGUID
#endif
#if defined(LTS_INITGUID)
#define DEFINE_LTSGUID(clsid,lID) DEFINE_GUID( clsid, lID,  LTSGUID_D2, \
                                               LTSGUID_D3,  LTSGUID_D41, \
                                               LTSGUID_D42, LTSGUID_D43, \
                                               LTSGUID_D44, LTSGUID_D45, \
                                               LTSGUID_D46, LTSGUID_D47, \
                                               LTSGUID_D48 )
#else
	#define DEFINE_LTSGUID(clsid,lID) DECLARE_GUID(	clsid, lID,  LTSGUID_D2, \
																	LTSGUID_D3,  LTSGUID_D41, \
																	LTSGUID_D42, LTSGUID_D43, \
																	LTSGUID_D44, LTSGUID_D45, \
																	LTSGUID_D46, LTSGUID_D47, \
																	LTSGUID_D48 )
#endif
#define DECLARE_LTSGUID(clsid,lID) DECLARE_GUID( clsid, lID,  LTSGUID_D2,  \
                                                 LTSGUID_D3,  LTSGUID_D41, \
                                                 LTSGUID_D42, LTSGUID_D43, \
                                                 LTSGUID_D44, LTSGUID_D45, \
                                                 LTSGUID_D46, LTSGUID_D47, \
                                                 LTSGUID_D48 )
#define LID_FROM_LTSGUID(guid) (guid.Data1)
#define LTSGUID_BASE_US ((unsigned short) 0x2913)
#define LTSGUID_BASE_UL ((unsigned long) 0x29130000)
#define LIDVALUE_FROM_LTSGUID(guid) ((unsigned short) (LID_FROM_LTSGUID(guid) \
                                    & (~LTSGUID_BASE_UL)))
#define LTSGUID(offset) ((unsigned long) (LTSGUID_BASE_UL | \
                        ((unsigned long) offset)))
#define IS_LOTUS_GUID(guid) ((LTSGUID_BASE_UL == (LID_FROM_LTSGUID(guid) &\
                                                  LTSGUID_BASE_UL))\
&& (LTSGUID_D2  == guid.Data2)\
&& (LTSGUID_D3  == guid.Data3)\
&& (LTSGUID_D41 == guid.Data4[0])\
&& (LTSGUID_D42 == guid.Data4[1])\
&& (LTSGUID_D43 == guid.Data4[2])\
&& (LTSGUID_D44 == guid.Data4[3])\
&& (LTSGUID_D45 == guid.Data4[4])\
&& (LTSGUID_D46 == guid.Data4[5])\
&& (LTSGUID_D47 == guid.Data4[6])\
&& (LTSGUID_D48 == guid.Data4[7]))
#define RUNTIME_DEFINE_LTSGUID(guid,lID) {guid.Data1=lID;\
guid.Data2=LTSGUID_D2;\
guid.Data3=LTSGUID_D3;\
guid.Data4[0]=LTSGUID_D41;\
guid.Data4[1]=LTSGUID_D42;\
guid.Data4[2]=LTSGUID_D43;\
guid.Data4[3]=LTSGUID_D44;\
guid.Data4[4]=LTSGUID_D45;\
guid.Data4[5]=LTSGUID_D46;\
guid.Data4[6]=LTSGUID_D47;\
guid.Data4[7]=LTSGUID_D48;}
#define LTSLID_AmiProDocPropSheet    LTSGUID(0xFFFE)
#define LTSLID_CosmoFigure16         LTSGUID(0xFFFD)
#define LTSLID_CosmoFigure32         LTSGUID(0xFFFC)
#define LTSLID_IOleUILinkContainer   LTSGUID(0xFFF9)
#define LTSLID_CBenOleIStorage       LTSGUID(0xFFF8)
#define LTSLID_CBenOleIStream        LTSGUID(0xFFF7)
#define LTSLID_CMCBenOleIStorage     LTSGUID(0xFFF6)
#define LTSLID_CMCBenOleIStream      LTSGUID(0xFFF5)
#define LTSLID_IOleUILtsLinkContainer  LTSGUID(0xFFF4)
#define LTSLID_123WBase              LTSGUID(0x0000)
#define LTSLID_123WNum               1024
#define LTSLID_123WMax               LTSGUID(0x03FF)
#define LTSLID_AmiProBase            LTSGUID(0x0400)
#define LTSLID_AmiProNum             1024
#define LTSLID_AmiProMax             LTSGUID(0x07FF)
#define LTSLID_ApproachBase          LTSGUID(0x0800)
#define LTSLID_ApproachNum           1024
#define LTSLID_ApproachMax           LTSGUID(0x0BFF)
#define LTSLID_FLBase                LTSGUID(0x0c00)
#define LTSLID_FLNum                 1024
#define LTSLID_FLMax                 LTSGUID(0x0FFF)
#define LTSLID_OrgBase               LTSGUID(0x1000)
#define LTSLID_OrgNum                1024
#define LTSLID_OrgMax                LTSGUID(0x13FF)
#define LTSLID_NotesBase             LTSGUID(0x1400)
#define LTSLID_NotesNum              1024
#define LTSLID_NotesMax              LTSGUID(0x17FF)
#define LTSLID_ccMailBase            LTSGUID(0x1800)
#define LTSLID_ccMailNum             1024
#define LTSLID_ccMailMax             LTSGUID(0x1BFF)
#define LTSLID_ChartBase             LTSGUID(0x1C00)
#define LTSLID_ChartNum              1024
#define LTSLID_ChartMax              LTSGUID(0x1FFF)
#define LTSLID_UIMSBase              LTSGUID(0x2000)
#define LTSLID_UIMSNum               1024
#define LTSLID_UIMSMax               LTSGUID(0x23FF)
#define LTSLID_WGLBase               LTSGUID(0x2400)
#define LTSLID_WGLNum                1024
#define LTSLID_WGLMax                LTSGUID(0x27FF)
#define LTSLID_FormsBase             LTSGUID(0x2800)
#define LTSLID_FormsNum              1024
#define LTSLID_FormsMax              LTSGUID(0x2bff)
#define LTSLID_ViPBase               LTSGUID(0x2c00)
#define LTSLID_ViPNum                1024
#define LTSLID_ViPMax                LTSGUID(0x2fff)
#define LTSLID_LOIBase               LTSGUID(0x3000)
#define LTSLID_LOINum                1024
#define LTSLID_LOIMax                LTSGUID(0x33ff)
#define LTSLID_LotusScriptBase       LTSGUID(0x3400)
#define LTSLID_LotusScriptNum        1024
#define LTSLID_LotusScriptMax        LTSGUID(0x37ff)
#define LTSLID_OracleDBLSXBase       LTSGUID(0x3800)
#define LTSLID_OracleDBLSXNum        128
#define LTSLID_OracleDBLSXMax        LTSGUID(0x387f)
#define LTSLID_NotesReadyComponentBase LTSGUID(0x3880)
#define LTSLID_NotesReadyComponentNum  1024
#define LTSLID_NotesReadyComponentMax  LTSGUID(0x3c7f)
#define LTSLID_EdgeComponentBase LTSGUID(0x3c80)
#define LTSLID_EdgeComponentNum  1024
#define LTSLID_EdgeComponentMax  LTSGUID(0x407f)
#define LTSLID_LSXBase LTSGUID(0x4080)
#define LTSLID_LSXNum  16
#define LTSLID_LSXMax  LTSGUID(0x408f)
#if defined( LTSGUID_WIN32 ) && !defined( LTSGUID_OTHER )
#if ! (defined(lint) || defined(_lint) || defined(RC_INVOKED))
#if ( _MSC_VER >= 800 )
#pragma warning(disable:4103)
#if !(defined( MIDL_PASS )) || defined( __midl )
#pragma pack(pop)
#else
#pragma pack()
#endif
#else
#pragma pack()
#endif
#endif
#endif
#endif
