/*******************************************************************************
* FILE NAME: immspeed.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in immspeed.hpp                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
// Priority INT_MIN (-2147483647 - 1) + 1024 + 512
#pragma priority( -2147482112 )
#include <immspeed.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _IMMSPEED_CPP_
  #include <ipagetun.h>
#endif

/*------------------------------------------------------------------------------
| IMMSpeed::IMMSpeed                                                           |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
IMMSpeed::IMMSpeed(IMMSpeed::Format form, unsigned long val)
   : fFormat(form),
     fSpeed(val)
{ }

/*------------------------------------------------------------------------------
| IMMSpeed::IMMSpeed                                                           |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
IMMSpeed::IMMSpeed( const IMMSpeed& copy)          // 7810
   : fFormat(copy.fFormat),
     fSpeed(copy.fSpeed)
{ }

/*------------------------------------------------------------------------------
| IMMSpeed::IMMSpeed                                                           |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
IMMSpeed::IMMSpeed(unsigned long percent)
   : fFormat(IMMSpeed::percentage),
     fSpeed(percent)
{ }

/*------------------------------------------------------------------------------
| IMMSpeed::~IMMSpeed                                                          |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
IMMSpeed::~IMMSpeed()
{ }

/*------------------------------------------------------------------------------
| IMMSpeed::format                                                             |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
IMMSpeed::Format IMMSpeed::format() const
{
  return fFormat;
}

/*------------------------------------------------------------------------------
| IMMSpeed::speed                                                              |
|                                                                              |
|                                                                              |
------------------------------------------------------------------------------*/
unsigned long  IMMSpeed::speed() const
{
  return fSpeed;
}
