/*******************************************************************************
* FILE NAME: DDE4UDLL.CPP                                                      *
*                                                                              *
* DESCRIPTION: Resource stub file for ICLUI DLLs                               *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1996                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <stdio.h>
#ifdef __WINDOWS__
#include <windows.h>
#endif

// function prototypes
extern "C" {
  int  _CRT_init      (void );
  void __ctordtorInit (int);
  void _CRT_term      (void );
  void __ctordtorTerm (int);
  unsigned _TlsWin32s (DWORD ulFlag);
  void _Optlink __IInitTerm(unsigned long ulflag);
  void _Optlink __IInitTermDefault(unsigned long ulflag);
}

void _setProcessDetachInProgress(void);
void _setProcessDetachInProgressDefault(void);

// Segment definitions
#ifdef IC_PAGETUNE
  #define _DDE4UDLL_CPP_
  #include <ipagetun.h>
#endif

#pragma data_seg(ICLNonConst)
#ifdef __WINDOWS__


// Refer to ithread.cpp for definitions and usage of
// setProcessDetachInProgress and IInitTerm functions.

// To avoid unresolved externals during linking, we define
// default functions in dde4dll2 which does nothing, and use #pragma weak
// to reference it if ithread.cpp is not being linked.
#pragma weak( _setProcessDetachInProgress, _setProcessDetachInProgressDefault)
#pragma weak( __IInitTerm, __IInitTermDefault)

#ifndef _WIN32S

  HANDLE        CPPOO_dllHandle;

#endif
#endif

#ifndef __WINDOWS__
  unsigned long CPPOO_dllHandle = 0;
#endif
#pragma data_seg()

#ifdef __WINDOWS__
INT APIENTRY          _DLL_InitTerm(HANDLE hmodule,
                                    DWORD  reasonCalled,
                                    LPVOID reserved )
{
   INT  rc = TRUE;     /* success */
   switch (reasonCalled)
      {
      case  DLL_PROCESS_ATTACH:
#ifdef _WIN32S
         _TlsWin32s(reasonCalled);
#endif
         /*******************************************************************/
         /* The C run-time environment initialization function must be      */
         /* called before any calls to C run-time functions that are not    */
         /* inlined.                                                        */
         /*******************************************************************/
#ifndef _WIN32S
         CPPOO_dllHandle = hmodule; // DLL being loaded
#endif
         if (_CRT_init() == -1)
         {
            rc = FALSE;                 // error
         }
         __IInitTerm( reasonCalled );
         __ctordtorInit(0);

         break;

      case  DLL_PROCESS_DETACH:
         _setProcessDetachInProgress();
         __ctordtorTerm(0);
         __IInitTerm( reasonCalled );
         _CRT_term();
#ifdef _WIN32S
         _TlsWin32s(reasonCalled);
#endif
         break;

      case  DLL_THREAD_ATTACH:
         __IInitTerm( reasonCalled );
         break;

      case  DLL_THREAD_DETACH:
         __IInitTerm( reasonCalled );
         break;

      }
   return rc;
}
#endif

#ifndef __WINDOWS__
unsigned long _System _DLL_InitTerm ( unsigned long hmodule, unsigned long ulFlag )
{
  unsigned long ulRc = 1;         // assume no errors

  if (ulFlag == 0)
  {
     CPPOO_dllHandle = hmodule; // DLL being loaded
     if (_CRT_init() == -1)
     {
        ulRc = 0;                 // error
     }
     __ctordtorInit(0);
  } /* endif */
  else if (ulFlag == 1)
  {                               // DLL being freed

// It appears we should do neither of these at shutdown
// There were problems with Driver 27 when ctordtorTerm() was called
// and _CRT_term() wasn't.
#ifdef IC_STATIC_LINK
     __ctordtorTerm();
     _CRT_term();
#endif
  }
  else
  {
     ulRc = 0;                    // error
  }

  return ulRc;
}
#endif
