/* NOSHIP */
#ifndef _IBMPDATA_INL_
#define _IBMPDATA_INL_ 0
/*******************************************************************************
* FILE NAME: ibmpdata.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ibmpdata.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IBMPDATA_
  #undef  _IBMPDATA_INL_
  #define _IBMPDATA_INL_ 1
  #include <ibmpdata.hpp>
#endif


#if _IBMPDATA_INL_
  #define inline
#endif

inline unsigned long IBitmapData::addRef( )
{
  return (++ulClUseCount);
}

inline unsigned long IBitmapData::removeRef( )
{
  return (--ulClUseCount);
}

inline unsigned long IBitmapData::useCount( ) const
{
  return ulClUseCount;
}

inline unsigned long IBitmapData::id( ) const
{
  return ulClId;
}

inline unsigned long IBitmapData::handle( ) const
{
  return ulClHandle;
}

inline IBitmapData& IBitmapData::setHandle( const unsigned long ulNewHandle )
{
  ulClHandle = ulNewHandle;
  return *this;
}

inline IBitmapData& IBitmapData::setSize( const ISize& newSize )
{
  sizClBitmap = newSize;
  return *this;
}

inline IString IBitmapData::resourceFileName( ) const
{
  return strClFileName;
}

inline ISize IBitmapData::size( ) const
{
  return sizClBitmap;
}

inline Boolean IBitmapData::operator ==(const IBitmapData& bmpData ) const
{
  if( (bmpData.id() == this->id()) &&
      (bmpData.size() == this->size()) &&
      (bmpData.resourceFileName() == this->resourceFileName()) )
       return(1);
  else
       return(0);
}

inline IBitmapData& IBitmapData::setChanged( Boolean changed )
{
  chngd = changed;
  return *this;
}

inline Boolean IBitmapData::changed( ) const
{
  return chngd;
}

#endif // _IBMPDATA_INL_
