/* NOSHIP */
#ifndef _ICCTLSTA_
#define _ICCTLSTA_
/*******************************************************************************
* FILE NAME: icctlsta.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the IControlStatics class, which  *
*   is used to dynamically load the dll for the container, notebook, slider    *
*   and spin button controls.                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ihandle.hpp>

#ifdef IC_WIN
// only needed in Windows

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

typedef unsigned long
     (FAR PASCAL *IS32to16SendMessage)( void *, unsigned int,
                                        unsigned long, unsigned long );
typedef unsigned long
     (FAR PASCAL *IS32to16PostMessage)( void *, unsigned int,
                                        unsigned long, unsigned long );
typedef unsigned long
     (FAR PASCAL *IS16to32Message)( void *, unsigned int *,
                                    unsigned long *, unsigned long * );

class IControlStatics : public IBase
{
public:

static HMODULE
  loadControlDLL        ( );

static HMODULE
  controlDynLinkLib;

static IS32to16SendMessage lpfn32to16SendMessage;
static IS32to16PostMessage lpfn32to16PostMessage;
static IS16to32Message     lpfn16to32Message;
};

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif  // IC_WIN

#endif // _ICCTLSTA_
