/*******************************************************************************
* FILE NAME: icliphdr.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in icliphdr.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#define INCL_WINCLIPBOARD
extern "C" {
   #include <iwindefs.h>
}
#include <icliphdr.hpp>
#include <iclipbrd.hpp>
#include <istring.hpp>
#include <itrace.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICLIPHDR_CPP_
  #include <ipagetun.h>
#endif

#ifdef IC_WIN
  #define WM_RENDERALLFMTS WM_RENDERALLFORMATS
  #define WM_RENDERFMT     WM_RENDERFORMAT
#endif

IClipboardHandler::IClipboardHandler()
{

}

IClipboardHandler::~IClipboardHandler()
{

}

Boolean IClipboardHandler::dispatchHandlerEvent ( IEvent& event )
{
   if (event.eventId() == WM_RENDERALLFMTS)
   {
      ITRACE_DEVELOP("WM_RENDERALLFMTS");
      return renderAllFormats(event);
   }
   else if (event.eventId() == WM_RENDERFMT)
   {
      ITRACE_DEVELOP("WM_RENDERFMT");
      IString format = IClipboard::format(event.parameter1().asUnsignedLong());
      return renderFormat( event, format);
   }
   else if (event.eventId() == WM_DESTROYCLIPBOARD)
   {
      ITRACE_DEVELOP("WM_DESTROYCLIPBOARD");
      return clipboardEmptied(event);
   }
   return false;
}

