#ifndef _ICMDEVT_INL_
#define _ICMDEVT_INL_ 0
/*******************************************************************************
* FILE NAME: icmdevt.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in icmdevt.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ICMDEVT_
  #undef  _ICMDEVT_INL_
  #define _ICMDEVT_INL_ 1
  #include <icmdevt.hpp>
#endif

#if _ICMDEVT_INL_
  #define inline
#endif

// Hack to avoid having to #include <iwindefs.h>
#ifndef WM_SYSCOMMAND
  #define WM_SYSCOMMAND                   0x0112
#endif

inline unsigned long  ICommandEvent :: commandId ( ) const
  {
  // DEFECT 24707 : must remove reserved bytes from the flag,
  //  to correctly return the actual SC_x system command id.
  //  (according to win32 sdk documentation).
     if ( eventId() == WM_SYSCOMMAND )
        return (((unsigned long)parameter1()) & 0xFFF0);
  return parameter1().number1();
  }
inline IBase::Boolean  ICommandEvent :: isFromFrame ( ) const
  {
  return (parameter1().number2() & 0x8000) ? true : false;
  }

#endif /* _ICMDEVT_INL_ */
