/* NOSHIP */
#ifndef _IDMCMDHR_
#define _IDMCMDHR_
/*******************************************************************************
* FILE NAME: idmcmdhdr.hpp                                                     *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMPopUpCommandHandler                                                   *
*     IDMPopUpMenuHandler                                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C"
  {
  #define IUSING_OLE
  #ifdef WIN32_LEAN_AND_MEAN
    #undef WIN32_LEAN_AND_MEAN
  #endif
  #ifdef _OLE2_H_
    #undef _OLE2_H_
  #endif
  #include <iwindefs.h>
  }
#include <ipopmenu.hpp>
#include <imenuhdr.hpp>
#include <icmdhdr.hpp>

#pragma pack(4)

#ifdef IC_WIN

class IDataObject;
class IDMPopUpCommandHandler ;

class IDMPopUpMenuHandler : public IMenuHandler
{
public:
  IDMPopUpMenuHandler(IWindow *) ;
  virtual
    ~IDMPopUpMenuHandler() ;
  IDMPopUpMenuHandler&
     startHandlingEvents() ;
  Boolean
     fNonDefaultDrag;

protected:
  virtual Boolean
     makePopUpMenu(IMenuEvent& menuEvent);
  Boolean
     dispatchHandlerEvent(IEvent& evt);

private:
  IDMPopUpMenuHandler ( const IDMPopUpMenuHandler&);
  IDMPopUpMenuHandler& operator=( const IDMPopUpMenuHandler&);
  IWindow
     *pWindowToHandle ;
};

class IDMPopUpCommandHandler : public ICommandHandler
{
public:
  IDMPopUpCommandHandler( IWindow* ) ;
  virtual
     ~IDMPopUpCommandHandler() ;
  IDMPopUpCommandHandler&
     startHandlingEvents() ;
  void setPoint(POINTL pt);
  void setDataObject(IDataObject* dataObj);
protected:
virtual Boolean
  command(ICommandEvent& cmdEvent);
private:
  IDMPopUpCommandHandler ( const IDMPopUpCommandHandler&);
  IDMPopUpCommandHandler& operator=( const IDMPopUpCommandHandler&);

  POINTL point;
  IDataObject* dataObject;
  IWindow
     *pWindowToHandle ;
};

#endif /* IC_WIN */

#pragma pack()

#endif //_IDMCMDHR_
