/* NOSHIP */
#ifndef _IDMOIPRV_
#define _IDMOIPRV_
/*******************************************************************************
* FILE NAME: idmoiprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private              *
*   to the implementation of idmdptgh.hpp                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ikeyset.h>

//class IThreadId;

class IDMThreadIdElement
  {
  public:
  IDMThreadIdElement( unsigned long   threadId,
                      int             refCount );

  ~IDMThreadIdElement( );

  unsigned long threadIdKey;
  int refCount;

private:

  IDMThreadIdElement( const IDMThreadIdElement& );
  IDMThreadIdElement
    &operator =     ( const IDMThreadIdElement& );
  };

inline unsigned long const& key (IDMThreadIdElement* const& k)
  {
  return k->threadIdKey;
  }

class IDMThreadIdSet : public IKeySet < IDMThreadIdElement*, unsigned long >
  {
  public:
    IDMThreadIdSet() ;
    ~IDMThreadIdSet();
  };
#endif

