/* NOSHIP */
#ifndef _IFILDPRV_
#define _IFILDPRV_
/*******************************************************************************
* FILE NAME: ifildprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IFileDialogSettingsData                                                  *
*     IFileDialogData                                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandle.hpp>
#ifndef IC_MOTIF
#include <iqueue.h>
#endif
#include <itrace.hpp>
#ifdef IC_WIN
#include <icolor.hpp>
#endif // IC_WIN

class IHandler;
class IString;

#pragma pack(4)

#ifndef IC_MOTIF
// StringSeq class is used to maintain sequences of IStrings
// needed for Drives and Types lists.
class StringSeq : public IQueue<IString*> {
public:
  StringSeq ( );
 ~StringSeq ( );
}; // StringSeq
#endif

/*******************************************************************************
|  Objects of IFileDialogSettingsData contain the private data for Settings    |
*******************************************************************************/
class IFileDialogSettingsData : public IBase {
typedef IBase
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogSettingsData ( );
  ~IFileDialogSettingsData ( );

#ifndef IC_MOTIF
StringSeq
 *fileTypes,
 *drives;

unsigned long
  dlgId;

IModuleHandle
  dlgHandle;

#ifdef IC_WIN
Boolean
  isDirectorySet;
IString
  fDirectory;
#endif

Boolean
  isDlgTemplateSet;
#endif
}; // IFileDialogSettingsData


/*******************************************************************************
|  Objects of IFileDialogData contain the private data for the IFileDialog     |
|  class.                                                                      |
*******************************************************************************/
class IFileDialogData : public IBase {
typedef IBase
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogData ( );
  ~IFileDialogData ( );

#ifdef IC_PMWIN
IHandler
 *handlerToAdd;
#endif
#ifdef IC_WIN
long
  fSRC,
  fReturnVal;

char
 *fTitle,
 *fDrive;

IString
  fOKButton;

IPoint
  fPosition;

unsigned long
  fDialogId,
  fSettingsChanged;

IColor
  fclrbackground;

HBRUSH
  fbkgrndbrush;
#endif  // IC_WIN
}; // IFileDialogData

#pragma pack()

#endif /* _IFILDPRV_ */

