/* NOSHIP */
#ifndef _INOTEHDR_
#define _INOTEHDR_
/*******************************************************************************
* FILE NAME: inotehdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     INotebookHandler                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>

//------------------------------------------------------
// DEFECT 23265 (cloned from PORTAPAK)
//------------------------------------------------------
#ifdef IC_PMWIN               
  #include <ikeyevt.hpp>
#endif // IC_PMWIN
//------------------------------------------------------

#pragma pack(4)

class INotebook;

class INotebookHandler : public IHandler {
typedef IHandler
  Inherited;
public:
  INotebookHandler ( );
virtual
  ~INotebookHandler ( );

#ifdef IC_MOTIF
virtual INotebookHandler
  &handleEventsFor       ( INotebook* notebook ),
  &stopHandlingEventsFor ( INotebook* notebook );
#endif // IC_MOTIF

protected:
/*-------------------------------- Overrides ---------------------------------*/
virtual Boolean
  dispatchHandlerEvent ( IEvent &anEvent );

private:
/*--------------------------------- Private ----------------------------------*/
#ifdef IC_MOTIF
virtual IHandler
  &handleEventsFor       ( IWindow* window  ),
  &stopHandlingEventsFor ( IWindow* window  );
#endif // IC_MOTIF

//------------------------------------------------------
// DEFECT 23265 (cloned from PORTAPAK)
//------------------------------------------------------
#ifdef IC_WIN              // had to be VIRTUAL !!!!!!
virtual Boolean
  handleTab  (IKeyboardEvent& event),
  gotFocus   (IEvent&         event);
#endif // IC_WIN
//------------------------------------------------------

}; // INotebookHandler


#ifdef IC_MOTIF
class INotebookStatics : public IBase {
typedef IBase
  Inherited;
/*******************************************************************************
* This class manages the lifetime of the static notebook handler. An object of *
* this class is constructed during static object initialization.  The handler  *
* object is constructed only if needed, and is deleted at termination of the   *
* application.                                                                 *
*******************************************************************************/
public:
/*-------------------------- Constructor/Destructor ----------------------------
| The only way to construct instances of this class is to use the default      |
| constructor, which does not take any arguments.                              |
------------------------------------------------------------------------------*/
 ~INotebookStatics      ( );

/*-------------------------------- Accessors -----------------------------------
| This function is used to access the static notebook handler. This allows one |
| object to be constructed when needed, and shared by all notebooks.           |
|   notebookHandler   - Returns the notebook handler.                          |
------------------------------------------------------------------------------*/
static INotebookHandler
 &notebookHandler       ( );

private:
/*--------------------------------- Private ----------------------------------*/
static INotebookHandler
 *pClNotebookHandler;
}; // class INotebookStatics
#endif // IC_MOTIF

#pragma pack()

#endif // _INOTEHDR_
