/* NOSHIP */
#ifndef _IRESSTAT_
#define _IRESSTAT_
/*******************************************************************************
* FILE NAME: iresstat.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declarations of the classes:                                               *
*     IResourceLibrary                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

#ifdef IC_MOTIF
  #include <istring.hpp>
#endif

class IPointerSet;
class IBitmapSet;
class IDLLSet;
class IResourceLibrary;
class IPrivateResource;

#pragma pack(4)

class IResLibStaticPtr {
public:
  ~IResLibStaticPtr ( );

static void
  deletePointerSet ( ),
  deleteBitmapSet  ( );

#ifndef IC_MOTIF
static void
  deleteDLLSet     ( );
#endif

static IPointerSet
 &pointerSet();
static IBitmapSet
 &bitmapSet();

#ifndef IC_MOTIF
static IDLLSet
 &dllSet();
#endif

static IResourceLibrary
 &defaultResource();
static IPrivateResource
 &libraryKey();

static IPointerSet
 *pPtrSet;
static IBitmapSet
 *pBmpSet;

#ifndef IC_MOTIF
static IDLLSet
 *pDLLSet;
#endif

static IResourceLibrary
 *pResDefault;
static IPrivateResource
 *pLibKey;
};

#ifdef IC_MOTIF
class IResLibPrivateData {
public:
  IResLibPrivateData();
  ~IResLibPrivateData();

char
 *getAppRes(unsigned long id,
                  char* preamble,
                  IBase::Boolean throwException = true);
void
  mergeOverrideResources(const char *resourceFile);
};
#endif

#pragma pack()

#endif // _IRESSTAT_
