/* NOSHIP */
#ifndef _ITEMID_
#define _ITEMID_
/*******************************************************************************
* FILE NAME: itemid.hpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     Itemid                                                                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>
#include <ihandle.hpp>

struct _ITEMIDLIST;
class IShellFolder;
class IMalloc;

class ItemID
{
  public:
    ItemID( struct _ITEMIDLIST *existingItem );
    ItemID( unsigned int cbSize );
    ItemID( const ItemID &other );
    ItemID( );
    virtual
     ~ItemID();

    ItemID
     &operator=  ( const ItemID& other ),
     &operator+= ( const ItemID& nextItem );

    ItemID
     &setToFirst(),
     &setToLast(),
     &setToNext( );

    ItemID
      current();
    Boolean
      currentIsValid();

    unsigned int
      size( ) const;

    ItemID
      concatItemIDs( ItemID &pidl );

    IString
      name( IShellFolder *lpsf, unsigned long dwFlags ),
      nameFromDesktop( );

    ItemID
      fullyQualifiedPidl(IShellFolder *lpsf);

    long /*HRESULT*/
      attributes( IShellFolder *lpsf, int itemNumber, unsigned long &ulAttr );

    struct _ITEMIDLIST *
      asLPITEMIDLIST();

    static ItemID
      itemIDFromDisplayName( const IString& displayName );

    IString
      fullyQualifiedName( );

    IPointerHandle
      ItemID::itemIcon( Boolean openIcon = false );

    IString
      itemType( );

  private:
    struct _ITEMIDLIST
      *thePidl,
      *currentPidl;
    IMalloc *lpMalloc;
};
#endif
